#include "pch.h"

struct tagMon {
	HMONITOR hMon;
	RECT rcMon;
	BOOL bPrimary;
} arMon[10];
int MonCount;
int NowMon = 0;

BOOL CALLBACK MonitorEnumProc(HMONITOR hMonitor, HDC hdcMonitor, LPRECT lprcMonitor, LPARAM dwData)
{
	MONITORINFOEX mi;

	arMon[MonCount].hMon = hMonitor;
	arMon[MonCount].rcMon = *lprcMonitor;
	mi.cbSize = sizeof(MONITORINFOEX);
	GetMonitorInfo(hMonitor, &mi);
	arMon[MonCount].bPrimary = (mi.dwFlags & MONITORINFOF_PRIMARY);
	MonCount++;
	return TRUE;
}

// API  ״  .     
LRESULT CALLBACK LCDTest_WndProc(HWND hWnd, UINT iMessage, WPARAM wParam, LPARAM lParam)
{
	HDC hdc;
	PAINTSTRUCT ps;
	HBRUSH hBrush;
	RECT crt;
	LPCTSTR Mes = TEXT("LCD ׽Ʈ α׷\r\n Ŭ, ̽: ,  Ŭ, M: ̵\r\n")
		TEXT("Esc:,Enter:ȳ ڿ RGBWK:  ");
	int sx, sy;
	static int idx = 2;
	static COLORREF col[] = { RGB(255,0,0),RGB(0,255,0),RGB(0,0,255),
		RGB(255,255,255),RGB(0,0,0) };
	static bool displayText = true;

	switch (iMessage) {
	case WM_CREATE:
		// ִ ũ Ȯ
		sx = GetSystemMetrics(SM_CXSCREEN);
		sy = GetSystemMetrics(SM_CYSCREEN);
		MoveWindow(hWnd, 0, 0, sx, sy, TRUE);
		return 0;
	case WM_LBUTTONDOWN:
		SendMessage(hWnd, WM_USER + 1, 0, 0);
		return 0;
	case WM_RBUTTONDOWN:
		SendMessage(hWnd, WM_USER + 2, 0, 0);
	case WM_USER + 1:
		idx = idx == Count(col) - 1 ? 0 : idx + 1;
		InvalidateRect(hWnd, NULL, FALSE);
		return 0;
	case WM_USER + 2:
		if (GetSystemMetrics(SM_CMONITORS) > 1) {
			MonCount = 0;
			EnumDisplayMonitors(NULL, NULL, MonitorEnumProc, (LPARAM)NULL);
			if (MonCount > 1) {
				NowMon = (NowMon == MonCount - 1 ? 0 : NowMon + 1);
				MoveWindow(hWnd, arMon[NowMon].rcMon.left, arMon[NowMon].rcMon.top,
					arMon[NowMon].rcMon.right - arMon[NowMon].rcMon.left,
					arMon[NowMon].rcMon.bottom - arMon[NowMon].rcMon.top, TRUE);
			}
		}
		return 0;
	case WM_KEYDOWN:
		switch (wParam) {
		case VK_SPACE:
			SendMessage(hWnd, WM_USER + 1, 0, 0);
			break;
		case VK_ESCAPE:
			DestroyWindow(hWnd);
			break;
		case VK_RETURN:
			displayText = !displayText;
			InvalidateRect(hWnd, NULL, FALSE);
			break;
		case 'R':
			idx = 0;
			InvalidateRect(hWnd, NULL, FALSE);
			break;
		case 'G':
			idx = 1;
			InvalidateRect(hWnd, NULL, FALSE);
			break;
		case 'B':
			idx = 2;
			InvalidateRect(hWnd, NULL, FALSE);
			break;
		case 'W':
			idx = 3;
			InvalidateRect(hWnd, NULL, FALSE);
			break;
		case 'K':
			idx = 4;
			InvalidateRect(hWnd, NULL, FALSE);
			break;
		case 'M':
			SendMessage(hWnd, WM_USER + 2, 0, 0);
			break;
		}
		return 0;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		hBrush = CreateSolidBrush(col[idx]);
		GetClientRect(hWnd, &crt);
		FillRect(hdc, &crt, hBrush);
		DeleteObject(hBrush);

		if (displayText) {
			if (idx == 4) {
				SetTextColor(hdc, RGB(255, 255, 255));
			}
			SetBkMode(hdc, TRANSPARENT);
			crt.top = crt.bottom / 2;
			DrawText(hdc, Mes, -1, &crt, DT_CENTER);
		}
		EndPaint(hWnd, &ps);
		return 0;
	case WM_DESTROY:
		return 0;
	}
	return(DefWindowProc(hWnd, iMessage, wParam, lParam));
}

LRESULT CALLBACK SizeMeter_WndProc(HWND hWnd, UINT iMessage, WPARAM wParam, LPARAM lParam)
{
	HDC hdc;
	PAINTSTRUCT ps;
	TCHAR str[111];
	RECT crt;
	int w, h;

	switch (iMessage) {
	case WM_CREATE:
		return 0;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		GetClientRect(hWnd, &crt);
		wsprintf(str, TEXT("%d x %d"), crt.right, crt.bottom);
		SetBkMode(hdc, TRANSPARENT);
		SetTextAlign(hdc, TA_CENTER);
		// DrawText(hdc, str, -1, &crt, DT_CENTER | DT_VCENTER);
		TextOut(hdc, crt.right / 2, crt.bottom / 2, str, lstrlen(str));
		lstrcpy(str, TEXT("1 ~ 9 : ǥ ũ"));
		TextOut(hdc, crt.right / 2, crt.bottom / 2 + 30, str, lstrlen(str));
		EndPaint(hWnd, &ps);
		return 0;
	case WM_SIZE:
		InvalidateRect(hWnd, NULL, TRUE);
		return 0;
	case WM_KEYDOWN:
		w = 0;
		switch (wParam) {
		case '1':
			w = 320;
			h = 240;
			break;
		case '2':
			w = 640;
			h = 480;
			break;
		case '3':
			w = 800;
			h = 600;
			break;
		case '4':
			w = 1024;
			h = 768;
			break;
		case '5':
			w = 1280;
			h = 1024;
			break;
		case '6':
			w = 1600;
			h = 1200;
			break;
		case '7':
			w = 1920;
			h = 1080;
			break;
		case '8':
			w = 2560;
			h = 1440;
			break;
		case '9':
			w = 3840;
			h = 2160;
			break;
		}
		if (w != 0)
		{
			SetRect(&crt, 0, 0, w, h);
			DWORD Style = GetWindowLong(hWnd, GWL_STYLE);
			DWORD ExStyle = GetWindowLong(hWnd, GWL_EXSTYLE);

			AdjustWindowRectEx(&crt, Style, GetMenu(hWnd) != NULL, ExStyle);
			SetWindowPos(hWnd, NULL, 0, 0, crt.right - crt.left, crt.bottom - crt.top,
				SWP_NOMOVE | SWP_NOZORDER);
		}
		return 0;
	case WM_DESTROY:
		return 0;
	}
	return(DefWindowProc(hWnd, iMessage, wParam, lParam));
}

LRESULT CMoveCursor::OnCreate(WPARAM wParam, LPARAM lParam) {
	bitOn = LoadBitmap(g_hInst, MAKEINTRESOURCE(IDB_CURSORON));
	bitOff = LoadBitmap(g_hInst, MAKEINTRESOURCE(IDB_CURSOROFF));

	// INI Ͽ ɼ о. Ʈ false. 
	bCursorMove = setting.get(dget_id, L"moveCursor", 0);
	CursorInterval = 180;
	// Ÿ̸Ӵ ̵ֱ 1/10 ڵ Ѵ. 180ʸ 18ʿ ѹ Ȯϸ ϴ.
	//  ɼ µ ڰ ̷    ʿ . 
	TimerInterval = CursorInterval * 100;
	CursorKeepSec = 0;
	RejectCount = 0;
	if (bCursorMove) {
		SetTimer(win_hWnd, 1, TimerInterval, NULL);
	}
	return 0;
}

LRESULT CMoveCursor::OnDestroy(WPARAM wParam, LPARAM lParam) {
	setting.set(dget_id, L"moveCursor", bCursorMove);
	DeleteObject(bitOn);
	DeleteObject(bitOff);
	KillTimer(win_hWnd, 1);
	return 0;
}

void CMoveCursor::OnDraw(HDC hdc, RECT crt)
{
	// todo : Ʈ   Ŀ ̴  ׷ ִϸ̼. Ÿ̸ ֱ   ª ̰.
	// Ƽ  ̸   糳  Ͽ ϴ 
	if (bCursorMove) {
		DrawBitmap(hdc, 0, 0, bitOn);
	} else {
		DrawBitmap(hdc, 0, 0, bitOff);
	}
}

void CMoveCursor::OnClick()
{
	bCursorMove = !bCursorMove;
	if (bCursorMove) {
		KillTimer(win_hWnd, 1);
	} else {
		SetTimer(win_hWnd, 1, TimerInterval, NULL);
	}
	InvalidateRect(win_hWnd, NULL, FALSE);
}

LRESULT CMoveCursor::OnTimer(WPARAM wParam, LPARAM lParam)
{
	POINT pt;

	GetCursorPos(&pt);
	//  ڸ ִ  ð  
	if (pt.x == OldCursorPt.x && pt.y == OldCursorPt.y) {
		CursorKeepSec += TimerInterval / 1000;
		// ũ ̹  ð Ǹ  Ŀ ĭ  ű 
		if (CursorKeepSec >= CursorInterval) {
			CursorKeepSec = 0;
			mouse_event(MOUSEEVENTF_MOVE, 1, 0, 0, 0);
			RejectCount++;
		}
		// ġ ٲ  ð  
	} else {
		CursorKeepSec = 0;
		OldCursorPt = pt;
	}
	return 0;
}

INT_PTR CALLBACK MoveCursorDlgProc(HWND hDlg, UINT iMessage, WPARAM wParam, LPARAM lParam)
{
	static CMoveCursor* pWidget;
	TCHAR str[128];

	switch (iMessage) {
	case WM_INITDIALOG:
		pWidget = (CMoveCursor*)lParam;
		MovePopupToSide(hDlg, trayWindow.win_x, trayWindow.win_y);

		//  ݴ   , Ʒ ̴. 
		SendDlgItemMessage(hDlg, IDC_SPINMOVECURSORCYCLE, UDM_SETRANGE, 0, MAKELPARAM(600, 60));

		wsprintf(str, L"̵ Ƚ : %d", pWidget->RejectCount);
		SetDlgItemText(hDlg, IDC_STMOVECURSORCOUNT, str);
		if (pWidget->bCursorMove) {
			CheckDlgButton(hDlg, IDC_CHKMOVECURSOR, BST_CHECKED);
		}
		SetDlgItemInt(hDlg, IDC_EDMOVECURSORCYCLE, pWidget->CursorInterval, FALSE);
		return TRUE;
	case WM_NCACTIVATE:
		if (wParam == FALSE && hOptionPopup != NULL) {
			pWidget->CursorInterval = GetDlgItemInt(hDlg, IDC_EDMOVECURSORCYCLE, NULL, FALSE);
			pWidget->TimerInterval = pWidget->CursorInterval * 100;
			if (IsDlgButtonChecked(hDlg, IDC_CHKMOVECURSOR) == BST_CHECKED) {
				pWidget->bCursorMove = true;
				SetTimer(pWidget->win_hWnd, 1, pWidget->TimerInterval, NULL);
			} else {
				pWidget->bCursorMove = false;
				KillTimer(pWidget->win_hWnd, 1);
			}

			hOptionPopup = NULL;
			DestroyWindow(hDlg);
		}
		return TRUE;
	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDCANCEL:
			hOptionPopup = NULL;
			DestroyWindow(hDlg);
			return TRUE;
		}
		break;
	}
	return FALSE;
}

LRESULT CMoveCursor::OnContextMenu(WPARAM wParam, LPARAM lParam)
{
	if (!IsWindow(hOptionPopup)) {
		hOptionPopup = CreateDialogParam(g_hInst, MAKEINTRESOURCE(IDD_MOVECURSOR),
			win_hWnd, MoveCursorDlgProc, (LPARAM)this);
		ShowWindow(hOptionPopup, SW_SHOW);
	}
	return 0;
}

LRESULT CTextClip::OnMessage(UINT iMessage, WPARAM wParam, LPARAM lParam) {
	switch (iMessage)
	{
	case WM_HOTKEY:
		ClipboardTextOnly();
		return 0;
	}

	return CWindow::OnMessage(iMessage, wParam, lParam);
}

LRESULT CTextClip::OnCreate(WPARAM wParam, LPARAM lParam)
{
	bitOn = LoadBitmap(g_hInst, MAKEINTRESOURCE(IDB_CLIPTEXTON));
	bitOff = LoadBitmap(g_hInst, MAKEINTRESOURCE(IDB_CLIPTEXTOFF));

	bClipToText = setting.get(dget_id, L"ClipToText", 0);
	clipCount = 0;

	if (bClipToText) {
		RegisterHotKey(win_hWnd, 0, MOD_SHIFT | MOD_CONTROL, 'C');
	}

	return 0;
}

LRESULT CTextClip::OnDestroy(WPARAM wParam, LPARAM lParam)
{
	setting.set(dget_id, L"ClipToText", bClipToText);
	DeleteObject(bitOn);
	DeleteObject(bitOff);
	UnregisterHotKey(win_hWnd, 0);
	return 0;
}

void CTextClip::OnDraw(HDC hdc, RECT crt)
{
	if (bClipToText) {
		DrawBitmap(hdc, 0, 0, bitOn);
	} else {
		DrawBitmap(hdc, 0, 0, bitOff);
	}
}

void CTextClip::OnClick()
{
	bClipToText = !bClipToText;
	if (bClipToText) {
		RegisterHotKey(win_hWnd, 0, MOD_SHIFT | MOD_CONTROL, 'C');
	} else {
		UnregisterHotKey(win_hWnd, 0);
	}
	InvalidateRect(win_hWnd, NULL, FALSE);
}

// ؽƮ 
void CTextClip::ClipboardTextOnly()
{
	HGLOBAL hmem;
	UINT Format = 0;
	BOOL bOther = FALSE;
	wchar_t* p, * p2;
	int len;

	// ϴ ؽƮ  ־ Ѵ.
	if (!IsClipboardFormatAvailable(CF_UNICODETEXT)) {
		return;
	}

	// ؽƮܿ ٸ ˵  ־ Ѵ.
	OpenClipboard(mainWindow.win_hWnd);
	for (;;) {
		Format = EnumClipboardFormats(Format);
		if (Format == 0) break;
		if (Format != CF_TEXT && Format != CF_OEMTEXT &&
			Format != CF_UNICODETEXT && Format != CF_LOCALE) {
			bOther = TRUE;
			break;
		}
	}
	CloseClipboard();

	// ؽƮ ִٸ ȯ ʿ䰡 .
	if (bOther == FALSE) {
		return;
	}

	OpenClipboard(mainWindow.win_hWnd);
	hmem = GetClipboardData(CF_UNICODETEXT);
	p = (wchar_t*)GlobalLock(hmem);
	p2 = (wchar_t*)calloc(lstrlenW(p) + 1, sizeof(wchar_t));
	lstrcpyW(p2, p);
	GlobalUnlock(hmem);
	CloseClipboard();

	len = (lstrlenW(p2) + 1) * sizeof(wchar_t);
	hmem = GlobalAlloc(GHND, len);
	p = (wchar_t*)GlobalLock(hmem);
	memcpy(p, p2, len);
	GlobalUnlock(hmem);
	free(p2);
	if (OpenClipboard(mainWindow.win_hWnd)) {
		EmptyClipboard();
		SetClipboardData(CF_UNICODETEXT, hmem);
		CloseClipboard();
	}

	clipCount++;
}

//   ȣ   д. ׷    ִ. 
LRESULT COneImage::OnUser1(WPARAM wParam, LPARAM lParam)
{
	pViewer = NULL;
	return 0;
}

LRESULT COneImage::OnCreate(WPARAM wParam, LPARAM lParam)
{
	setting.get(dget_id, L"imagePath", L"", imagePath, MAX_PATH);
	if (lstrlen(imagePath) != 0) {
		nowImage = Image::FromFile(imagePath);
		FixImageOrientation(nowImage);
	}
	hOneImage = LoadBitmap(g_hInst, MAKEINTRESOURCE(IDB_ONEIMAGE));

	return 0;
}

LRESULT COneImage::OnDestroy(WPARAM wParam, LPARAM lParam)
{
	DeleteObject(hOneImage);
	if (nowImage != NULL) {
		delete nowImage;
	}
	if (pViewer != NULL) {
		DestroyWindow(pViewer->win_hWnd);
	}

	return 0;
}

void COneImage::OnDraw(HDC hdc, RECT crt)
{
	if (nowImage == NULL) {
		DrawBitmap(hdc, 0, 0, hOneImage);
	} else {
		DrawImageCenter(hdc, nowImage, 24, 24, true, win_backBrush);
	}
}

void COneImage::OnClick()
{
	if (nowImage != NULL) {
		//  .
		if (pViewer == NULL) {
			pViewer = new CImageViewer();
			lstrcpy(pViewer->imagePath, imagePath);
			pViewer->Create(1, this);
		}
	}
}

// todo : ɼ ȭڸ      ư ġѴ.
// ̰ ϱ  Ŀ Ҿ ɼâ  ʵ å ؾ Ѵ. 
LRESULT COneImage::OnContextMenu(WPARAM wParam, LPARAM lParam)
{
	OPENFILENAME OFN;
	lstrcpy(imagePath, L"");
	memset(&OFN, 0, sizeof(OPENFILENAME));
	OFN.lStructSize = sizeof(OPENFILENAME);
	OFN.hwndOwner = win_hWnd;
	OFN.lpstrFilter = TEXT("̹ (jpg, png)\0*.jpg;*.png\0");
	OFN.lpstrFile = imagePath;
	OFN.nMaxFile = MAX_PATH;
	if (GetOpenFileName(&OFN) == 0) return 0;

	// ̹ Ǵ  Ѵ. 
	setting.set(dget_id, L"imagePath", imagePath);
	nowImage = Image::FromFile(imagePath);
	FixImageOrientation(nowImage);
	InvalidateRect(win_hWnd, NULL, TRUE);

	return 0;
}

LRESULT CTetris::OnCreate(WPARAM wParam, LPARAM lParam)
{
	hBitmap = LoadBitmap(g_hInst, MAKEINTRESOURCE(IDB_TETRIS));
	return 0;
}

LRESULT CTetris::OnDestroy(WPARAM wParam, LPARAM lParam)
{
	DeleteObject(hBitmap);
	return 0;
}

void CTetris::OnDraw(HDC hdc, RECT crt)
{
	DrawBitmap(hdc, 0, 0, hBitmap);
}

void CTetris::OnClick() { 
	//  츦 Ͽ . 
	CTetrisGame* pGame;
	pGame = new CTetrisGame();
	pGame->Create();
}

// Ŭȿ ʱȭ 迭 ϴ  𸣰. C   . 
struct TetPoint {
	int x, y;
};
TetPoint Shape[][4][4] = {
	{ {0,0,1,0,2,0,-1,0}, {0,0,0,1,0,-1,0,-2}, {0,0,1,0,2,0,-1,0}, {0,0,0,1,0,-1,0,-2} },
	{ {0,0,1,0,0,1,1,1}, {0,0,1,0,0,1,1,1}, {0,0,1,0,0,1,1,1}, {0,0,1,0,0,1,1,1} },
	{ {0,0,-1,0,0,-1,1,-1}, {0,0,0,1,-1,0,-1,-1}, {0,0,-1,0,0,-1,1,-1}, {0,0,0,1,-1,0,-1,-1} },
	{ {0,0,-1,-1,0,-1,1,0}, {0,0,-1,0,-1,1,0,-1}, {0,0,-1,-1,0,-1,1,0}, {0,0,-1,0,-1,1,0,-1} },
	{ {0,0,-1,0,1,0,-1,-1}, {0,0,0,-1,0,1,-1,1}, {0,0,-1,0,1,0,1,1}, {0,0,0,-1,0,1,1,-1} },
	{ {0,0,1,0,-1,0,1,-1}, {0,0,0,1,0,-1,-1,-1}, {0,0,1,0,-1,0,-1,1}, {0,0,0,-1,0,1,1,1} },
};

void CTetrisGame::Create()
{
	CreateWindow(TEXT("CWindow"), L"Tetris", WS_OVERLAPPED | WS_SYSMENU | WS_BORDER | WS_CAPTION | WS_VISIBLE,
		10, 10, 100, 100,
		NULL, (HMENU)NULL, g_hInst, this);
}

LRESULT CTetrisGame::OnCreate(WPARAM wParam, LPARAM lParam)
{
	GameStatus = GAMEOVER;
	srand(GetTickCount());
	AdjustMainWindow();

	//    . 
	MovePopupToSide(win_hWnd, mainWindow.win_x, mainWindow.win_y);

	// 0 ĭ, 1~6 . 7 
	COLORREF arTileColor[] = { 0, 0xff0000, 0x00ff00, 0x0000ff, 0xffff00, 0xff00ff, 0x00ffff, 0x000000 };
	for (int i = 1; i <= 7; i++) {
		arBrush[i] = CreateSolidBrush(arTileColor[i]);
	}

	return 0;
}

LRESULT CTetrisGame::OnDestroy(WPARAM wParam, LPARAM lParam)
{
	for (int i = 1; i <= 7; i++) {
		DeleteObject(arBrush[i]);
	}
	return 0;
}

LRESULT CTetrisGame::OnTimer(WPARAM wParam, LPARAM lParam)
{
	if (MoveDown() == TRUE) {
		MakeNewBrick();
	}
	return 0;
}

void CTetrisGame::OnDraw(HDC hdc, RECT crt)
{
	int x, y, i;
	TCHAR str[128];

	FillRect(hdc, &crt, (HBRUSH)GetStockObject(LTGRAY_BRUSH));

	// ׵θ ׸
	for (x = 0; x < bw + 1; x++) {
		PrintTile(hdc, x, 0, WALL);
		PrintTile(hdc, x, bh + 1, WALL);
	}
	for (y = 0; y < bh + 2; y++) {
		PrintTile(hdc, 0, y, WALL);
		PrintTile(hdc, bw + 1, y, WALL);
	}

	//  ׸
	for (x = 1; x < bw + 1; x++) {
		for (y = 1; y < bh + 1; y++) {
			PrintTile(hdc, x, y, board[x][y]);
		}
	}

	// ̵  ׸
	if (GameStatus != GAMEOVER && brick != -1) {
		for (i = 0; i < 4; i++) {
			PrintTile(hdc, nx + Shape[brick][rot][i].x, ny + Shape[brick][rot][i].y, brick + 1);
		}
	}

	//   ׸
	for (x = bw + 3; x <= bw + 11; x++) {
		for (y = bh - 5; y <= bh + 1; y++) {
			if (x == bw + 3 || x == bw + 11 || y == bh - 5 || y == bh + 1) {
				PrintTile(hdc, x, y, WALL);
			} else {
				PrintTile(hdc, x, y, 0);
			}
		}
	}
	if (GameStatus != GAMEOVER) {
		for (i = 0; i < 4; i++) {
			PrintTile(hdc, bw + 7 + Shape[nbrick][0][i].x, bh - 2 + Shape[nbrick][0][i].y, nbrick + 1);
		}
	}

	//  
	HFONT oldFont;
	oldFont = (HFONT)SelectObject(hdc, mainFont);
	SetBkMode(hdc, TRANSPARENT);
	lstrcpy(str, TEXT("1~9: ũ"));
	TextOut(hdc, (bw + 4) * ts, 30, str, lstrlen(str));
	lstrcpy(str, TEXT("Enter:/"));
	TextOut(hdc, (bw + 4) * ts, 60, str, lstrlen(str));
	wsprintf(str, TEXT(" : %d   "), score);
	TextOut(hdc, (bw + 4) * ts, 90, str, lstrlen(str));
	wsprintf(str, TEXT(" : %d    "), bricknum);
	TextOut(hdc, (bw + 4) * ts, 120, str, lstrlen(str));
	SelectObject(hdc, oldFont);
}

LRESULT CTetrisGame::OnKeyDown(WPARAM wParam, LPARAM lParam)
{
	int x, y;
	int trot;

	//   ο  ϴ Ű
	if (wParam == VK_RETURN) {
		if (GameStatus == GAMEOVER) {
			for (x = 0; x < bw + 2; x++) {
				for (y = 0; y < bh + 2; y++) {
					board[x][y] = (y == 0 || y == bh + 1 || x == 0 || x == bw + 1) ? WALL : EMPTY;
				}
			}
			score = 0;
			bricknum = 0;
			GameStatus = RUNNING;
			nbrick = random(sizeof(Shape) / sizeof(Shape[0]));
			MakeNewBrick();
			Interval = 1000;
			SetTimer(win_hWnd, 1, Interval, NULL);
		} else if (GameStatus == RUNNING) {
			GameStatus = PAUSE;
			KillTimer(win_hWnd, 1);
		} else if (GameStatus == PAUSE) {
			GameStatus = RUNNING;
			SetTimer(win_hWnd, 1, Interval, NULL);
		}
	}

	//  ũ   ٲ  ִ. 
	if (GameStatus == GAMEOVER && wParam >= '1' && wParam <= '9') {
		switch (wParam) {
		case '1':
			bw = 8; bh = 16; ts = 32;
			break;
		case '2':	// Ʈ
			bw = 10; bh = 20; ts = 24;
			break;
		case '3':
			bw = 12; bh = 24; ts = 40;
			break;
		case '4':
			bw = 15; bh = 30; ts = 28;
			break;
		case '5':	// FHD ִ ũ
			bw = 200; bh = 100; ts = 8;
			break;
		case '6':
			bw = 20; bh = 40; ts = 32;
			break;
		case '7':
			bw = 50; bh = 100; ts = 16;
			break;
		case '8':
			bw = 200; bh = 100; ts = 16;
			break;
		case '9':	// 4k ִ ũ
			bw = 400; bh = 200; ts = 8;
			break;
		}
		// ǿ ϴ   Ѵ. 
		memset(board, 0, sizeof(board));
		AdjustMainWindow();
		return 0;
	}

	//  Ű  ߿   . 
	if (GameStatus != RUNNING || brick == -1) {
		return 0;
	}

	switch (wParam) {
	case VK_LEFT:
		if (GetAround(nx - 1, ny, brick, rot) == EMPTY) {
			nx--;
			InvalidateRect(win_hWnd, NULL, FALSE);
		}
		break;
	case VK_RIGHT:
		if (GetAround(nx + 1, ny, brick, rot) == EMPTY) {
			nx++;
			InvalidateRect(win_hWnd, NULL, FALSE);
		}
		break;
	case VK_UP:
		trot = (rot == 3 ? 0 : rot + 1);
		if (GetAround(nx, ny, brick, trot) == EMPTY) {
			rot = trot;
			InvalidateRect(win_hWnd, NULL, FALSE);
		}
		break;
	case VK_DOWN:
		if (MoveDown() == TRUE) {
			MakeNewBrick();
		}
		break;
	case VK_SPACE:
		while (MoveDown() == FALSE) { ; }
		MakeNewBrick();
		break;
	}

	return 0;
}

void CTetrisGame::MakeNewBrick()
{
	bricknum++;
	brick = nbrick;
	nbrick = random(sizeof(Shape) / sizeof(Shape[0]));
	nx = bw / 2;
	ny = 3;
	rot = 0;
	InvalidateRect(win_hWnd, NULL, FALSE);
	if (GetAround(nx, ny, brick, rot) != EMPTY) {
		KillTimer(win_hWnd, 1);
		GameStatus = GAMEOVER;
		MessageBox(win_hWnd, L"GAME OVER", L"˸", MB_OK);
	}
}

int CTetrisGame::GetAround(int x, int y, int b, int r)
{
	int i, k = EMPTY;

	for (i = 0; i < 4; i++) {
		k = max(k, board[x + Shape[b][r][i].x][y + Shape[b][r][i].y]);
	}
	return k;
}
BOOL CTetrisGame::MoveDown()
{
	if (GetAround(nx, ny + 1, brick, rot) != EMPTY) {
		TestFull();
		return TRUE;
	}
	ny++;
	//  ׷     ش.
	InvalidateRect(win_hWnd, NULL, FALSE);
	//  ʹ  ִϸ̼ ʴ´. 
	if (bw < 100) {
		UpdateWindow(win_hWnd);
	}
	return FALSE;
}
void CTetrisGame::TestFull()
{
	int i, x, y, ty;
	int count = 0;
	static int arScoreInc[] = { 0,1,3,8,20 };

	for (i = 0; i < 4; i++) {
		board[nx + Shape[brick][rot][i].x][ny + Shape[brick][rot][i].y] = brick + 1;
	}
	// ̵    . 
	brick = -1;

	for (y = 1; y < bh + 1; y++) {
		for (x = 1; x < bw + 1; x++) {
			if (board[x][y] == EMPTY) break;
		}
		if (x == bw + 1) {
			count++;
			for (ty = y; ty > 1; ty--) {
				for (x = 1; x < bw + 1; x++) {
					board[x][ty] = board[x][ty - 1];
				}
			}
			InvalidateRect(win_hWnd, NULL, FALSE);
			UpdateWindow(win_hWnd);
			Sleep(150);
		}
	}
	score += arScoreInc[count];
	if (bricknum % 10 == 0 && Interval > 200) {
		Interval -= 50;
		SetTimer(win_hWnd, 1, Interval, NULL);
	}
}

void CTetrisGame::PrintTile(HDC hdc, int x, int y, int c)
{
	HPEN oldPen;
	HBRUSH oldBrush;
	RECT brt;

	if (c == EMPTY) {
		if (ts > 20) {
			Rectangle(hdc, x * ts + ts / 2 - 1, y * ts + ts / 2 - 1, x * ts + ts / 2 + 1, y * ts + ts / 2 + 1);
		} else {
			SetPixel(hdc, x * ts + ts / 2, y * ts + ts / 2, RGB(128, 128, 128));
		}
	} else {
		SetRect(&brt, x * ts, y * ts, x * ts + ts, y * ts + ts);

		oldBrush = (HBRUSH)SelectObject(hdc, arBrush[c]);
		oldPen = (HPEN)SelectObject(hdc, GetStockObject(NULL_PEN));
		Rectangle(hdc, brt.left, brt.top, brt.right, brt.bottom);
		SelectObject(hdc, oldBrush);
		SelectObject(hdc, oldPen);

		// ü ٷ ߴµ  ʰ  . 
		/*white = CreatePen(PS_SOLID, 1, RGB(200, 200, 200));
		gray = CreatePen(PS_SOLID, 1, RGB(32, 32, 32));
		oldPen = (HPEN)SelectObject(hdc, white);
		MoveToEx(hdc, brt.left, brt.top, NULL); LineTo(hdc, brt.left, brt.bottom);
		MoveToEx(hdc, brt.left, brt.top, NULL); LineTo(hdc, brt.right, brt.top);
		SelectObject(hdc, gray);
		MoveToEx(hdc, brt.left, brt.bottom, NULL); LineTo(hdc, brt.right, brt.bottom);
		MoveToEx(hdc, brt.right, brt.top, NULL); LineTo(hdc, brt.right, brt.bottom);
		SelectObject(hdc, oldPen);
		DeleteObject(white);
		DeleteObject(gray);
		*/
	}
}

void CTetrisGame::AdjustMainWindow()
{
	RECT crt;
	SetRect(&crt, 0, 0, (bw + 12) * ts, (bh + 2) * ts);
	AdjustWindowRect(&crt, WS_OVERLAPPED | WS_SYSMENU | WS_BORDER | WS_CAPTION, FALSE);
	SetWindowPos(win_hWnd, NULL, 0, 0, crt.right - crt.left, crt.bottom - crt.top,
		SWP_NOMOVE | SWP_NOZORDER);
}

LRESULT CColorTable::OnCreate(WPARAM wParam, LPARAM lParam)
{
	hBitmap = LoadBitmap(g_hInst, MAKEINTRESOURCE(IDB_COLORTABLE));
	return 0;
}

LRESULT CColorTable::OnDestroy(WPARAM wParam, LPARAM lParam)
{
	DeleteObject(hBitmap);
	return 0;
}

void CColorTable::OnDraw(HDC hdc, RECT crt)
{
	DrawBitmap(hdc, 0, 0, hBitmap);
}

void CColorTable::OnClick()
{
	CColorTableApp* pApp;
	pApp = new CColorTableApp();
	pApp->Create();
}

// ǥ . todo : Űε ¿ ̵ϴ  ߰ 
void CColorTableApp::Create()
{
	// ּȭ   
	CreateWindow(TEXT("CWindow"), L"ǥ", WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | 
		WS_THICKFRAME | WS_MAXIMIZEBOX | WS_VISIBLE,
		0, 0, 0, 0,	NULL, (HMENU)NULL, g_hInst, this);

	//   ġ .
	WINDOWPLACEMENT wndpl;
	wndpl.length = sizeof(WINDOWPLACEMENT);
	wndpl.flags = 0;
	wndpl.rcNormalPosition.left = setting.get(L"ColorTableApp", L"left", 10);
	wndpl.rcNormalPosition.top = setting.get(L"ColorTableApp", L"top", 10);
	wndpl.rcNormalPosition.right = setting.get(L"ColorTableApp", L"right", 1500);
	wndpl.rcNormalPosition.bottom = setting.get(L"ColorTableApp", L"bottom", 1024);
	wndpl.showCmd = setting.get(L"ColorTableApp", L"showCmd", SW_SHOWNORMAL);
	SetWindowPlacement(win_hWnd, &wndpl);
}

LRESULT CColorTableApp::OnCreate(WPARAM wParam, LPARAM lParam)
{
	hList = CreateWindow(TEXT("listbox"), NULL, WS_CHILD | WS_VISIBLE | WS_BORDER |
		LBS_NOTIFY, 5, 5, 130, 150, win_hWnd, (HMENU)CT_LIST, g_hInst, NULL);
	SendMessage(hList, LB_ADDSTRING, 0, (LPARAM)L" ǥػ()");
	SendMessage(hList, LB_ADDSTRING, 0, (LPARAM)L" ǥػ(̸)");
	SendMessage(hList, LB_ADDSTRING, 0, (LPARAM)L" ");
	SendMessage(hList, LB_SETCURSEL, 0, 0);
	SendMessage(hList, WM_SETFONT, (WPARAM)mainFont, MAKELPARAM(FALSE, 0));

	// 4  ư ġ
	for (int i = 0; i < 4; i++) {
		hBtnCopy[i] = CreateWindow(TEXT("button"), TEXT(""), WS_CHILD | WS_VISIBLE |
			BS_PUSHBUTTON, 5, 480 + i * 30, 130, 25, win_hWnd, (HMENU)(CT_COPY1 + i), g_hInst, NULL);
		SendMessage(hBtnCopy[i], WM_SETFONT, (WPARAM)mainFont, MAKELPARAM(FALSE, 0));
	}

	PrepareColor(0);
	selIdx = 0;
	ChangeSelColor(0);
	return 0;
}

LRESULT CColorTableApp::OnDestroy(WPARAM wParam, LPARAM lParam)
{
	//   ġ 
	WINDOWPLACEMENT wndpl;
	wndpl.length = sizeof(WINDOWPLACEMENT);
	GetWindowPlacement(win_hWnd, &wndpl);

	setting.set(L"ColorTableApp", L"left", (int)wndpl.rcNormalPosition.left);
	setting.set(L"ColorTableApp", L"top", (int)wndpl.rcNormalPosition.top);
	setting.set(L"ColorTableApp", L"right", (int)wndpl.rcNormalPosition.right);
	setting.set(L"ColorTableApp", L"bottom", (int)wndpl.rcNormalPosition.bottom);
	setting.set(L"ColorTableApp", L"showCmd", (int)wndpl.showCmd);

	return 0;
}

LRESULT CColorTableApp::OnSize(WPARAM wParam, LPARAM lParam)
{
	CWindow::OnSize(wParam, lParam);
	
	CalcTileSize();
	return 0;
}

LRESULT CColorTableApp::OnCommand(WPARAM wParam, LPARAM lParam)
{
	HWND hBtn;
	TCHAR str[128];
	HGLOBAL hmem;
	TCHAR* ptr;

	switch (LOWORD(wParam)) {
	case CT_LIST:
		switch (HIWORD(wParam)) {
		case LBN_SELCHANGE:
			PrepareColor(SendMessage(hList, LB_GETCURSEL, 0, 0));
			CalcTileSize();
			InvalidateRect(win_hWnd, NULL, TRUE);
			return 0;
		}
		break;
	case CT_COPY1:
	case CT_COPY2:
	case CT_COPY3:
	case CT_COPY4:
		hBtn = GetDlgItem(win_hWnd, LOWORD(wParam));
		GetWindowText(hBtn, str, 128);
		hmem = GlobalAlloc(GHND, (lstrlen(str) + 1) * sizeof(TCHAR));
		ptr = (TCHAR*)GlobalLock(hmem);
		memcpy(ptr, str, (lstrlen(str) + 1) * sizeof(TCHAR));
		GlobalUnlock(hmem);
		if (OpenClipboard(win_hWnd)) {
			EmptyClipboard();
			SetClipboardData(CF_UNICODETEXT, hmem);
			CloseClipboard();
		} else {
			GlobalFree(hmem);
		}
		break;
	}

	return 0;
}

void CColorTableApp::OnDraw(HDC hdc, RECT crt)
{
	int x = leftMargin;
	int y = 0;
	HBRUSH brush, oldBrush;
	TCHAR value[128];
	HFONT oldFont;
	int rgb;

	//     
	rgb = RGB(GetBValue(arColor[selIdx].color), GetGValue(arColor[selIdx].color), GetRValue(arColor[selIdx].color));
	brush = CreateSolidBrush(rgb);
	oldBrush = (HBRUSH)SelectObject(hdc, brush);
	Rectangle(hdc, 5, 170, 135, 300);
	DeleteObject(SelectObject(hdc, oldBrush));

	//  Ʒ   
	rgb = RGB(GetBValue(arColor[prevSel].color), GetGValue(arColor[prevSel].color), GetRValue(arColor[prevSel].color));
	brush = CreateSolidBrush(rgb);
	oldBrush = (HBRUSH)SelectObject(hdc, brush);
	Rectangle(hdc, 5, 305, 135, 435);
	DeleteObject(SelectObject(hdc, oldBrush));

	SetBkMode(hdc, TRANSPARENT);
	oldFont = (HFONT)SelectObject(hdc, mainFont);
	TextOut2(hdc, 5, 455, L" ");

	SetTextAlign(hdc, TA_CENTER);
	if (tile_width <= 80) {
		oldFont = (HFONT)SelectObject(hdc, smallFont);
	}

	for (int idx = 0; ; idx++) {
		if (lstrlen(arColor[idx].name) == 0) break;

		//     
		if (idx == selIdx) {
			brush = CreateSolidBrush(RGB(0,0,255));
			oldBrush = (HBRUSH)SelectObject(hdc, brush);
			Rectangle(hdc, x, y, x + tile_width, y+tile_height);
			DeleteObject(SelectObject(hdc, oldBrush));
			SetTextColor(hdc, RGB(255, 255, 255));
		} else {
			SetTextColor(hdc, RGB(0, 0, 0));
		}

		// 16  BGR̾  ٲ㼭  . 
		rgb = RGB(GetBValue(arColor[idx].color), GetGValue(arColor[idx].color), GetRValue(arColor[idx].color));
		brush = CreateSolidBrush(rgb);
		oldBrush = (HBRUSH)SelectObject(hdc, brush);

		if (namedColor) {
			TextOut2(hdc, x + tile_width / 2, y + 2, arColor[idx].name);
			// ¿ 4ȼ е 
			Rectangle(hdc, x + 4, y + 20, x + tile_width - 4, y + tile_height - 20);
		} else {
			Rectangle(hdc, x + 4, y + 4, x + tile_width - 4, y + tile_height - 20);
		}
		DeleteObject(SelectObject(hdc, oldBrush));
		wsprintf(value, L"%06X", arColor[idx].color);
		TextOut2(hdc, x + tile_width / 2, y + tile_height - 20, value);

		x += tile_width;
		if (x + tile_width > crt.right) {
			x = leftMargin;
			y += tile_height;
		}
	}

	SelectObject(hdc, oldFont);
}

LRESULT CColorTableApp::OnLButtonDown(WPARAM wParam, LPARAM lParam)
{
	POINT pt;
	int idx;

	pt.x = (int)(short)LOWORD(lParam);
	pt.y = (int)(short)HIWORD(lParam);

	//   Ŭص ƹ ó  ʴ´.
	if (pt.x <= leftMargin) return 0;

	// ǥκ Ŭ Ÿ 
	idx = (pt.y / tile_height) * perLine + (pt.x - leftMargin) / tile_width;

	// ȭ Ʒ Ŭ   
	if (idx >= colorCount) idx = colorCount - 1;

	ChangeSelColor(idx);
	return 0;
}

void CColorTableApp::PrepareColor(int colorType)
{
	int i;

	switch (colorType)
	{
	case 0:
	case 1:
		for (i = 0; ; i++) {
			if (lstrlen(arStandardColor[i].name) == 0) break;
			lstrcpy(arColor[i].name, arStandardColor[i].name);
			arColor[i].color = arStandardColor[i].color;
		}
		lstrcpy(arColor[i].name, L"");
		colorCount = i;
		if (colorType == 1) {
			qsort(arColor, i, sizeof(sOneColor), colorNameCompare);
		}
		namedColor = true;
		selIdx = prevSel = 0;
		break;
	case 2:
		i = 0;
		for (int r = 0; r <= 0xff; r += 0x33) {
			for (int g = 0; g <= 0xff; g += 0x33) {
				for (int b = 0; b <= 0xff; b += 0x33) {
					wsprintf(arColor[i].name, L"%02X%02X%02X", r, g, b);
					arColor[i].color = r * 0x10000 + g * 0x100 + b;
					i++;
				}
			}
		}
		lstrcpy(arColor[i].name, L"");
		colorCount = i;
		namedColor = false;
		selIdx = prevSel = 0;

		break;
	}
}

int CColorTableApp::colorNameCompare(const void* a, const void* b)
{
	CColorTableApp::sOneColor ra, rb;
	ra = *(CColorTableApp::sOneColor*)a;
	rb = *(CColorTableApp::sOneColor*)b;

	if (lstrcmp(ra.name, rb.name) > 0) {
		return 1;
	}

	return -1;
}

void CColorTableApp::CalcTileSize()
{
	RECT crt;
	GetClientRect(win_hWnd, &crt);
	int width = crt.right - leftMargin;
	int height = crt.bottom;

	// ٴ 16. ּ ȼ   ٴ  .  1280 ϸ 16 ۾.
	tile_width = width / 16;
	if (tile_width < 80) tile_width = 80;
	perLine = width / tile_width;

	// 0  
	if (perLine == 0) perLine = 1;

	// ʿ   ̸  ϵ ּ  .
	int needRow = colorCount / perLine + 1;
	tile_height = height / needRow;
	if (tile_height < 50) tile_height = 50;
}

void CColorTableApp::ChangeSelColor(int idx)
{
	//  ϱ   
	prevSel = selIdx;
	selIdx = idx;

	int color = arColor[selIdx].color;
	TCHAR text[128];

	SetWindowText(hBtnCopy[0], arColor[selIdx].name);
	wsprintf(text, L"RGB(%d, %d, %d)", GetBValue(color), GetGValue(color), GetRValue(color));
	SetWindowText(hBtnCopy[1], text);
	wsprintf(text, L"0X%0X", color);
	SetWindowText(hBtnCopy[2], text);
	wsprintf(text, L"#%0X", color);
	SetWindowText(hBtnCopy[3], text);

	InvalidateRect(win_hWnd, NULL, TRUE);
}


