#include "pch.h"

#ifdef _DEBUG
#define DEBUGLOGFILE TEXT("c:\\Temp\\SoEnty_Debug.txt")
void WriteLogFile(LPCTSTR strLog, ...)
{
	HANDLE hLog;
	static int count = 0;
	DWORD dwWritten;
	TCHAR szLog[1024];
	TCHAR strLog2[1024];
	va_list marker;
	SYSTEMTIME st;

	va_start(marker, strLog);
	_vstprintf(szLog, strLog, marker);

	if (count == 0) {
		hLog = CreateFile(DEBUGLOGFILE, GENERIC_WRITE, 0, NULL,
			CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	} else {
		hLog = CreateFile(DEBUGLOGFILE, GENERIC_WRITE, 0, NULL,
			OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	}

	GetLocalTime(&st);
	wsprintf(strLog2, TEXT("ī=%06d(%d:%d:%d:%d) %s\r\n"), count++,
		st.wHour, st.wMinute, st.wSecond, st.wMilliseconds, szLog);
	SetFilePointer(hLog, 0, NULL, FILE_END);
	WriteFile(hLog, strLog2, lstrlen(strLog2), &dwWritten, NULL);
	CloseHandle(hLog);
}

void CustomTrace(LPCTSTR format, ...)
{
	TCHAR buf[1024];
	va_list marker;

	va_start(marker, format);
	_vstprintf(buf, format, marker);
	OutputDebugString(buf);
}
#else
void WriteLogFile(LPCTSTR strLog, ...) { ; }
void CustomTrace(LPCTSTR format, ...) { ; }
#endif

void DrawBitmap(HDC hdc, int x, int y, HBITMAP hBit)
{
	HDC MemDC;
	HBITMAP OldBitmap;
	int bx, by;
	BITMAP bit;

	MemDC = CreateCompatibleDC(hdc);
	OldBitmap = (HBITMAP)SelectObject(MemDC, hBit);

	GetObject(hBit, sizeof(BITMAP), &bit);
	bx = bit.bmWidth;
	by = bit.bmHeight;

	BitBlt(hdc, x, y, bx, by, MemDC, 0, 0, SRCCOPY);

	SelectObject(MemDC, OldBitmap);
	DeleteDC(MemDC);
}

void TrimTrailZero(TCHAR* num)
{
	if (_tcschr(num, '.') != NULL) {
		TCHAR* p;
		for (p = num + lstrlen(num) - 1; *p == '0'; p--) { ; }
		if (*p == '.') {
			*p = 0;
		} else {
			*(p + 1) = 0;
		}
	}
}

bool IsTopMost(HWND hWnd)
{
	LONG_PTR ExStyle;
	ExStyle = GetWindowLongPtr(hWnd, GWL_EXSTYLE);
	return ((ExStyle & WS_EX_TOPMOST) != 0);
}

void FillRect(HDC hdc, int left, int top, int right, int bottom, HBRUSH brush)
{
	RECT rt;
	SetRect(&rt, left, top, right, bottom);
	FillRect(hdc, &rt, brush);
}

//    ã´. 
COLORREF GetLightColor(COLORREF color, int value)
{
	int r = min(GetRValue(color) + value, 255);
	int g = min(GetGValue(color) + value, 255);
	int b = min(GetBValue(color) + value, 255);
	return (RGB(r, g, b));
}

//  ο  ã´.
COLORREF GetDarkColor(COLORREF color, int value)
{
	int r = max(GetRValue(color) - value, 0);
	int g = max(GetGValue(color) - value, 0);
	int b = max(GetBValue(color) - value, 0);
	return (RGB(r, g, b));
}

//  ߾ӿ ڿ Ѵ.  hdc Ӽ .
void TextOutVCenter(HDC hdc, int x, int y, LPCTSTR str)
{
	SIZE sz;
	GetTextExtentPoint32(hdc, str, lstrlen(str), &sz);
	TextOut(hdc, x, y - sz.cy / 2, str, lstrlen(str));
}

// ˾ θ ġ ʴ  ڵ ̵
// wx, wy ˾ » ǥ̸  ġ .
void MovePopupToSide(HWND hDlg, int wx, int wy)
{
	HMONITOR hMonitor;
	MONITORINFOEX mi;
	POINT pt;
	RECT wrt, drt;
	int x, y;
	const int GAP = 5;

	//  찡 ִ ͸ ˾Ƴ.
	hMonitor = MonitorFromWindow(mainWindow.win_hWnd, MONITOR_DEFAULTTONEAREST);
	mi.cbSize = sizeof(MONITORINFOEX);
	GetMonitorInfo(hMonitor, &mi);

	GetCursorPos(&pt);
	GetWindowRect(mainWindow.win_hWnd, &wrt);
	GetWindowRect(hDlg, &drt);
	if (bVertical) {
		//   콺  ʿ  ȭڸ ʿ ǥѴ.
		if ((mi.rcMonitor.right + mi.rcMonitor.left) / 2 > pt.x) {
			x = wrt.right + GAP;
		} else {
			x = wrt.left - (drt.right - drt.left) - GAP;
		}
		y = wrt.top + wy;

		// ȭ غ ͺ  Ʒ̸  ÷ ش.
		// , ۾ ǥٱ  ʾ Ϻ   ִ.
		if (y + (drt.bottom - drt.top) > mi.rcMonitor.bottom) {
			y = mi.rcMonitor.bottom - (drt.bottom - drt.top);
		}

		//  ͸  Ʒ .
		if (y < mi.rcMonitor.top) {
			y = mi.rcMonitor.top;
		}
	} else {
		// ʵ  .
		if ((mi.rcMonitor.bottom + mi.rcMonitor.top) / 2 > pt.y) {
			y = wrt.bottom + GAP;
		} else {
			y = wrt.top - (drt.bottom - drt.top) - GAP;
		}
		x = wrt.left + wx;

		if (x + (drt.right - drt.left) > mi.rcMonitor.right) {
			x = mi.rcMonitor.right - (drt.right - drt.left);
		}

		if (x < mi.rcMonitor.left) {
			x = mi.rcMonitor.left;
		}
	}

	// ȭ ġ ű Z ״ Ѵ. ƴϸ AlwaysOnTop Ӽ ٲ. 
	SetWindowPos(hDlg, NULL, x, y, 0, 0, SWP_NOSIZE | SWP_NOZORDER);
}

// st ¥  ʸ Ѵ. 2000 1 1  
DWORD MyGetAbsSecond(SYSTEMTIME st)
{
	INT64 i64;
	FILETIME fst;

	SystemTimeToFileTime(&st, &fst);
	i64 = (((INT64)fst.dwHighDateTime) << 32) + fst.dwLowDateTime;
	// ʴ ȯϰ 2000 1 1   ٲ۴.
	i64 = i64 / 10000000 - (INT64)145731 * 86400;

	return (DWORD)i64;
}

// ʸ ý Ÿ ٲ۴.
void MyAbsSecondToSystem(DWORD Abs, SYSTEMTIME& st)
{
	INT64 i64;
	FILETIME fst;

	i64 = (Abs + (INT64)145731 * 86400) * 10000000;
	fst.dwHighDateTime = (DWORD)(i64 >> 32);
	fst.dwLowDateTime = (DWORD)(i64 & 0xffffffff);
	FileTimeToSystemTime(&fst, &st);
}

int GetCheckedRadioButton(HWND hDlg, int First, int Last)
{
	int id;

	for (id = First; id <= Last; id++) {
		if (IsDlgButtonChecked(hDlg, id) == BST_CHECKED)
			return id;
	}
	return -1;
}

//   ߾ӿ Ⱦ ߾ ̹ 
void DrawImageCenter(HDC hdc, Image* pImage, int width, int height, bool erase, HBRUSH backBrush)
{
	Graphics G(hdc);
	int iw, ih;
	int l, t, r, b, tsize;

	iw = pImage->GetWidth();
	ih = pImage->GetHeight();
	if (iw < width && ih < height) {
		l = width / 2 - iw / 2;
		t = height / 2 - ih / 2;
		r = l + iw;
		b = t + ih;
	} else {
		// ̹ Ⱦ  ũ : ȭ η  
		if ((double)iw / ih > (double)width / height) {
			l = 0;
			r = width;
			// ȭ  ŭ ׸  δ.
			tsize = int(ih * width / (double)iw);
			t = height / 2 - tsize / 2;
			b = t + tsize;
		} else {
			t = 0;
			b = height;
			tsize = int(iw * height / (double)ih);
			l = width / 2 - tsize / 2;
			r = l + tsize;
		}
	}

	G.DrawImage(pImage, l, t, r - l, b - t);

	// ̹ ٱ   ä. 
	if (erase) {
		FillRect(hdc, 0, 0, width, t, backBrush);
		FillRect(hdc, 0, 0, l, height, backBrush);
		FillRect(hdc, 0, b, width, height, backBrush);
		FillRect(hdc, r, t, width, height, backBrush);
	}
}

//  ϰ  ġ INI  θ ʱȭѴ. 
void CSetting::SetIniPath(LPCTSTR filename)
{
	TCHAR* p;

	GetModuleFileName(NULL, iniPath, MAX_PATH);

	// ϸ  ʾ  ϸ Ȯڸ ini Ѵ. 
	if (filename == NULL) {
		p = _tcsrchr(iniPath, '.');
		*(p + 1) = 0;
		lstrcat(iniPath, L"ini");
	} else {
		p = _tcsrchr(iniPath, '\\');
		*(p + 1) = 0;
		lstrcat(iniPath, filename);
	}
}

int CSetting::get(LPCTSTR section, LPCTSTR key, int defValue)
{
	if (useIni) {
		return GetPrivateProfileInt(section, key, defValue, iniPath);
	} else {
		TCHAR regPath[MAX_PATH];
		HKEY hKey;
		DWORD dwDisp;
		INT Result;
		DWORD cbSize;

		Result = defValue;
		lstrcpy(regPath, regRoot);
		lstrcat(regPath, section);
		if (RegCreateKeyEx(hive, regPath, 0, NULL, REG_OPTION_NON_VOLATILE, KEY_READ, NULL, &hKey, &dwDisp) == ERROR_SUCCESS) {
			if (dwDisp == REG_OPENED_EXISTING_KEY) {
				cbSize = sizeof(LONG);
				if (RegQueryValueEx(hKey, key, 0, NULL, (LPBYTE)&Result, &cbSize) != ERROR_SUCCESS) {
					Result = defValue;
				}
			}
			RegCloseKey(hKey);
		}
		return Result;
	}
}

//  ũ 128 ̻ Ȯؾ Ѵ.  ̻ API Լ  ȣ 
void CSetting::get(LPCTSTR section, LPCTSTR key, LPCTSTR defValue, LPTSTR retValue, int nSize/* = 128*/)
{
	if (useIni) {
		GetPrivateProfileString(section, key, defValue, retValue, nSize, iniPath);
	} else {
		TCHAR regPath[MAX_PATH];
		HKEY hKey;
		DWORD dwDisp;
		DWORD cbSize;
		bool Result = false;

		lstrcpy(regPath, regRoot);
		lstrcat(regPath, section);
		if (RegCreateKeyEx(hive, regPath, 0, NULL, REG_OPTION_NON_VOLATILE, KEY_READ, NULL, &hKey, &dwDisp) == ERROR_SUCCESS) {
			if (dwDisp == REG_OPENED_EXISTING_KEY) {
				cbSize = nSize * sizeof(TCHAR);
				if (RegQueryValueEx(hKey, key, 0, NULL, (LPBYTE)retValue, &cbSize) == ERROR_SUCCESS) {
					Result = true;
				}
			}
			RegCloseKey(hKey);
		}

		if (Result == false) {
			lstrcpy(retValue, defValue);
		}
	}
}

// Ǽ б - ڿ   Ǽ ȯϿ Ѵ. INI, Ʈ  Ǽ Ÿ   ʴ´.
//  ϳ  ޼  unsigned   ȣ ϱ  ݵ int ĳؾ ϴ  ִ. 
double CSetting::get(LPCTSTR section, LPCTSTR key, double defValue)
{
	TCHAR buf[128];
	get(section, key, TEXT(""), buf);
	if (lstrlen(buf) == 0) {
		return defValue;
	} else {
		TCHAR* endptr;
		return _tcstod(buf, &endptr);
	}
}

bool CSetting::set(LPCTSTR section, LPCTSTR key, int value)
{
	if (useIni) {
		//  ڿ ٲ㼭 Ѵ.
		TCHAR buf[64];
		wsprintf(buf, TEXT("%d"), value);
		WritePrivateProfileString(section, key, buf, iniPath);
		return true;
	} else {
		TCHAR regPath[MAX_PATH];
		HKEY hKey;
		DWORD dwDisp;
		bool Result = false;

		lstrcpy(regPath, regRoot);
		lstrcat(regPath, section);
		if (RegCreateKeyEx(hive, regPath, 0, NULL, REG_OPTION_NON_VOLATILE, KEY_WRITE, NULL, &hKey, &dwDisp) == ERROR_SUCCESS) {
			if (RegSetValueEx(hKey, key, 0, REG_DWORD, (LPBYTE)&value, sizeof(INT)) == ERROR_SUCCESS) {
				Result = true;
			}
			RegCloseKey(hKey);
		}
		return Result;
	}
}

bool CSetting::set(LPCTSTR section, LPCTSTR key, LPCTSTR value)
{
	if (useIni) {
		WritePrivateProfileString(section, key, value, iniPath);
		return true;
	} else {
		TCHAR regPath[MAX_PATH];
		HKEY hKey;
		DWORD dwDisp;
		bool Result = false;

		lstrcpy(regPath, regRoot);
		lstrcat(regPath, section);
		if (RegCreateKeyEx(hive, regPath, 0, NULL, REG_OPTION_NON_VOLATILE, KEY_WRITE, NULL, &hKey, &dwDisp) == ERROR_SUCCESS) {
			if (RegSetValueEx(hKey, key, 0, REG_SZ, (LPBYTE)value, (lstrlen(value) + 1) * sizeof(TCHAR)) == ERROR_SUCCESS) {
				Result = true;
			}
			RegCloseKey(hKey);
		}
		return Result;
	}
}

bool CSetting::set(LPCTSTR section, LPCTSTR key, double value)
{
	TCHAR buf[128];
	_stprintf_s(buf, TEXT("%f"), value);
	return set(section, key, buf);
}

//  ü Ѵ.
void CSetting::deleteSection(LPCTSTR section)
{
	if (useIni) {
		// ι° μ NULL̸ section  Ѵ.
		WritePrivateProfileString(section, NULL, NULL, iniPath);
	} else {
		// Ʈ   ̱
	}

}

//  ͸  ä. 
void makeFullScreen(HWND hWnd)
{
	HMONITOR hMonitor;
	MONITORINFOEX mi;

	SetWindowLongPtr(hWnd, GWL_STYLE, WS_POPUP | WS_VISIBLE);

	hMonitor = MonitorFromWindow(hWnd, MONITOR_DEFAULTTONEAREST);
	mi.cbSize = sizeof(MONITORINFOEX);
	GetMonitorInfo(hMonitor, &mi);
	SetWindowPos(hWnd, HWND_NOTOPMOST, mi.rcMonitor.left, mi.rcMonitor.top,
		mi.rcMonitor.right - mi.rcMonitor.left, mi.rcMonitor.bottom - mi.rcMonitor.top,
		SWP_FRAMECHANGED);
}

#define IsHorz (GetWindowLong(hWnd,GWL_STYLE) & GSS_HORZ)
struct GrpScrlData {
	int Max, Min;
	int Pos;
	int TSize;
	int TGap;
	COLORREF BackColor;
	COLORREF ThumbColor;
};

LRESULT CALLBACK GrpScrlProc(HWND hWnd, UINT iMessage, WPARAM wParam, LPARAM lParam);
void GetThumbRect(HWND hWnd, RECT* trt);
void PosFromPixel(HWND hWnd, int Pixel);

class GrpScrlRegister {
public:
	GrpScrlRegister() {
		WNDCLASS WndClass;

		WndClass.cbClsExtra = 0;
		WndClass.cbWndExtra = 4;
		WndClass.hbrBackground = NULL;
		WndClass.hCursor = LoadCursor(NULL, IDC_ARROW);
		WndClass.hIcon = NULL;
		WndClass.hInstance = GetModuleHandle(NULL);
		WndClass.lpfnWndProc = GrpScrlProc;
		WndClass.lpszClassName = TEXT("GrpScrl");
		WndClass.lpszMenuName = NULL;
		WndClass.style = 0;

		RegisterClass(&WndClass);
	}
} GrpScrlRegisterObject;

LRESULT CALLBACK GrpScrlProc(HWND hWnd, UINT iMessage, WPARAM wParam, LPARAM lParam)
{
	HDC hdc, MemDC;
	HBITMAP MemBit, hOldBmp;
	PAINTSTRUCT ps;
	GrpScrlData* pData;
	RECT crt, trt;
	POINT pt;
	static int offset;
	static HPEN hPen[5];
	int i;
	HBRUSH BackBrush, ThumbBrush, OldBrush;

	pData = (GrpScrlData*)GetWindowLong(hWnd, 0);
	switch (iMessage) {
	case WM_CREATE:
		pData = (GrpScrlData*)calloc(sizeof(GrpScrlData), 1);
		SetWindowLong(hWnd, 0, (LONG)pData);
		pData->TSize = 20;
		pData->TGap = 2;
		// hPen 迭 ̹Ƿ  νϽ    ʿ䰡 .
		if (hPen[0] == NULL) {
			for (i = 0; i < 5; i++) {
				hPen[i] = CreatePen(PS_SOLID, 1, RGB(i * 32 + 32, i * 32 + 32, i * 32 + 32));
			}
		}
		pData->BackColor = GetSysColor(COLOR_BTNFACE);
		pData->ThumbColor = RGB(255, 255, 255);
		return 0;
	case GSM_SETRANGE:
		pData->Min = wParam;
		pData->Max = lParam;
		InvalidateRect(hWnd, NULL, TRUE);
		return 0;
	case GSM_GETRANGEHI:
		return pData->Max;
	case GSM_GETRANGELOW:
		return pData->Min;
	case GSM_SETPOS:
		pData->Pos = wParam;
		pData->Pos = max(pData->Min, min(pData->Max, pData->Pos));
		InvalidateRect(hWnd, NULL, TRUE);
		return 0;
	case GSM_GETPOS:
		return pData->Pos;
	case GSM_SETTSIZE:
		GetClientRect(hWnd, &crt);
		pData->TSize = wParam;
		if (IsHorz) {
			pData->TSize = max(4, min(crt.right - 10, pData->TSize));
		} else {
			pData->TSize = max(4, min(crt.bottom - 10, pData->TSize));
		}
		InvalidateRect(hWnd, NULL, TRUE);
		return 0;
	case GSM_GETTSIZE:
		return pData->TSize;
	case GSM_SETTGAP:
		GetClientRect(hWnd, &crt);
		pData->TGap = wParam;
		if (IsHorz) {
			pData->TGap = max(0, min(crt.bottom / 2 - 2, pData->TGap));
		} else {
			pData->TGap = max(0, min(crt.right / 2 - 2, pData->TGap));
		}
		InvalidateRect(hWnd, NULL, TRUE);
		return 0;
	case GSM_GETTGAP:
		return pData->TGap;
	case GSM_SETBACKCOLOR:
		pData->BackColor = (COLORREF)wParam;
		InvalidateRect(hWnd, NULL, TRUE);
		return 0;
	case GSM_SETTHUMBCOLOR:
		pData->ThumbColor = (COLORREF)wParam;
		InvalidateRect(hWnd, NULL, TRUE);
		return 0;
		// ũⰡ ٲ  絵   ٽ ؾ Ѵ.
	case WM_SIZE:
		SendMessage(hWnd, GSM_SETTSIZE, pData->TSize, 0);
		SendMessage(hWnd, GSM_SETTGAP, pData->TGap, 0);
		return 0;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		GetClientRect(hWnd, &crt);
		MemDC = CreateCompatibleDC(hdc);
		MemBit = CreateCompatibleBitmap(hdc, crt.right, crt.bottom);
		hOldBmp = (HBITMAP)SelectObject(MemDC, MemBit);

		BackBrush = CreateSolidBrush(pData->BackColor);
		FillRect(MemDC, &crt, BackBrush);
		DeleteObject(BackBrush);
		if (IsHorz) {
			for (i = 0; i < 5; i++) {
				SelectObject(MemDC, hPen[i]);
				MoveToEx(MemDC, crt.left, crt.bottom / 2 - 2 + i, NULL);
				LineTo(MemDC, crt.right, crt.bottom / 2 - 2 + i);
			}
		} else {
			for (i = 0; i < 5; i++) {
				SelectObject(MemDC, hPen[i]);
				MoveToEx(MemDC, crt.right / 2 - 2 + i, crt.top, NULL);
				LineTo(MemDC, crt.right / 2 - 2 + i, crt.bottom);
			}
		}
		GetThumbRect(hWnd, &trt);
		SelectObject(MemDC, GetStockObject(BLACK_PEN));
		ThumbBrush = CreateSolidBrush(pData->ThumbColor);
		OldBrush = (HBRUSH)SelectObject(MemDC, ThumbBrush);
		RoundRect(MemDC, trt.left, trt.top, trt.right, trt.bottom, 10, 10);
		DeleteObject(SelectObject(MemDC, OldBrush));

		BitBlt(hdc, 0, 0, crt.right, crt.bottom, MemDC, 0, 0, SRCCOPY);
		SelectObject(MemDC, hOldBmp);
		DeleteObject(MemBit);
		DeleteDC(MemDC);
		EndPaint(hWnd, &ps);
		return 0;
	case WM_LBUTTONDOWN:
		GetThumbRect(hWnd, &trt);
		pt.x = LOWORD(lParam);
		pt.y = HIWORD(lParam);
		if (PtInRect(&trt, pt)) {
			if (IsHorz) {
				offset = trt.left - LOWORD(lParam);
			} else {
				offset = trt.top - HIWORD(lParam);
			}
			SetCapture(hWnd);
		} else {
			if (IsHorz) {
				PosFromPixel(hWnd, LOWORD(lParam) - pData->TSize / 2);
			} else {
				PosFromPixel(hWnd, HIWORD(lParam) - pData->TSize / 2);
			}
			SendMessage(GetParent(hWnd), IsHorz ? WM_HSCROLL : WM_VSCROLL,
				MAKEWPARAM(SB_THUMBPOSITION, 0), (LPARAM)hWnd);
		}
		return 0;
	case WM_MOUSEMOVE:
		if (GetCapture() == hWnd) {
			GetClientRect(hWnd, &crt);
			if (IsHorz) {
				PosFromPixel(hWnd, (int)(short)LOWORD(lParam) + offset);
			} else {
				PosFromPixel(hWnd, (int)(short)HIWORD(lParam) + offset);
			}
			// ġ  . 32Ʈ̹Ƿ   
			SendMessage(GetParent(hWnd), IsHorz ? WM_HSCROLL : WM_VSCROLL,
				MAKEWPARAM(SB_THUMBTRACK, 0), (LPARAM)hWnd);
		}
		return 0;
	case WM_LBUTTONUP:
		if (GetCapture() == hWnd) {
			ReleaseCapture();
			SendMessage(GetParent(hWnd), IsHorz ? WM_HSCROLL : WM_VSCROLL,
				MAKEWPARAM(SB_THUMBPOSITION, 0), (LPARAM)hWnd);
		}
		return 0;
	case WM_DESTROY:
		if (hPen[0]) {
			for (i = 0; i < 5; i++) {
				DeleteObject(hPen[i]);
				hPen[0] = NULL;
			}
		}
		free(pData);
		return 0;
	}
	return(DefWindowProc(hWnd, iMessage, wParam, lParam));
}

void GetThumbRect(HWND hWnd, RECT* trt)
{
	GrpScrlData* pData;
	RECT crt;
	int x, y;

	pData = (GrpScrlData*)GetWindowLong(hWnd, 0);
	GetClientRect(hWnd, &crt);
	if (IsHorz) {
		x = MulDiv(pData->Pos, crt.right - pData->TSize, pData->Max - pData->Min);
		SetRect(trt, x, crt.top + pData->TGap, x + pData->TSize, crt.bottom - pData->TGap);
	} else {
		y = MulDiv(pData->Pos, crt.bottom - pData->TSize, pData->Max - pData->Min);
		SetRect(trt, crt.left + pData->TGap, y, crt.right - pData->TGap, y + pData->TSize);
	}
}

// ȭ ScrPos شϴ  Ѵ.
void PosFromPixel(HWND hWnd, int Pixel)
{
	GrpScrlData* pData;
	RECT crt;
	int width;

	pData = (GrpScrlData*)GetWindowLong(hWnd, 0);
	GetClientRect(hWnd, &crt);
	if (IsHorz) {
		width = crt.right - pData->TSize;
	} else {
		width = crt.bottom - pData->TSize;
	}

	pData->Pos = MulDiv(Pixel, pData->Max - pData->Min, width);
	pData->Pos = max(pData->Min, min(pData->Max, pData->Pos));
	InvalidateRect(hWnd, NULL, TRUE);
}

// Ʈ 
struct GrpBtnData {
	HBITMAP Bitmap[4];
	eState State;
};

LRESULT CALLBACK GrpBtnProc(HWND hWnd, UINT iMessage, WPARAM wParam, LPARAM lParam);
static void DeleteAllBitmap(GrpBtnData* pData);
static BOOL IsPtOnMe(HWND hWnd, LPARAM lParam);

//  Ŭ  ִ  ü
class GrpBtnRegister {
public:
	GrpBtnRegister() {
		WNDCLASS WndClass;

		WndClass.cbClsExtra = 0;
		WndClass.cbWndExtra = sizeof(LONG_PTR);
		WndClass.hbrBackground = (HBRUSH)(COLOR_BTNFACE + 1);
		WndClass.hCursor = LoadCursor(NULL, IDC_ARROW);
		WndClass.hIcon = NULL;
		WndClass.hInstance = GetModuleHandle(NULL);
		WndClass.lpfnWndProc = GrpBtnProc;
		WndClass.lpszClassName = TEXT("GrpBtn");
		WndClass.lpszMenuName = NULL;
		WndClass.style = 0;

		RegisterClass(&WndClass);
	}
} GrpBtnRegisterObject;

LRESULT CALLBACK GrpBtnProc(HWND hWnd, UINT iMessage, WPARAM wParam, LPARAM lParam)
{
	HDC hdc;
	PAINTSTRUCT ps;
	GrpBtnData* pData;
	RECT crt;
	POINT pt;
	static eState CheckState;
	HWND hParent;

	pData = (GrpBtnData*)GetWindowLongPtr(hWnd, 0);
	switch (iMessage) {
	case WM_CREATE:
		pData = (GrpBtnData*)calloc(sizeof(GrpBtnData), 1);
		SetWindowLongPtr(hWnd, 0, (LONG_PTR)pData);
		return 0;
	case GBM_SETIMAGE:
		DeleteAllBitmap(pData);
		pData->Bitmap[0] = LoadBitmap(GetModuleHandle(NULL), MAKEINTRESOURCE(LOWORD(wParam)));
		pData->Bitmap[1] = LoadBitmap(GetModuleHandle(NULL), MAKEINTRESOURCE(HIWORD(wParam)));
		pData->Bitmap[2] = LoadBitmap(GetModuleHandle(NULL), MAKEINTRESOURCE(LOWORD(lParam)));
		pData->Bitmap[3] = LoadBitmap(GetModuleHandle(NULL), MAKEINTRESOURCE(HIWORD(lParam)));
		InvalidateRect(hWnd, NULL, FALSE);
		return 0;
	case GBM_GETSTATE:
		return pData->State;
	case GBM_SETSTATE:
		if ((GetWindowLongPtr(hWnd, GWL_STYLE) & GBS_CHECK) != 0) {
			ChangeState(hWnd, (eState)wParam);
		}
		return 0;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		if (pData->Bitmap[pData->State]) {
			DrawBitmap(hdc, 0, 0, pData->Bitmap[pData->State]);
		}
		EndPaint(hWnd, &ps);
		return 0;
	case WM_LBUTTONDOWN:
		// Ǫ ư DOWN, üũ ư Ŭ
		if ((GetWindowLongPtr(hWnd, GWL_STYLE) & GBS_CHECK) == 0) {
			ChangeState(hWnd, GB_DOWN);
		} else {
			CheckState = pData->State;
			ChangeState(hWnd, CheckState == GB_NORMAL ? GB_DOWN : GB_NORMAL);
		}
		SetCapture(hWnd);
		return 0;
	case WM_MOUSEMOVE:
		if (GetCapture() == hWnd) {
			if ((GetWindowLongPtr(hWnd, GWL_STYLE) & GBS_CHECK) == 0) {
				if (IsPtOnMe(hWnd, lParam)) {
					ChangeState(hWnd, GB_DOWN);
				} else {
					ChangeState(hWnd, GB_NORMAL);
				}
			} else {
				if (IsPtOnMe(hWnd, lParam)) {
					ChangeState(hWnd, CheckState == GB_NORMAL ? GB_DOWN : GB_NORMAL);
				} else {
					ChangeState(hWnd, CheckState);
				}
			}
		} else {
			for (hParent = hWnd; GetParent(hParent); hParent = GetParent(hParent)) { ; }
			if (GetForegroundWindow() != hParent) return 0;
			// Ǫ ư  °   ִ.
			if ((GetWindowLongPtr(hWnd, GWL_STYLE) & GBS_CHECK) == 0) {
				ChangeState(hWnd, GB_HOT);
				SetTimer(hWnd, 0, 50, NULL);
			}
		}
		return 0;
	case WM_LBUTTONUP:
		if (GetCapture() == hWnd) {
			ReleaseCapture();
			// üũ ư MOUSEMOVE  ¸ ״ .
			if ((GetWindowLongPtr(hWnd, GWL_STYLE) & GBS_CHECK) == 0) {
				ChangeState(hWnd, GB_NORMAL);
			}
			if (IsPtOnMe(hWnd, lParam)) {
				SendMessage(GetParent(hWnd), WM_COMMAND, MAKEWPARAM(
					GetWindowLongPtr(hWnd, GWLP_ID), GBN_CLICKED), (LPARAM)hWnd);
			}
		}
		return 0;
	case WM_TIMER:
		GetCursorPos(&pt);
		GetWindowRect(hWnd, &crt);
		if (PtInRect(&crt, pt) == FALSE) {
			KillTimer(hWnd, 0);
			ChangeState(hWnd, GB_NORMAL);
		}
		return 0;
	case WM_ENABLE:
		if (wParam == TRUE) {
			ChangeState(hWnd, GB_NORMAL);
		} else {
			ChangeState(hWnd, GB_DISABLE);
			KillTimer(hWnd, 0);
		}
		return 0;
	case WM_DESTROY:
		DeleteAllBitmap(pData);
		free(pData);
		return 0;
		// ˾ ޴ ޽ θ𿡰 Ѵ. 
	case WM_CONTEXTMENU:
		PostMessage(GetParent(hWnd), WM_CONTEXTMENU, wParam, lParam);
		return 0;
	}
	return(DefWindowProc(hWnd, iMessage, wParam, lParam));
}

void ChangeState(HWND hWnd, eState State)
{
	GrpBtnData* pData;

	pData = (GrpBtnData*)GetWindowLongPtr(hWnd, 0);
	if (pData->State == State) return;

	pData->State = State;
	InvalidateRect(hWnd, NULL, FALSE);
}

static void DeleteAllBitmap(GrpBtnData* pData)
{
	int i;

	for (i = 0; i < 4; i++) {
		if (pData->Bitmap[i]) {
			DeleteObject(pData->Bitmap[i]);
		}
	}
}

static BOOL IsPtOnMe(HWND hWnd, LPARAM lParam)
{
	POINT pt;
	RECT wrt;

	pt.x = (int)(short)LOWORD(lParam);
	pt.y = (int)(short)HIWORD(lParam);
	ClientToScreen(hWnd, &pt);
	GetWindowRect(hWnd, &wrt);
	return PtInRect(&wrt, pt);
}

// 迭 ȯϸ  ÷ڸ ã´.
void moveNext(int& now, int size)
{
	if (now == size - 1) {
		now = 0;
	} else {
		now++;
	}
}

// 迭 ȯϸ  ÷ڸ ã´.
void movePrev(int& now, int size)
{
	if (now == 0) {
		now = size - 1;
	} else {
		now--;
	}
}

// ȸ ̹   . 2, 4, 5, 6 µ ־     ʿϴ. 
void FixImageOrientation(Image* pImage)
{
	UINT size, count;
	// 1 ̸   exif   ϵ ʴ´. 
	unsigned short orientation = 1;
	PropertyItem* arPro;
	pImage->GetPropertySize(&size, &count);

	arPro = (PropertyItem*)malloc(size);
	pImage->GetAllPropertyItems(size, count, arPro);
	for (int i = 0; i < (int)count; i++) {
		if (arPro[i].id == PropertyTagOrientation) {
			orientation = *(unsigned short*)arPro[i].value;
		}
	}

	switch (orientation) {
	case 6:
		pImage->RotateFlip(Rotate90FlipNone);
		break;
	case 3:
		pImage->RotateFlip(Rotate180FlipNone);
		break;
	case 8:
		pImage->RotateFlip(Rotate270FlipNone);
		break;
	}
}

void MySetImeMode(HWND hEdit, BOOL bHan)
{
	HIMC hImc;
	hImc = ImmGetContext(hEdit);

	if (bHan == TRUE) {
		ImmSetConversionStatus(hImc, IME_CMODE_NATIVE, IME_SMODE_NONE);
	}
	else {
		ImmSetConversionStatus(hImc, 0, IME_SMODE_NONE);
	}

	ImmReleaseContext(hEdit, hImc);
}

// X11,  ǥػ
sNamedColor arStandardColor[] = {
	{L"IndianRed",				0xcd5c5c},
	{L"DarkSalmon",				0xe9967a},
	{L"LightCoral",				0xf08080},
	{L"Salmon",					0xfa8072},
	{L"OrangeRed",				0xff4500},
	{L"Red",					0xff0000},
	{L"Crimson",				0xdc143c},
	{L"FireBrick",				0xb22222},
	{L"DarkRed",				0x8b0000},
	{L"MediumVioletRed",		0xc71585},
	{L"Pink",					0xffc0cb},
	{L"LightPink",				0xffb6c1},
	{L"HotPink",				0xff69b4},
	{L"DeepPink",				0xff1493},
	{L"PaleVioletRed",			0xdb7093},
	{L"DarKkhaki",				0xbdb76b},
	{L"Khaki",					0xf0e68c},
	{L"PaleGoldenRod",			0xeee8aa},
	{L"LightGoldenRodYellow",	0xfafad2},
	{L"LightYellow",			0xffffe0},
	{L"LemonChiffon",			0xfffacd},
	{L"Yellow",					0xffff00},
	{L"Gold",					0xffd700},
	{L"PapayaWhip",				0xffefd5},
	{L"Moccasin",				0xffe4b5},
	{L"PeachPuff",				0xffdab9},
	{L"Cyan",					0x00ffff},
	{L"Aqua",					0x00ffff},
	{L"AquaMarine",				0x7fffd4},
	{L"Turquoise",				0x40e0d0},
	{L"MediumTurquoise",		0x48d1cc},
	{L"DarkTurquoise",			0x00ced1},
	{L"CadetBlue",				0x5f9ea0},
	{L"SlateGray",				0x708090},
	{L"LightCyan",				0xe0ffff},
	{L"PaleTurquoise",			0xafeeee},
	{L"PowderBlue",				0xb0e0e6},
	{L"LightSteelBlue",			0xb0c4de},
	{L"SteelBlue",				0x4682b4},
	{L"LightBlue",				0xadd8e6},
	{L"SkyBlue",				0x87ceeb},
	{L"LightSkyBlue",			0x87cefa},
	{L"DeepSkyBlue",			0x00bfff},
	{L"CornflowerBlue",			0x6495ed},
	{L"RoyalBlue",				0x4169e1},
	{L"MediumSlateBlue",		0x7b68ee},
	{L"DodgerBlue",				0x1e90ff},
	{L"Blue",					0x0000ff},
	{L"MediumBlue",				0x0000cd},
	{L"DarkBlue",				0x00008b},
	{L"Navy",					0x000080},
	{L"MidnightBlue",			0x191970},
	{L"LightSalmon",			0xffa07a},
	{L"Orange",					0xffa500},
	{L"DarkOrange",				0xff8c00},
	{L"Coral",					0xff7f50},
	{L"Tomato",					0xff6347},
	{L"MediumGpringGreen",		0x00fa9a},
	{L"SpringGreen",			0x00ff7f},
	{L"PaleGreen",				0x98fb98},
	{L"GreenYellow",			0xadff2f},
	{L"ChartReuse",				0x7fff00},
	{L"LawnGreen",				0x7cfc00},
	{L"Lime",					0x00ff00},
	{L"LightGreen",				0x90ee90},
	{L"YellowGreen",			0x9acd32},
	{L"LimeGreen",				0x32cd32},
	{L"MediumSeaGreen",			0x3cb371},
	{L"DarkSeaGreen",			0x8fbc8f},
	{L"ForestGreen",			0x228b22},
	{L"Seagreen",				0x2e8b57},
	{L"Green",					0x008000},
	{L"OliveDrab",				0x6b8e23},
	{L"Olive",					0x808000},
	{L"DarkOliveGreen",			0x556b2f},
	{L"DarkGreen",				0x006400},
	{L"MediumAquaMarine",		0x66cdaa},
	{L"Turquoise",				0x40e0d0},
	{L"LightSeaGreen",			0x20b2aa},
	{L"DarkCyan",				0x008b8b},
	{L"Teal",					0x008080},
	{L"Lavender",				0xe6e6fa},
	{L"Thistle",				0xd8bfd8},
	{L"Plum",					0xdda0dd},
	{L"Violet",					0xee82ee},
	{L"Fuchsia",				0xff00ff},
	{L"Magenta",				0xff00ff},
	{L"Orchid",					0xda70d6},
	{L"MediumOrchid",			0xba55d3},
	{L"DarkOrchid",				0x9932cc},
	{L"BlueViolet",				0x8a2be2},
	{L"DarkViolet",				0x9400d3},
	{L"MediumPurple",			0x9370db},
	{L"SlateBlue",				0x6a5acd},
	{L"Purple",					0x800080},
	{L"DarkMagenta",			0x8b008b},
	{L"DarkSlateBlue",			0x483d8b},
	{L"Indigo",					0x4b0082},
	{L"HoneyDew",				0xf0fff0},
	{L"MintCream",				0xf5fffa},
	{L"Azure",					0xf0ffff},
	{L"AliceBlue",				0xf0f8ff},
	{L"GhostWhite",				0xf8f8ff},
	{L"WhiteSmoke",				0xf5f5f5},
	{L"LavenderBlush",			0xfff0f5},
	{L"MistyRose",				0xffe4e1},
	{L"AntiqueWhite",			0xfaebd7},
	{L"SeaShell",				0xfff5ee},
	{L"Snow",					0xfffafa},
	{L"White",					0xffffff},
	{L"Beige",					0xf5f5dc},
	{L"Linen",					0xfaf0e6},
	{L"OldLace",				0xfdf5e6},
	{L"FloralWhite",			0xfffaf0},
	{L"Ivory",					0xfffff0},
	{L"Gainsboro",				0xdcdcdc},
	{L"LightGrey",				0xd3d3d3},
	{L"Silver",					0xc0c0c0},
	{L"DarkGray",				0xa9a9a9},
	{L"Gray",					0x808080},
	{L"DimGray",				0x696969},
	{L"DarkSlateGray",			0x2f4f4f},
	{L"LightSlateGray",			0x778899},
	{L"SlateGray",				0x708090},
	{L"CornSilk",				0xfff8dc},
	{L"BlanchedAlmond",			0xffebcd},
	{L"Bisque",					0xffe4c4},
	{L"NavajoWhite",			0xffdead},
	{L"Wheat",					0xf5deb3},
	{L"SandyBrown",				0xf4a460},
	{L"GoldenRod",				0xdaa520},
	{L"DarkGoldenRod",			0xb8860b},
	{L"Peru",					0xcd853f},
	{L"Chocolate",				0xd2691e},
	{L"Maroon",					0x800000},
	{L"SaddleBrown",			0x8b4513},
	{L"Brown",					0xa52a2a},
	{L"Sienna",					0xa0522d},
	{L"Darkred",				0x8b0000},
	{L"BurlyWood",				0xdeb887},
	{L"Tan",					0xd2b48c},
	{L"RosyBrown",				0xbc8f8f},
	{L"Black",					0x000000},
	{L"",						0x000000},		// end mark
};

// ̸κ  ã ش.   Ѵ.
COLORREF GetColorFromName(LPCTSTR name)
{
	for (int i = 0; ; i++) {
		if (lstrlen(arStandardColor[i].name) == 0) break;
		if (lstrcmpi(arStandardColor[i].name, name) == 0) {
			int c = arStandardColor[i].color;
			return RGB(GetBValue(c), GetGValue(c), GetRValue(c));
		}
	}

	return RGB(0, 0, 0);
}