// ũ Լ
#define Count(a) (sizeof(a)/sizeof(a[0]))
#define TextOut2(h,x,y,t) TextOut(h,x,y,t,lstrlen(t));
#define ABS(a) ((a) >= 0 ? (a):-(a))
#define random(n) (rand()%(n))

void WriteLogFile(LPCTSTR strLog, ...);
void CustomTrace(LPCTSTR format, ...); 
void DrawBitmap(HDC hdc, int x, int y, HBITMAP hBit);
void TrimTrailZero(TCHAR* num);
bool IsTopMost(HWND hWnd);
void FillRect(HDC hdc, int left, int top, int right, int bottom, HBRUSH brush);
COLORREF GetLightColor(COLORREF color, int value);
COLORREF GetDarkColor(COLORREF color, int value);
void TextOutVCenter(HDC hdc, int x, int y, LPCTSTR str);
void MovePopupToSide(HWND hDlg, int wx, int wy);
DWORD MyGetAbsSecond(SYSTEMTIME st);
void MyAbsSecondToSystem(DWORD Abs, SYSTEMTIME& st);
int GetCheckedRadioButton(HWND hDlg, int First, int Last);
void DrawImageCenter(HDC hdc, Image* pImage, int width, int height, bool erase, HBRUSH backBrush);

template<typename T>
class TStack
{
protected:
	T* Stack;
	int Size;
	int Top;

public:
	TStack(int aSize) {
		Size = aSize;
		Stack = (T*)malloc(Size * sizeof(T));
		Top = -1;
	}
	virtual ~TStack() {
		free(Stack);
	}
	virtual BOOL Push(T data) {
		if (Top < Size - 1) {
			Top++;
			Stack[Top] = data;
			return TRUE;
		} else {
			return FALSE;
		}
	}
	virtual T Pop() {
		return Stack[Top--];
	}
	virtual int GetTop() { return Top; }
	virtual T GetValue(int n) { return Stack[n]; }
};

struct sImagePath {
	TCHAR Path[MAX_PATH];
	sImagePath(LPCTSTR path) {
		lstrcpy(Path, path);
	}
};

//  ȥC̳  Ʈ   , ø  ߰, int Ÿ   
// ø   Ƿ  迭θ  . ü  ϹǷ ü  
template <typename T>
class TDArray
{
public:
	T* ar;
	int allocsize;
	int num;
	int growby;
	int fp;

	TDArray(int asize = 100, int agrowby = 50);
	~TDArray();
	bool Insert(int idx, const T* pvalue, int n);
	bool Insert(int idx, const T& value) { return Insert(idx, &value, 1); }
	bool Delete(int idx, int n = 1);

	bool Append(const T& value) { return Insert(num, &value, 1); }
	bool Append(const T* pvalue, int n) { return Insert(num, pvalue, n); }
	void Clear();
	void Replace(int idx, const T& value) { assert(idx >= 0 && idx < num); ar[idx] = value; }

	bool Write(void* data, int length);
	bool Read(void* data, int length);

	T& operator[](int idx) { assert(idx >= 0 && idx < num); return ar[idx]; }
	const T& operator[](int idx) const { assert(idx >= 0 && idx < num); return ar[idx]; }
};

template <typename T>
TDArray<T>::TDArray(int asize/*=100*/, int agrowby/*=50*/)
{
	allocsize = asize;
	growby = agrowby;
	num = 0;
	fp = 0;
	ar = (T*)malloc(allocsize * sizeof(T));
}

template <typename T>
TDArray<T>::~TDArray()
{
	if (ar) free(ar);
	ar = NULL;
}

template <typename T>
void TDArray<T>::Clear()
{
	if (ar) free(ar);
	num = 0;
	allocsize = 100;
	fp = 0;
	ar = (T*)malloc(allocsize * sizeof(T));
}

template <typename T>
bool TDArray<T>::Insert(int idx, const T* pvalue, int n)
{
	int need;

	if (idx < 0 || idx > num) return false;

	need = num + n;
	if (need > allocsize) {
		allocsize = need + growby;
		ar = (T*)realloc(ar, allocsize * sizeof(T));
	}
	memmove(ar + idx + n, ar + idx, (num - idx) * sizeof(T));
	memcpy(ar + idx, pvalue, n * sizeof(T));
	num += n;
	return true;
}

template <typename T>
bool TDArray<T>::Delete(int idx, int n/*=1*/)
{
	if (idx < 0 || idx > num) return false;
	if (n <= 0) return false;
	memmove(ar + idx, ar + idx + n, (num - idx - n) * sizeof(T));
	num -= n;
	return true;
}

template <typename T>
bool TDArray<T>::Write(void* data, int length)
{
	Append((T*)data, length);
	return true;
}

template <typename T>
bool TDArray<T>::Read(void* data, int length)
{
	memcpy(data, ar + fp, length);
	fp += length;
	return true;
}

class CGdiPlusStarter
{
private:
	ULONG_PTR m_gpToken;

public:
	bool m_bSuccess;
	CGdiPlusStarter() {
		GdiplusStartupInput gpsi;
		m_bSuccess = (GdiplusStartup(&m_gpToken, &gpsi, NULL) == Ok);
	}
	~CGdiPlusStarter() {
		GdiplusShutdown(m_gpToken);
	}
};

// INI   Ʈ    ϴ Ŭ. 
// Ǽ  ɵ ߰.
// Ʈ  ڵ ڵ  Űڵ ݴ ״ ذ   ׽Ʈ ʿ
// Ű ϴ ɱ   ʾ. 
class CSetting
{
public:
	bool useIni;
	TCHAR iniPath[MAX_PATH];
	TCHAR regRoot[MAX_PATH];		//  \\ Ͽ    . 
	HKEY hive;

	//     Ѵ. Ʈ ο ̺    Ѵ.
	CSetting(bool useIni) {
		this->useIni = useIni;
		hive = HKEY_CURRENT_USER;
	}

	//    iniFile θ ʱȭѴ. 
	void SetIniPath(LPCTSTR filename);
	int get(LPCTSTR section, LPCTSTR key, int defValue);
	void get(LPCTSTR section, LPCTSTR key, LPCTSTR defValue, LPTSTR retValue, int nSize = 128);
	double get(LPCTSTR section, LPCTSTR key, double defValue);

	bool set(LPCTSTR section, LPCTSTR key, int value);
	bool set(LPCTSTR section, LPCTSTR key, LPCTSTR value);
	bool set(LPCTSTR section, LPCTSTR key, double value);

	void deleteSection(LPCTSTR section);
};

void makeFullScreen(HWND hWnd);
void moveNext(int& now, int size);
void movePrev(int& now, int size);

// GrpScr Ÿ
#define GSS_HORZ 1
#define GSS_VERT 2

// GrpScr ޽
#define GSM_SETRANGE WM_USER+1
#define GSM_GETRANGEHI WM_USER+2
#define GSM_GETRANGELOW WM_USER+3
#define GSM_SETPOS WM_USER+4
#define GSM_GETPOS WM_USER+5
#define GSM_SETTSIZE WM_USER+6
#define GSM_GETTSIZE WM_USER+7
#define GSM_SETTGAP WM_USER+8
#define GSM_GETTGAP WM_USER+9
#define GSM_SETBACKCOLOR WM_USER+10
#define GSM_SETTHUMBCOLOR WM_USER+11

// GrpBtn Ÿ
#define GBS_PUSH 0
#define GBS_CHECK 1

// GrpBtn ޽
#define GBM_SETIMAGE WM_USER+1 
#define GBM_GETSTATE WM_USER+2
#define GBM_SETSTATE WM_USER+3

//  ޽
#define GBN_CLICKED 0

// ư  
enum eState { GB_NORMAL, GB_HOT, GB_DOWN, GB_DISABLE };
void ChangeState(HWND hWnd, eState State);

void FixImageOrientation(Image* pImage);
void MySetImeMode(HWND hEdit, BOOL bHan);

struct sNamedColor
{
	LPCTSTR name;
	COLORREF color;
};

COLORREF GetColorFromName(LPCTSTR name);

