#include "pch.h"

LRESULT CClock::OnTimer(WPARAM wParam, LPARAM lParam) {
	SYSTEMTIME st;
	GetLocalTime(&st);
	static TCHAR arYoil[][4] = { TEXT(""), TEXT(""), TEXT("ȭ"), TEXT(""), TEXT(""), TEXT(""), TEXT("") };
	static TCHAR arYoilEng[][16] = { TEXT("Sun"), TEXT("Mon"), TEXT("Tue"), TEXT("Wen"), TEXT("Thr"), TEXT("Fri"), TEXT("Sat") };

	month = st.wMonth;
	day = st.wDay;
	lstrcpy(yoil, arYoil[st.wDayOfWeek]);

	bool needRepaint;
	if (outSec) {
		needRepaint = (hour != st.wHour || min != st.wMinute || sec != st.wSecond);
	} else {
		needRepaint = (hour != st.wHour || min != st.wMinute);
	}

	hour = st.wHour;
	min = st.wMinute;
	sec = st.wSecond;

	// ǥ ð  ٲ  ٽ ׸.
	if (needRepaint) {
		InvalidateRect(win_hWnd, NULL, TRUE);
	}
	return 0;
}

// ð  ֻ ǥ Ѵ.
void getRadialPos(int cx, int cy, int radius, double hour, int& x, int& y)
{
	// ð  ٲ۴.    360   ٲ۴.
	double angle = -30 * hour + 90;
	if (angle < 0) angle += 360;
	//   ٲ۴.
	double radian = angle * 3.1415 / 180;

	// Ͱ 1/4и̹Ƿ y ǥ .
	x = int(cx + radius * cos(radian));
	y = int(cy - radius * sin(radian));
}

void CClock::OnDraw(HDC hdc, RECT crt) {
	TCHAR sTime[128];
	HFONT oldFont;

	if (faceType == 0) {
		LPCTSTR ampm;
		HFONT dayFont, timeFont;
		int fontSize;
		int center = crt.bottom / 2 - 3;

		SetBkMode(hdc, TRANSPARENT);
		SetTextAlign(hdc, TA_CENTER);
		wsprintf(sTime, TEXT("%d%d %s"), month, day, yoil);

		dayFont = CreateFont(20, 0, 0, 0, 0, 0, 0, 0, HANGUL_CHARSET, 3, 2, 1,
			VARIABLE_PITCH | FF_MODERN, TEXT(" "));
		oldFont = (HFONT)SelectObject(hdc, dayFont);
		TextOut(hdc, crt.right / 2, center - 20, sTime, lstrlen(sTime));

		// ʸ ǥ  Ʈ   Ű.
		fontSize = outSec ? 25 : 35;
		timeFont = CreateFont(fontSize, 0, 0, 0, 0, 0, 0, 0, ANSI_CHARSET, 3, 2, 1,
			VARIABLE_PITCH | FF_SWISS, TEXT("Arial"));
		SelectObject(hdc, timeFont);

		int tHour = hour;
		if (hour24 == false) {
			//  0,  12÷ ǥѴ.
			if (tHour > 12) {
				tHour -= 12;
			}
		}

		TCHAR sDigit[128];
		if (digit2) {
			lstrcpy(sDigit, L"%02d");
		} else {
			lstrcpy(sDigit, L"%d");
		}

		TCHAR sFormat[128];
		lstrcpy(sFormat, sDigit);
		lstrcat(sFormat, L":");
		lstrcat(sFormat, sDigit);
		if (outSec) {
			lstrcat(sFormat, L":");
			lstrcat(sFormat, sDigit);
			wsprintf(sTime, sFormat, tHour, min, sec);
		} else {
			wsprintf(sTime, sFormat, tHour, min);
		}
		TextOut(hdc, crt.right / 2, center, sTime, lstrlen(sTime));

		if (hour24 == false) {
			SIZE sz;
			GetTextExtentPoint32(hdc, sTime, lstrlen(sTime), &sz);
			SetTextAlign(hdc, TA_LEFT | TA_BASELINE);
			SelectObject(hdc, smallFont);
			SetTextColor(hdc, RGB(128, 128, 128));
			//ampm = tHour >= 12 ? L"PM" : L"AM";
			ampm = tHour >= 12 ? L"" : L"";
			TextOut2(hdc, crt.right / 2 + sz.cx / 2 + 3, center + sz.cy - 8, ampm);
		}

		SelectObject(hdc, oldFont);
		DeleteObject(dayFont);
		DeleteObject(timeFont);
	}

	if (faceType == 1) {
		int cx = crt.right / 2;
		int cy = crt.bottom / 2;
		// ª  90% ׸.
		int radius = int(min(cx, cy) * 0.9);
		int timeR;
		HPEN pen, oldPen;
		int rx, ry;

		//  ð  ׸. 
		for (int h = 0; h <= 11; h++) {
			getRadialPos(cx, cy, radius, h, rx, ry);
			if (h % 3 == 0) {
				timeR = 3;
			} else {
				timeR = 2;
			}
			Ellipse(hdc, rx - timeR, ry - timeR, rx + timeR, ry + timeR);
		}

		// ¥  ǥѴ. ð ٴú  Ʒ ׸.
		SetBkMode(hdc, TRANSPARENT);
		oldFont = (HFONT)SelectObject(hdc, mainFont);
		SetTextAlign(hdc, TA_CENTER);
		wsprintf(sTime, TEXT("%d"), month);
		TextOutVCenter(hdc, cx - radius / 2, cy - 7, sTime);
		wsprintf(sTime, TEXT("%d"), day);
		TextOutVCenter(hdc, cx - radius / 2, cy + 7, sTime);
		TextOutVCenter(hdc, cx + radius / 2, cy, yoil);
		SelectObject(hdc, oldFont);

		int tx, ty;

		// ħ ǥ. ð Ӹ ƴ϶ а Ѵ. 30 0.5ð شѴ.
		pen = CreatePen(PS_SOLID, 3, RGB(255, 0, 0));
		oldPen = (HPEN)SelectObject(hdc, pen);
		getRadialPos(cx, cy, int(radius * 0.6), hour + min / 60.0, tx, ty);
		MoveToEx(hdc, cx, cy, NULL);LineTo(hdc, tx, ty);
		DeleteObject(SelectObject(hdc, oldPen));

		// ħ ǥ. ʸ  Ѵ. 60  12   ٲٷ 5 .
		pen = CreatePen(PS_SOLID, 2, RGB(0, 0, 255));
		oldPen = (HPEN)SelectObject(hdc, pen);
		getRadialPos(cx, cy, int(radius * 0.8), (min + sec / 60.0) / 5, tx, ty);
		MoveToEx(hdc, cx, cy, NULL); LineTo(hdc, tx, ty);
		DeleteObject(SelectObject(hdc, oldPen));

		// ħ ǥ
		if (outSec) {
			pen = CreatePen(PS_SOLID, 1, RGB(128, 128, 128));
			oldPen = (HPEN)SelectObject(hdc, pen);
			getRadialPos(cx, cy, int(radius * 0.8), sec / 5.0, tx, ty);
			MoveToEx(hdc, cx, cy, NULL); LineTo(hdc, tx, ty);
			DeleteObject(SelectObject(hdc, oldPen));
		}
	}
}

INT_PTR CALLBACK ClockDlgProc(HWND hDlg, UINT iMessage, WPARAM wParam, LPARAM lParam)
{
	static CClock* pWidget;
	int radio = 0;
	static LPCTSTR arFace[] = { TEXT(""),TEXT("Ƴα") };
	ULONGLONG tick;
	int Min, Hour, Day;
	TCHAR str[255];
	SYSTEMTIME st, boot;
	DWORD abs;

	switch (iMessage) {
	case WM_INITDIALOG:
		pWidget = (CClock*)lParam;
		MovePopupToSide(hDlg, pWidget->win_x, pWidget->win_y);

		for (int i = 0; i < Count(arFace); i++) {
			SendDlgItemMessage(hDlg, IDC_CLOCKFACE, LB_ADDSTRING, 0, (LPARAM)arFace[i]);
		}
		SendDlgItemMessage(hDlg, IDC_CLOCKFACE, LB_SETCURSEL, pWidget->faceType, 0);

		SendDlgItemMessage(hDlg, IDC_CHKHOUR24, BM_SETCHECK, pWidget->hour24 ? BST_CHECKED : BST_UNCHECKED, 0);
		SendDlgItemMessage(hDlg, IDC_CHKOUTSEC, BM_SETCHECK, pWidget->outSec ? BST_CHECKED : BST_UNCHECKED, 0);
		SendDlgItemMessage(hDlg, IDC_CHKDIGIT2, BM_SETCHECK, pWidget->digit2 ? BST_CHECKED : BST_UNCHECKED, 0);

		tick = GetTickCount64() / 1000;
		Day = int(tick / 86400);
		Hour = (tick % 86400) / 3600;
		Min = (tick % 3600) / 60;

		GetLocalTime(&st);
		abs = MyGetAbsSecond(st);
		MyAbsSecondToSystem(DWORD(abs - tick), boot);

		wsprintf(str, TEXT("%d/%d %d:%d (%d %dð %d)"), boot.wMonth, boot.wDay, boot.wHour, boot.wMinute,Day, Hour, Min);
		SetDlgItemText(hDlg, IDC_STBOOT, str);

		return TRUE;
	case WM_NCACTIVATE:
		if (wParam == FALSE && hOptionPopup != NULL) {
			pWidget->hour24 = IsDlgButtonChecked(hDlg, IDC_CHKHOUR24);
			pWidget->outSec = IsDlgButtonChecked(hDlg, IDC_CHKOUTSEC);
			pWidget->digit2 = IsDlgButtonChecked(hDlg, IDC_CHKDIGIT2);
			pWidget->faceType = (int)SendDlgItemMessage(hDlg, IDC_CLOCKFACE, LB_GETCURSEL, 0, 0);
			InvalidateRect(pWidget->win_hWnd, NULL, TRUE);

			//  Ѵ. Ź ϴ ͺٴ   ϴ°   δ. 
			pWidget->SaveSetting();

			// ⼭ ıϸ WM_NCACTIVATE .      ıؾ Ѵ.
			hOptionPopup = NULL;
			DestroyWindow(hDlg);
		}
		return TRUE;
	case WM_COMMAND:
		switch (LOWORD(wParam)) {
			// ESC ư   Ѵ.
		case IDCANCEL:
			hOptionPopup = NULL;
			DestroyWindow(hDlg);
			return TRUE;
		}
		break;
	}
	return FALSE;
}

LRESULT CClock::OnContextMenu(WPARAM wParam, LPARAM lParam)
{
	if (!IsWindow(hOptionPopup)) {
		hOptionPopup = CreateDialogParam(g_hInst, MAKEINTRESOURCE(IDD_CLOCK),
			win_hWnd, ClockDlgProc, (LPARAM)this);
		ShowWindow(hOptionPopup, SW_SHOW);
	}
	return 0;
}

void CClock::LoadSetting()
{
	faceType = setting.get(dget_id, L"faceType", 0);
	hour24 = setting.get(dget_id, L"hour24", false);
	outSec = setting.get(dget_id, L"outSec", true);
	digit2 = setting.get(dget_id, L"digit2", true);
}
void CClock::SaveSetting()
{
	setting.set(dget_id, L"faceType", faceType);
	setting.set(dget_id, L"hour24", hour24);
	setting.set(dget_id, L"outSec", outSec);
	setting.set(dget_id, L"digit2", digit2);
}



LRESULT CCpuUsage::OnTimer(WPARAM wParam, LPARAM lParam) {
	PDH_FMT_COUNTERVALUE counterVal;

	//  ĭ ֱٰ 
	PdhCollectQueryData(cpuQuery);
	PdhGetFormattedCounterValue(cpuTotal, PDH_FMT_DOUBLE, NULL, &counterVal);

	// ϳ  ̵ϰ  ֱٰ 
	for (int i = 1; i < USAGE_NUM; i++) {
		arUsage[i - 1] = arUsage[i];
	}
	// ݿøؼ  Ѵ. 
	arUsage[USAGE_NUM - 1] = (int)(counterVal.doubleValue + 0.5);

	InvalidateRect(win_hWnd, NULL, TRUE);
	return 0;
}

void CCpuUsage::OnDraw(HDC hdc, RECT crt) {
	int width, height;
	RECT trt;
	POINT pts[USAGE_NUM + 3];
	int Min = 100, Max = 0, Sum = 0, Avg;
	HPEN hPen, OldPen;
	HBRUSH hBrush, OldBrush;
	HFONT OldFont;
	TCHAR sUsage[128];
	TCHAR yMax[10];
	int tleft, tright;

	SetBkMode(hdc, TRANSPARENT);

	GetClientRect(win_hWnd, &crt);
	trt.left = crt.left + 18;
	trt.top = crt.top + 5;
	trt.right = crt.right - 5;
	trt.bottom = crt.bottom - 35;
	width = (trt.right - trt.left);
	height = (trt.bottom - trt.top);

	//  ä
	hPen = CreatePen(PS_SOLID, 1, RGB(16, 80, 160));
	OldPen = (HPEN)SelectObject(hdc, hPen);
	hBrush = CreateSolidBrush(RGB(240, 240, 255));
	OldBrush = (HBRUSH)SelectObject(hdc, hBrush);
	Rectangle(hdc, trt.left, trt.top, trt.right, trt.bottom);
	SelectObject(hdc, OldPen);
	DeleteObject(hPen);
	SelectObject(hdc, OldBrush);
	DeleteObject(hBrush);

	// ٵ ׸
	hPen = CreatePen(PS_SOLID, 1, RGB(220, 220, 255));
	OldPen = (HPEN)SelectObject(hdc, hPen);
	for (int i = 1; i <= 3; i++) {
		MoveToEx(hdc, trt.left + 1, trt.top + height * i / 4, NULL);
		LineTo(hdc, trt.right - 1, trt.top + height * i / 4);
	}
	for (int i = 1; i <= 5; i++) {
		MoveToEx(hdc, trt.left + width * i / 6, trt.top + 1, NULL);
		LineTo(hdc, trt.left + width * i / 6, trt.bottom - 1);
	}
	SelectObject(hdc, OldPen);
	DeleteObject(hPen);

	// 踦 Ѵ.
	for (int i = 0; i < USAGE_NUM; i++) {
		Min = min(Min, arUsage[i]);
		Max = max(Max, arUsage[i]);
		Sum = Sum + arUsage[i];
	}
	Avg = Sum / USAGE_NUM;

	//  40% ̸̸ 50, 20̸̸ 25, 10̸̸ 12 y  Ѵ. 
	int divide = 100;
	lstrcpy(yMax, L"100");

	//  Y ɼ . ƴϸ  100% ǥ
	if (varYAxis) {
		if (Max < 10) {
			divide = 12;
			lstrcpy(yMax, L"12");
		} else if (Max < 20) {
			divide = 25;
			lstrcpy(yMax, L"25");
		} else if (Max < 40) {
			divide = 50;
			lstrcpy(yMax, L"50");
		}
	}

	// ٰ . divide 簢 ܿ . 
	for (int i = 0; i < USAGE_NUM; i++) {
		pts[i].x = trt.left + LONG((double)width / USAGE_NUM * i);
		pts[i].y = trt.top + height - height * arUsage[i] / divide;
	}
	pts[USAGE_NUM].x = pts[USAGE_NUM - 1].x;
	pts[USAGE_NUM].y = trt.top + height;
	pts[USAGE_NUM + 1].x = trt.left;
	pts[USAGE_NUM + 1].y = trt.top + height;
	pts[USAGE_NUM + 2].x = pts[0].x;
	pts[USAGE_NUM + 2].y = pts[0].y;

	// ٰ ׸.
	Polygon(hdc, pts, USAGE_NUM + 3);

	// Y ̺ Ѵ.
	OldFont = (HFONT)SelectObject(hdc, smallFont);
	UINT oldAlign = SetTextAlign(hdc, TA_RIGHT);
	TextOutVCenter(hdc, crt.left + 16, trt.bottom, L"0");
	TextOutVCenter(hdc, crt.left + 16, trt.top, yMax);
	SetTextAlign(hdc, oldAlign);

	tleft = trt.left;
	tright = crt.right;
	if (crt.right < 120) {
		tleft = 2;
		tright = crt.right;
	}

	OldFont = (HFONT)SelectObject(hdc, mainFont);
	wsprintf(sUsage, TEXT("CPU:%d~%d"), Min, Max);
	TextOut(hdc, tleft, trt.bottom + 2, sUsage, lstrlen(sUsage));
	wsprintf(sUsage, L":%d%%", Avg);
	TextOut(hdc, tleft, trt.bottom + 18, sUsage, lstrlen(sUsage));
	SelectObject(hdc, OldFont);
	OldFont = (HFONT)SelectObject(hdc, bigFont);
	oldAlign = SetTextAlign(hdc, TA_RIGHT);
	SetTextColor(hdc, RGB(0, 128, 0));
	wsprintf(sUsage, L"%d%%", arUsage[USAGE_NUM - 1]);
	TextOut(hdc, tright, trt.bottom + 5, sUsage, lstrlen(sUsage));
	SetTextAlign(hdc, oldAlign);
	SelectObject(hdc, OldFont);
}

INT_PTR CALLBACK CpuUsageDlgProc(HWND hDlg, UINT iMessage, WPARAM wParam, LPARAM lParam)
{
	static CCpuUsage* pWidget;
	int radio = 0;

	switch (iMessage) {
	case WM_INITDIALOG:
		pWidget = (CCpuUsage*)lParam;
		MovePopupToSide(hDlg, pWidget->win_x, pWidget->win_y);

		if (pWidget->timerInterval == 1) radio = IDC_CPUTIME1;
		if (pWidget->timerInterval == 2) radio = IDC_CPUTIME2;
		if (pWidget->timerInterval == 5) radio = IDC_CPUTIME3;
		if (pWidget->timerInterval == 10) radio = IDC_CPUTIME4;
		CheckRadioButton(hDlg, IDC_CPUTIME1, IDC_CPUTIME4, radio);

		SendDlgItemMessage(hDlg, IDC_CHKVARYAXIS, BM_SETCHECK, pWidget->varYAxis ? BST_CHECKED : BST_UNCHECKED, 0);
		SendDlgItemMessage(hDlg, IDC_CHKVIEWTHREAD, BM_SETCHECK, pWidget->viewThread ? BST_CHECKED : BST_UNCHECKED, 0);
		
		return TRUE;
	case WM_NCACTIVATE:
		if (wParam == FALSE && hOptionPopup != NULL) {
			if (IsDlgButtonChecked(hDlg, IDC_CPUTIME1)) pWidget->timerInterval = 1;
			if (IsDlgButtonChecked(hDlg, IDC_CPUTIME2)) pWidget->timerInterval = 2;
			if (IsDlgButtonChecked(hDlg, IDC_CPUTIME3)) pWidget->timerInterval = 5;
			if (IsDlgButtonChecked(hDlg, IDC_CPUTIME4)) pWidget->timerInterval = 10;
			SetTimer(pWidget->win_hWnd, 1, pWidget->timerInterval * 1000, NULL);
			pWidget->varYAxis = IsDlgButtonChecked(hDlg, IDC_CHKVARYAXIS);
			pWidget->viewThread = IsDlgButtonChecked(hDlg, IDC_CHKVIEWTHREAD);
			InvalidateRect(pWidget->win_hWnd, NULL, TRUE);

			// ⼭ ıϸ WM_NCACTIVATE .      ıؾ Ѵ.
			hOptionPopup = NULL;
			DestroyWindow(hDlg);
		}
		return TRUE;
	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		// ESC ư   Ѵ.
		case IDCANCEL:
			hOptionPopup = NULL;
			DestroyWindow(hDlg);
			return TRUE;
		}
		break;
	}
	return FALSE;
}

LRESULT CCpuUsage::OnContextMenu(WPARAM wParam, LPARAM lParam)
{
	if (!IsWindow(hOptionPopup)) {
		hOptionPopup = CreateDialogParam(g_hInst, MAKEINTRESOURCE(IDD_CPUUSAGE),
			win_hWnd, CpuUsageDlgProc, (LPARAM)this);
		ShowWindow(hOptionPopup, SW_SHOW);
	}
	return 0;
}

LRESULT CMemUsage::OnTimer(WPARAM wParam, LPARAM lParam) {
	mem.dwLength = sizeof(MEMORYSTATUSEX);
	GlobalMemoryStatusEx(&mem);
	InvalidateRect(win_hWnd, NULL, TRUE);
	return 0;
}

void CMemUsage::OnDraw(HDC hdc, RECT crt)
{
	TCHAR str[128];
	HFONT OldFont;
	UINT oldAlign;
	double total = mem.ullTotalPhys / 1073741824.0;
	double avail = mem.ullAvailPhys / 1073741824.0;
	double used = total - avail;
	int center = crt.bottom / 2;
	TCHAR ram[10];

	SetBkMode(hdc, TRANSPARENT);
	if (crt.right < 100) {
		OldFont = (HFONT)SelectObject(hdc, smallFont);
		lstrcpy(ram, L"");
	} else {
		OldFont = (HFONT)SelectObject(hdc, mainFont);
		lstrcpy(ram, L"RAM ");
	}
	oldAlign = SetTextAlign(hdc, TA_BASELINE);
	_stprintf_s(str, TEXT("%s%.1fG"), ram, total);
	TextOut2(hdc, 4, center - 2, str);
	SetTextAlign(hdc, TA_TOP);
	_stprintf_s(str, TEXT("%.1fG"), used);
	TextOut2(hdc, 4, center + 2, str);
	SelectObject(hdc, OldFont);

	OldFont = (HFONT)SelectObject(hdc, bigFont);
	_stprintf_s(str, TEXT("%d%%"), mem.dwMemoryLoad);
	SetTextAlign(hdc, TA_RIGHT);
	SetTextColor(hdc, RGB(0, 0, 255));
	TextOutVCenter(hdc, crt.right - 4, center, str);
	SelectObject(hdc, OldFont);
	SetTextAlign(hdc, oldAlign);
}

LRESULT CDiskUsage::OnTimer(WPARAM wParam, LPARAM lParam)
{
	TCHAR Drive[MAX_PATH];
	UINT Type;
	int idx = 0;

	for (int i = 'C'; i <= 'Z'; i++) {
		wsprintf(Drive, L"%c:\\", i);
		Type = GetDriveType(Drive);
		if (Type == DRIVE_FIXED || (includeRemovable && Type == DRIVE_REMOVABLE) || (includeNetwork && Type == DRIVE_REMOTE)) {
			arDisk[idx].drive = i;
			GetDiskFreeSpaceEx(Drive, &arDisk[idx].Avail, &arDisk[idx].Total, NULL);
			idx++;
		}
	}
	//  ǥ
	arDisk[idx].drive = '0';
	InvalidateRect(win_hWnd, NULL, TRUE);
	return 0;
}

void CDiskUsage::OnDraw(HDC hdc, RECT crt)
{
	TCHAR str[111];
	TCHAR percent[111];
	HFONT oldFont;
	int y;
	int maxTotal = 0;
	HBRUSH uesdGraph;
	RECT urt;
	const int Thick = 12;
	HPEN pen, oldPen;

	oldFont = (HFONT)SelectObject(hdc, mainFont);
	SetBkMode(hdc, TRANSPARENT);
	uesdGraph = CreateSolidBrush(RGB(0, 255, 0));
	pen = CreatePen(PS_SOLID, 1, RGB(192, 192, 192));
	oldPen = (HPEN)SelectObject(hdc, pen);

	// ִ 뷮 ã´.
	for (int idx = 0; arDisk[idx].drive != '0'; idx++) {
		int total = int(arDisk[idx].Total.QuadPart / 1073741824);
		if (total > maxTotal) maxTotal = total;
	}

	y = 2 + 7;
	for (int idx = 0; arDisk[idx].drive != '0'; idx++) {
		wsprintf(str, L"%c", arDisk[idx].drive);
		TextOutVCenter(hdc, 2, y, str);

		int total = int(arDisk[idx].Total.QuadPart / 1073741824);
		int avail = int(arDisk[idx].Avail.QuadPart / 1073741824);
		int used = total - avail;

		//  20,  5ŭ   ׷ ׸
		int gwidth = crt.right - 25;
		//  ̺ ׷ 
		int dwidth;
		if (relativeChart) {
			dwidth = gwidth * total / maxTotal;
		} else {
			dwidth = gwidth;
		}

		// ׷ ܰ ׸
		Rectangle(hdc, 20, y - Thick / 2, 20 + dwidth, y + Thick / 2);
		// 뷮 . ׷ 輱 ʿ ׸.
		int uwidth = (dwidth - 2) * used / total;
		SetRect(&urt, 21, y - (Thick / 2 - 1), 21 + uwidth, y + (Thick / 2 - 1));
		FillRect(hdc, &urt, uesdGraph);

		y += 15;
		wsprintf(str, L"%d-%d=%d", total, used, avail);
		//   120  ̻  
		if (crt.right > 120) {
			wsprintf(percent, L"(%d%%)", avail * 100 / total);
			lstrcat(str, percent);
		}
		TextOutVCenter(hdc, 2, y, str);
		y += 15 + 5;
	}
	SelectObject(hdc, oldFont);
	DeleteObject(uesdGraph);
	DeleteObject(SelectObject(hdc, oldPen));
}

INT_PTR CALLBACK DiskUsageDlgProc(HWND hDlg, UINT iMessage, WPARAM wParam, LPARAM lParam)
{
	static CDiskUsage* pWidget;
	int radio = 0;

	switch (iMessage) {
	case WM_INITDIALOG:
		pWidget = (CDiskUsage*)lParam;
		MovePopupToSide(hDlg, pWidget->win_x, pWidget->win_y);

		SendDlgItemMessage(hDlg, IDC_CHKRELATIVECHART, BM_SETCHECK, pWidget->relativeChart ? BST_CHECKED : BST_UNCHECKED, 0);
		SendDlgItemMessage(hDlg, IDC_CHKREMOVABLE, BM_SETCHECK, pWidget->includeRemovable ? BST_CHECKED : BST_UNCHECKED, 0);
		SendDlgItemMessage(hDlg, IDC_CHKNETWORK, BM_SETCHECK, pWidget->includeNetwork ? BST_CHECKED : BST_UNCHECKED, 0);

		return TRUE;
	case WM_NCACTIVATE:
		if (wParam == FALSE && hOptionPopup != NULL) {
			pWidget->relativeChart = IsDlgButtonChecked(hDlg, IDC_CHKRELATIVECHART);
			pWidget->includeRemovable = IsDlgButtonChecked(hDlg, IDC_CHKREMOVABLE);
			pWidget->includeNetwork = IsDlgButtonChecked(hDlg, IDC_CHKNETWORK);
			SendMessage(pWidget->win_hWnd, WM_TIMER, 1, 0);
			InvalidateRect(pWidget->win_hWnd, NULL, TRUE);

			// ⼭ ıϸ WM_NCACTIVATE .      ıؾ Ѵ.
			hOptionPopup = NULL;
			DestroyWindow(hDlg);
		}
		return TRUE;
	case WM_COMMAND:
		switch (LOWORD(wParam)) {
			// ESC ư   Ѵ.
		case IDCANCEL:
			hOptionPopup = NULL;
			DestroyWindow(hDlg);
			return TRUE;
		}
		break;
	}
	return FALSE;
}

LRESULT CDiskUsage::OnContextMenu(WPARAM wParam, LPARAM lParam)
{
	if (!IsWindow(hOptionPopup)) {
		hOptionPopup = CreateDialogParam(g_hInst, MAKEINTRESOURCE(IDD_DISKUSAGE),
			win_hWnd, DiskUsageDlgProc, (LPARAM)this);
		ShowWindow(hOptionPopup, SW_SHOW);
	}
	return 0;
}

LRESULT CBattery::OnTimer(WPARAM wParam, LPARAM lParam)
{
	GetSystemPowerStatus(&sps);
	InvalidateRect(win_hWnd, NULL, TRUE);
	return 0;
}

void CBattery::OnDraw(HDC hdc, RECT crt)
{
	HFONT OldFont, font;
	HBRUSH brush, oldbrush;
	brush = CreateSolidBrush(RGB(255, 0, 0));
	UINT oldAlign;
	SetBkMode(hdc, TRANSPARENT);

	TCHAR ac[128];
	TCHAR remain[128] = L"";
	TCHAR percent[128];
	if (sps.ACLineStatus) {
		lstrcpy(ac, L"");
	} else {
		if (sps.BatteryLifeTime != (DWORD)-1) {
			if (sps.BatteryLifeTime >= 3600) {
				wsprintf(remain, L"%d:%d", sps.BatteryLifeTime / 3600, sps.BatteryLifeTime % 3600 / 60);
			} else {
				wsprintf(remain, L"%d", sps.BatteryLifeTime % 3600 / 60);
			}
			wsprintf(ac, L"͸(%s)", remain);
		} else {
			lstrcpy(ac, L"͸");
		}
	}
	wsprintf(percent, L"%d%%", sps.BatteryLifePercent);

	if (bVertical) {
		OldFont = (HFONT)SelectObject(hdc, mainFont);
		TextOutVCenter(hdc, 5, crt.bottom / 4, ac);
		SelectObject(hdc, OldFont);

		font = CreateFont(18, 0, 0, 0, 0, 0, 0, 0, ANSI_CHARSET, 3, 2, 1,
			VARIABLE_PITCH | FF_SWISS, TEXT("Arial"));
		OldFont = (HFONT)SelectObject(hdc, font);
		oldAlign = SetTextAlign(hdc, TA_RIGHT);
		TextOutVCenter(hdc, crt.right - 5, crt.bottom / 4, percent);
		SetTextAlign(hdc, oldAlign);
		SelectObject(hdc, OldFont);
		DeleteObject(font);

		// ¿ ڿ    20 ߾ 
		Rectangle(hdc, 5, crt.bottom / 2, crt.right - 5, crt.bottom / 2 + 20);
		int width = crt.right - 14;
		int gaugewidth = sps.BatteryLifePercent * width / 100;
		oldbrush = (HBRUSH)SelectObject(hdc, brush);
		Rectangle(hdc, 5, crt.bottom / 2 + 2, 7 + gaugewidth, crt.bottom / 2 + 20 - 2);
		SelectObject(hdc, oldbrush);
	} else {
		OldFont = (HFONT)SelectObject(hdc, mainFont);
		TextOut2(hdc, crt.right / 4, crt.bottom / 4, ac);
		SelectObject(hdc, OldFont);

		int gcenter = crt.right * 3 / 4;
		Rectangle(hdc, gcenter - 10, 5, gcenter + 10, crt.bottom - 5);
		int height = crt.bottom - 14;
		int gaugeheight = sps.BatteryLifePercent * height / 100;
		oldbrush = (HBRUSH)SelectObject(hdc, brush);
		Rectangle(hdc, gcenter - 8, crt.bottom - 5 - gaugeheight, gcenter + 8, crt.bottom - 5);
		SelectObject(hdc, oldbrush);

		font = CreateFont(17, 0, 0, 0, 0, 0, 0, 0, ANSI_CHARSET, 3, 2, 1,
			VARIABLE_PITCH | FF_SWISS, TEXT("Arial"));
		OldFont = (HFONT)SelectObject(hdc, font);
		TextOut2(hdc, crt.right / 4, crt.bottom / 2, percent);
		SelectObject(hdc, OldFont);
		DeleteObject(font);
	}

	DeleteObject(brush);
	SelectObject(hdc, OldFont);
}

//      Լ
static WNDPROC CalcOldEditProc;
double CalcExp(TCHAR* exp, BOOL* bError/*=NULL*/);
double CalcPostfix(TCHAR* Post);
void MakePostfix(TCHAR* Post, TCHAR* Mid);
int GetPriority(int op);
LRESULT CALLBACK EditProc(HWND hWnd, UINT iMessage, WPARAM wParam, LPARAM lParam);

//  . Ŭ Ʈ θ Լ ȣ     ޽ ó
LRESULT CCalc::OnUser1(WPARAM wParam, LPARAM lParam)
{
	TCHAR sExp[256];
	BOOL bError;

	GetWindowText(hCbExp, sExp, 256);
	calcResult = CalcExp(sExp, &bError);
	if (bError) {
		lstrcpy(sResult, L" ߸Ǿϴ.");
	} else {
		// ޺ Ͽ .    INI Ͽ   δ ͵   . 
		SendMessage(hCbExp, CB_INSERTSTRING, 0, (LPARAM)sExp);

		_stprintf_s(sResult, TEXT("= %f"), calcResult);
		TrimTrailZero(sResult);

		// ڵ  
		if (autoCopy) {
			CopyResult();
		}
	}
	InvalidateRect(win_hWnd, NULL, TRUE);
	return 0;
}

//    ø
LRESULT CCalc::OnUser2(WPARAM wParam, LPARAM lParam)
{
	TCHAR str[128];
	HWND hEdit;
	int len;

	_stprintf_s(str, TEXT("%f"), calcResult);
	TrimTrailZero(str);
	lstrcat(str, L" ");
	SetWindowText(hCbExp, str);

	// ڿ  ϳ  ־ ְ  ̵  Ŀ ش. 
	SetFocus(hCbExp);
	hEdit = GetWindow(hCbExp, GW_CHILD);
	len = GetWindowTextLength(hEdit);
	SendMessage(hEdit, EM_SETSEL, len, len);
	return 0;
}

LRESULT CCalc::OnCreate(WPARAM wParam, LPARAM lParam) {
	hCbExp = CreateWindow(TEXT("combobox"), TEXT(""), WS_CHILD | WS_VISIBLE | CBS_DROPDOWN | CBS_AUTOHSCROLL,
		2, 2, 160, 125, win_hWnd, (HMENU)1, g_hInst, NULL);
	SendMessage(hCbExp, WM_SETFONT, (WPARAM)mainFont, MAKELPARAM(FALSE, 0));
	// ޺  Ʈ ŬϿ EnterŰ Է Ѵ.
	hEdit=GetWindow(hCbExp,GW_CHILD);
	CalcOldEditProc = (WNDPROC)SetWindowLongPtr(hEdit, GWLP_WNDPROC, (LONG_PTR)EditProc);

	//  ư
	hBtnCopy = CreateWindow(TEXT("GrpBtn"), NULL, WS_CHILD | WS_VISIBLE | GBS_PUSH,
		0, 0, 16, 16, win_hWnd, (HMENU)2, g_hInst, NULL);
	SendMessage(hBtnCopy, GBM_SETIMAGE, MAKEWPARAM(IDB_CALCCOPY_NOR, IDB_CALCCOPY_NOR),
		MAKEWPARAM(IDB_CALCCOPY_NOR, IDB_CALCCOPY_NOR));
	return 0;
}

LRESULT CCalc::OnSize(WPARAM wParam, LPARAM lParam)
{
	// ϴ θ ޼带  ȣϿ Ʈ óѴ.
	CWindow::OnSize(wParam, lParam);

	RECT crt;
	GetClientRect(win_hWnd, &crt);

	//  ߾ ϵ  ּ 2ȼ . 
	int y = (crt.bottom - 52) / 2;
	if (y < 2) y = 2;
	MoveWindow(hCbExp, 2, y, crt.right - 4, 125, TRUE);
	y += 25 + 2;
	MoveWindow(hBtnCopy, crt.right - 18, y, 16, 16, TRUE);

	return 0;
}

LRESULT CCalc::OnCommand(WPARAM wParam, LPARAM lParam)
{
	switch (LOWORD(wParam)) {
	case 2:
		CopyResult();
		break;
	case IDM_CALC_RESULTUP:
		SendMessage(win_hWnd, WM_USER + 2, 0, 0);
		break;
	case IDM_CALC_AUTOCOPY:
		autoCopy = !autoCopy;
		break;
	}
	return 0;
}

void CCalc::OnDraw(HDC hdc, RECT crt)
{
	HFONT oldFont;

	//  ư   ġ Ѵ.
	RECT wrt;
	GetWindowRect(hBtnCopy, &wrt);
	ScreenToClient(win_hWnd, (LPPOINT)&wrt.left);

	oldFont = (HFONT)SelectObject(hdc, mainFont);
	SetBkMode(hdc, TRANSPARENT);
	TextOut2(hdc, 2, wrt.top, sResult);
	SelectObject(hdc, oldFont);
}

LRESULT CCalc::OnContextMenu(WPARAM wParam, LPARAM lParam)
{
	HMENU hMenu, hPopup;
	hMenu = LoadMenu(g_hInst, MAKEINTRESOURCE(IDR_POPUPMENU));
	hPopup = GetSubMenu(hMenu, 1);

	// ڵ   ޴ ǥ
	if (autoCopy) {
		CheckMenuItem(hPopup, IDM_CALC_AUTOCOPY, MF_BYCOMMAND | MF_CHECKED);
	}

	TrackPopupMenu(hPopup, TPM_LEFTALIGN, (short)LOWORD(lParam),
		(short)HIWORD(lParam), 0, win_hWnd, NULL);
	DestroyMenu(hMenu);
	return 0;
}

void CCalc::CopyResult()
{
	TCHAR str[128];
	_stprintf_s(str, TEXT("%f"), calcResult);
	TrimTrailZero(str);

	HGLOBAL hmem;
	TCHAR* ptr;
	hmem = GlobalAlloc(GHND, (lstrlen(str) + 1) * sizeof(TCHAR));
	ptr = (TCHAR*)GlobalLock(hmem);
	memcpy(ptr, str, (lstrlen(str) + 1) * sizeof(TCHAR));
	GlobalUnlock(hmem);
	if (OpenClipboard(win_hWnd)) {
		EmptyClipboard();
		SetClipboardData(CF_UNICODETEXT, hmem);
		CloseClipboard();
	} else {
		GlobalFree(hmem);
	}
}

LRESULT CALLBACK EditProc(HWND hWnd, UINT iMessage, WPARAM wParam, LPARAM lParam)
{
	switch (iMessage) {
	case WM_KEYDOWN:
		if (wParam == VK_RETURN) {
			PostMessage(GetParent(GetParent(hWnd)), WM_USER + 1, 0, 0);
			return 0;
		}
		if (wParam == VK_TAB) {
			PostMessage(GetParent(GetParent(hWnd)), WM_USER + 2, 0, 0);
			break;
		}
		break;
	case WM_KEYUP:
	case WM_CHAR:
		if (wParam == VK_RETURN || wParam == VK_TAB) {
			return 0;
		}
		break;
	}

	return CallWindowProc(CalcOldEditProc, hWnd, iMessage, wParam, lParam);
}

int GetPriority(int op)
{
	switch (op) {
	case '(':
		return 0;
	case '+':
	case '-':
		return 1;
	case '*':
	case '/':
		return 2;
	case '^':
		return 3;
	}
	return 100;
}

void MakePostfix(TCHAR* Post, TCHAR* Mid)
{
	TCHAR *m = Mid;
	TCHAR *p = Post, c;
	TStack<TCHAR> cS(256);

	while (*m) {
		//  - ״ ϰ ڿ  ϳ Ѵ.
		if (isdigit(*m)) {
			while (isdigit(*m) || *m == '.') *p++ = *m++;
			*p++ = ' ';
		} else
			//  - ÿ ִ ڱ⺸  ڸ   ϰ ڽ ǪѴ.
			if (strchr("^*/+-", *m)) {
				while (cS.GetTop() != -1 && GetPriority(cS.GetValue(cS.GetTop())) >=
					GetPriority(*m)) {
					*p++ = cS.Pop();
				}
				cS.Push(*m++);
			} else
				//  ȣ - ǪѴ.
				if (*m == '(') {
					cS.Push(*m++);
				} else
					// ݴ ȣ -  ȣ   ؼ ϰ  ȣ .
					if (*m == ')') {
						for (;;) {
							c = cS.Pop();
							if (c == '(') break;
							*p++ = c;
						}
						m++;
					} else {
						m++;
					}
	}
	// ÿ  ڵ  .
	while (cS.GetTop() != -1) {
		*p++ = cS.Pop();
	}
	*p = 0;
}

double CalcPostfix(TCHAR *Post)
{
	TCHAR* p = Post;
	double num;
	double left, right;
	TStack<double> dS(256);

	while (*p) {
		// ڴ ÿ ִ´.
		if (isdigit(*p)) {
			num = _ttof(p);
			dS.Push(num);
			for (; isdigit(*p) || *p == '.'; p++) { ; }
		} else {
			// ڴ ÿ    ϰ ٽ ǪѴ.
			if (strchr("^*/+-", *p)) {
				right = dS.Pop();
				left = dS.Pop();
				switch (*p) {
				case '+':
					dS.Push(left + right);
					break;
				case '-':
					dS.Push(left - right);
					break;
				case '*':
					dS.Push(left * right);
					break;
				case '/':
					if (right == 0.0) {
						dS.Push(0.0);
					} else {
						dS.Push(left / right);
					}
					break;
				case '^':
					dS.Push(pow(left, right));
					break;
				}
			}
			//   Ǵ ڰ ƴ   ڷ
			p++;
		}
	}
	if (dS.GetTop() != -1) {
		num = dS.Pop();
	} else {
		num = 0.0;
	}
	return num;
}

double CalcExp(TCHAR* exp, BOOL* bError/*=NULL*/)
{
	TCHAR Post[256];
	TCHAR *p;
	int count;

	// ȣ ¦ ´ Ȯ.
	// todo : ,  ܿ ʿ  ִ Ȯ 
	if (bError != NULL) {
		for (p = exp, count = 0; *p; p++) {
			if (*p == '(') count++;
			if (*p == ')') count--;
		}
		*bError = (count != 0);
	}

	MakePostfix(Post, exp);
	return CalcPostfix(Post);
}

LRESULT CRadix::OnCreate(WPARAM wParam, LPARAM lParam)
{
	//  Ʈ ID  Ѵ.
	hEdit2 = CreateWindow(TEXT("edit"), NULL, WS_CHILD | WS_VISIBLE | WS_BORDER |
		ES_AUTOHSCROLL, 0, 0, 0, 0, win_hWnd, (HMENU)2, g_hInst, NULL);
	hEdit10 = CreateWindow(TEXT("edit"), NULL, WS_CHILD | WS_VISIBLE | WS_BORDER |
		ES_AUTOHSCROLL, 0, 0, 0, 0, win_hWnd, (HMENU)10, g_hInst, NULL);
	hEdit16 = CreateWindow(TEXT("edit"), NULL, WS_CHILD | WS_VISIBLE | WS_BORDER |
		ES_AUTOHSCROLL, 0, 0, 0, 0, win_hWnd, (HMENU)16, g_hInst, NULL);
	return 0;
}

LRESULT CRadix::OnSize(WPARAM wParam, LPARAM lParam)
{
	CWindow::OnSize(wParam, lParam);
	int width = LOWORD(lParam);
	int height = HIWORD(lParam);
	int center;
	
	// 2 10   ߰ ߾ ǥ ´.
	//  100  ̺ 13ȼ   Ű ´  ߾ Ѵ.
	if (width > 100) {
		center = height / 2 + 3;
	} else {
		center = height / 2 - 10;
	}

	//  ߾  2  25ø 10, 16 ߾ӿ . ̴  20
	// 2  20,  5ŭ  10 ݱ, 16   
	MoveWindow(hEdit2, 20, center - 25, width - 25, 20, TRUE);
	if (width > 100) {
		MoveWindow(hEdit10, 20, center, width / 2 - 20, 20, TRUE);
		MoveWindow(hEdit16, width / 2 + 25, center, width / 2 - 30, 20, TRUE);
	} else {
		//  100  10, 16   Ѵ.
		MoveWindow(hEdit10, 20, center, width - 25, 20, TRUE);
		MoveWindow(hEdit16, 20, center + 25, width- 25, 20, TRUE);
	}
	SendMessage(hEdit2, WM_SETFONT, (WPARAM)mainFont, MAKELPARAM(FALSE, 0));
	SendMessage(hEdit10, WM_SETFONT, (WPARAM)mainFont, MAKELPARAM(FALSE, 0));
	SendMessage(hEdit16, WM_SETFONT, (WPARAM)mainFont, MAKELPARAM(FALSE, 0));

	return 0;
}

void CRadix::OnDraw(HDC hdc, RECT crt)
{
	HFONT oldFont;
	int center;

	if (crt.right > 100) {
		center = crt.bottom / 2 + 3;
	} else {
		center = crt.bottom / 2 - 10;
	}

	oldFont = (HFONT)SelectObject(hdc, mainFont);
	SetBkMode(hdc, TRANSPARENT);
	SetTextAlign(hdc, TA_CENTER);

	// ĸ  ׸. 
	TextOutVCenter(hdc, 10, center - 12, L"2");
	TextOutVCenter(hdc, 10, center + 10, L"10");
	if (crt.right > 100) {
		TextOutVCenter(hdc, crt.right / 2 + 15, center + 10, L"16");
	} else {
		TextOutVCenter(hdc, 10, center + 35, L"16");
	}

	SelectObject(hdc, oldFont);
}

LRESULT CRadix::OnCommand(WPARAM wParam, LPARAM lParam)
{
	int num;
	TCHAR str[128];

	switch (LOWORD(wParam)) {
	case 10:
		switch (HIWORD(wParam)) {
		case EN_CHANGE:
			if (editByCode == false) {
				editByCode = TRUE;
				num = GetDlgItemInt(win_hWnd, 10, NULL, FALSE);
				memset(str, 0, 128 * sizeof(TCHAR));
				_itot_s<128>(num, str, 16);
				SetDlgItemText(win_hWnd, 16, str);
				_itot_s<128>(num, str, 2);
				SetDlgItemText(win_hWnd, 2, str);
				editByCode = FALSE;
			}
			return TRUE;
		}
		break;
	case 16:
		switch (HIWORD(wParam)) {
		case EN_CHANGE:
			if (editByCode == false) {
				editByCode = TRUE;
				GetDlgItemText(win_hWnd, 16, str, 128);
				num = _tcstoul(str, NULL, 16);
				SetDlgItemInt(win_hWnd, 10, num, FALSE);
				_itot_s<128>(num, str, 2);
				SetDlgItemText(win_hWnd, 2, str);
				editByCode = FALSE;
			}
			return TRUE;
		}
		break;
	case 2:
		switch (HIWORD(wParam)) {
		case EN_CHANGE:
			if (editByCode == false) {
				editByCode = TRUE;
				GetDlgItemText(win_hWnd, 2, str, 128);
				num = _tcstoul(str, NULL, 2);
				SetDlgItemInt(win_hWnd, 10, num, FALSE);
				_itot_s<128>(num, str, 16);
				SetDlgItemText(win_hWnd, 16, str);
				editByCode = FALSE;
			}
			return TRUE;
		}
		break;
	}
	return 0;
}

LRESULT CImageSlide::OnUser1(WPARAM wParam, LPARAM lParam)
{
	//   ¿  ϳ Ǹ     д.
	// ׷ Ŭ ٽ   ִ. 
	if (multiViewer == false) {
		pLastViewer = NULL;
	}
	return 0;
}

LRESULT CImageSlide::OnDropFiles(WPARAM wParam, LPARAM lParam)
{
	TCHAR Path[MAX_PATH];
	int Count, n, addCount = 0;
	int oldCount;
	TCHAR ext[MAX_PATH];

	oldCount = arImage.num;

	Count = DragQueryFile((HDROP)wParam, 0xffffffff, NULL, 0);
	for (n = 0; n < Count; n++) {
		DragQueryFile((HDROP)wParam, n, Path, MAX_PATH);
		// Ȯڸ ҹڷ ٲ  Ѵ.
		lstrcpy(ext, PathFindExtension(Path));
		_tcslwr(ext);
		if (lstrcmp(ext, L".jpg") == 0 || lstrcmp(ext, L".png") == 0) {
			arImage.Append(new sImagePath(Path));
			addCount++;
		}
	}
	SaveImageList();

	//  ߰ ̹ ٷ ̵ Ѵ. 
	if (addCount != 0) {
		nowIdx = oldCount - 1;
		SendMessage(win_hWnd, WM_TIMER, 1, 0);
	}
	return 0;
}

LRESULT CImageSlide::OnCreate(WPARAM wParam, LPARAM lParam)
{
	LoadSetting();
	LoadImageList();
	//  0 ϱ  -1 Ѵ.
	nowIdx = -1;
	nowImage = NULL;

	DragAcceptFiles(win_hWnd, TRUE);
	SetTimer(win_hWnd, 1, timerInterval * 1000, NULL);
	SendMessage(win_hWnd, WM_TIMER, 1, 0);

	return 0;
}

LRESULT CImageSlide::OnDestroy(WPARAM wParam, LPARAM lParam) {
	KillTimer(win_hWnd, 1);
	if (nowImage != NULL) {
		delete nowImage;
	}
	for (int i = 0; i < (int)arImage.num; i++) {
		delete arImage[i];
	}
	return 0;
}

void CImageSlide::LoadSetting()
{
	timerInterval = setting.get(dget_id, L"timerInterval", 5);
	randomSlide = setting.get(dget_id, L"randomSlide", false);
	displayFileName = setting.get(dget_id, L"displayFileName", false);
	multiViewer = setting.get(dget_id, L"multiViewer", false);
}

void CImageSlide::SaveSetting()
{
	setting.set(dget_id, L"timerInterval", timerInterval);
	setting.set(dget_id, L"randomSlide", randomSlide);
	setting.set(dget_id, L"displayFileName", displayFileName);
	setting.set(dget_id, L"multiViewer", multiViewer);
}

void CImageSlide::LoadImageList()
{
	TCHAR* buf;
	TCHAR* p, * pEnd;
	TCHAR oneFile[MAX_PATH];

	// ִ 1000 ̳ δ  .  5000    .
	int bufSize = MAX_PATH * 1000 * sizeof(TCHAR);
	buf = (TCHAR*)malloc(bufSize);
	setting.get(dget_id, L"ImageList", L"", buf, bufSize);
	arImage.Clear();
	for (p = buf; *p != 0;) {
		pEnd = _tcsstr(p, L"");
		memset(oneFile, 0, sizeof(oneFile));
		_tcsncpy(oneFile, p, pEnd - p);
		arImage.Append(new sImagePath(oneFile));
		p = pEnd + 1;
	}
	free(buf);
}

void CImageSlide::SaveImageList()
{
	TCHAR* buf;
	int num;

	// INI    ̾ ؼ ȵǴ. 
	//  ߴ INI б Լ      ũ ڷ Ѵ.
	//    0Ʈ Ҵ  Ƿ  ڿ̶ Ҵؾ Ѵ. 
	num = arImage.num;
	if (num == 0) {
		buf = (TCHAR*)calloc(128, sizeof(TCHAR));
	} else {
		buf = (TCHAR*)calloc(MAX_PATH * num, sizeof(TCHAR));
		for (int i = 0; i < (int)arImage.num; i++) {
			lstrcat(buf, arImage[i]->Path);
			lstrcat(buf, L"");
		}
	}
	setting.set(dget_id, L"ImageList", buf);
	free(buf);
}

LRESULT CImageSlide::OnTimer(WPARAM wParam, LPARAM lParam)
{
	// ̹ ̸ ƹ ͵  ʴ´.
	if (arImage.num == 0) {
		return 0;
	}

	// ޸ : nowIdx ù  -1 ʱȭǹǷ ̹ ϳۿ  Ʒ ڵ带 ؼ ȵȴ.

	//  ̹ ̵
	if (randomSlide) {
		int oldIdx = nowIdx;
		//     ޶ Ѵ.  ̹ ϳۿ    .
		for (;;) {
			nowIdx = random(arImage.num);
			if (arImage.num == 1) break;
			if (nowIdx != oldIdx) break;
		}
	} else {
		nowIdx++;
		if (nowIdx >= (int)arImage.num) {
			nowIdx = 0;
		}
	}

	//  ̹   ٽ 
	if (nowImage != NULL) {
		delete nowImage;
	}
	nowImage = Image::FromFile(arImage[nowIdx]->Path);
	FixImageOrientation(nowImage);
	InvalidateRect(win_hWnd, NULL, TRUE);
	return 0;
}

INT_PTR CALLBACK ImageSlideDlgProc(HWND hDlg, UINT iMessage, WPARAM wParam, LPARAM lParam)
{
	static CImageSlide* pWidget;
	int radio = 0;
	int list_count, list_idx, new_idx;
	TCHAR oneFile[MAX_PATH];

	switch (iMessage) {
	case WM_INITDIALOG:
		pWidget = (CImageSlide*)lParam;
		MovePopupToSide(hDlg, pWidget->win_x, pWidget->win_y);

		SendDlgItemMessage(hDlg, IDC_SPINIMAGECYCLE, UDM_SETRANGE, 0, MAKELPARAM(300, 1));
		SetDlgItemInt(hDlg, IDC_EDIMAGECYCLE, pWidget->timerInterval, FALSE);

		SendDlgItemMessage(hDlg, IDC_CHKRANDOMSLIDE, BM_SETCHECK, pWidget->randomSlide ? BST_CHECKED : BST_UNCHECKED, 0);
		SendDlgItemMessage(hDlg, IDC_CHKDISPLAYFILENAME, BM_SETCHECK, pWidget->displayFileName ? BST_CHECKED : BST_UNCHECKED, 0);
		SendDlgItemMessage(hDlg, IDC_CHKMULTIVIEWER, BM_SETCHECK, pWidget->multiViewer ? BST_CHECKED : BST_UNCHECKED, 0);

		// ̹  о ´. 
		for (int i = 0; i < (int)pWidget->arImage.num; i++) {
			SendDlgItemMessage(hDlg, IDC_LIIMGLIST, LB_ADDSTRING, 0, (LPARAM)pWidget->arImage[i]->Path);
		}
		return TRUE;
	case WM_NCACTIVATE:
		if (wParam == FALSE && hOptionPopup != NULL) {
			pWidget->timerInterval = GetDlgItemInt(hDlg, IDC_EDIMAGECYCLE, NULL, FALSE);
			pWidget->randomSlide = IsDlgButtonChecked(hDlg, IDC_CHKRANDOMSLIDE);
			pWidget->displayFileName = IsDlgButtonChecked(hDlg, IDC_CHKDISPLAYFILENAME);
			pWidget->multiViewer = IsDlgButtonChecked(hDlg, IDC_CHKMULTIVIEWER);
			SetTimer(pWidget->win_hWnd, 1, pWidget->timerInterval * 1000, NULL);

			//  .    Ѵ.
			pWidget->SaveSetting();

			//   籸.       ؾ . 
			for (int i = 0; i < (int)pWidget->arImage.num; i++) {
				delete pWidget->arImage[i];
			}
			pWidget->arImage.Clear();
			list_count = (int)SendDlgItemMessage(hDlg, IDC_LIIMGLIST, LB_GETCOUNT, 0, 0);
			for (int i = 0; i < list_count; i++) {
				SendDlgItemMessage(hDlg, IDC_LIIMGLIST, LB_GETTEXT, i, (LPARAM)oneFile);
				pWidget->arImage.Append(new sImagePath(oneFile));
			}

			//  . ȭ Ǵ ӽÿ Ѵ. 
			pWidget->SaveImageList();

			//     ȳ ޽ ٽ ׸ Ѵ.
			if (pWidget->arImage.num == 0) {
				InvalidateRect(pWidget->win_hWnd, NULL, TRUE);
			}

			// ⼭ ıϸ WM_NCACTIVATE .      ıؾ Ѵ.
			hOptionPopup = NULL;
			DestroyWindow(hDlg);
		}
		return TRUE;
	case WM_COMMAND:
		switch (LOWORD(wParam)) {
			// ESC ư   Ѵ.
		case IDCANCEL:
			hOptionPopup = NULL;
			DestroyWindow(hDlg);
			return TRUE;
		case IDC_BTNIS_RESET:
			SendDlgItemMessage(hDlg, IDC_LIIMGLIST, LB_RESETCONTENT, 0, 0);
			return TRUE;
		case IDC_BTNIS_DEL:
			list_idx = (int)SendDlgItemMessage(hDlg, IDC_LIIMGLIST, LB_GETCURSEL, 0, 0);
			if (list_idx != -1) {
				SendDlgItemMessage(hDlg, IDC_LIIMGLIST, LB_DELETESTRING, list_idx, 0);
				list_count = (int)SendDlgItemMessage(hDlg, IDC_LIIMGLIST, LB_GETCOUNT, 0, 0);
				//  ġ  ϵ    ׸ 
				new_idx = list_idx < list_count ? list_idx : list_count - 1;
				SendDlgItemMessage(hDlg, IDC_LIIMGLIST, LB_SETCURSEL, new_idx, 0);
			}
			return TRUE;
		// todo : 巡ؼ ̵ϴ  ʿ. ̹ ̸ Ⱑ ־     . 
		case IDC_BTNIS_UP:
			list_idx = (int)SendDlgItemMessage(hDlg, IDC_LIIMGLIST, LB_GETCURSEL, 0, 0);
			if (list_idx != -1 && list_idx != 0) {
				SendDlgItemMessage(hDlg, IDC_LIIMGLIST, LB_GETTEXT, list_idx, (LPARAM)oneFile);
				SendDlgItemMessage(hDlg, IDC_LIIMGLIST, LB_DELETESTRING, list_idx, 0);
				SendDlgItemMessage(hDlg, IDC_LIIMGLIST, LB_INSERTSTRING, list_idx - 1, (LPARAM)oneFile);
				new_idx = list_idx - 1;
				SendDlgItemMessage(hDlg, IDC_LIIMGLIST, LB_SETCURSEL, new_idx, 0);
			}
			return TRUE;
		case IDC_BTNIS_DOWN:
			list_idx = (int)SendDlgItemMessage(hDlg, IDC_LIIMGLIST, LB_GETCURSEL, 0, 0);
			list_count = (int)SendDlgItemMessage(hDlg, IDC_LIIMGLIST, LB_GETCOUNT, 0, 0);
			if (list_idx != -1 && list_idx != list_count - 1) {
				SendDlgItemMessage(hDlg, IDC_LIIMGLIST, LB_GETTEXT, list_idx, (LPARAM)oneFile);
				SendDlgItemMessage(hDlg, IDC_LIIMGLIST, LB_DELETESTRING, list_idx, 0);
				SendDlgItemMessage(hDlg, IDC_LIIMGLIST, LB_INSERTSTRING, list_idx + 1, (LPARAM)oneFile);
				new_idx = list_idx + 1;
				SendDlgItemMessage(hDlg, IDC_LIIMGLIST, LB_SETCURSEL, new_idx, 0);
			}
			return TRUE;
		}
		break;
	}
	return FALSE;
}

LRESULT CImageSlide::OnContextMenu(WPARAM wParam, LPARAM lParam)
{
	if (!IsWindow(hOptionPopup)) {
		hOptionPopup = CreateDialogParam(g_hInst, MAKEINTRESOURCE(IDD_IMAGESLIDE),
			win_hWnd, ImageSlideDlgProc, (LPARAM)this);
		ShowWindow(hOptionPopup, SW_SHOW);
	}
	return 0;
}

void CImageSlide::OnDraw(HDC hdc, RECT crt)
{
	//   ȳ ޽ Ѵ. 
	if (arImage.num == 0) {
		InflateRect(&crt, -2, -5);
		SetTextColor(hdc, RGB(255, 255, 0));
		SetBkMode(hdc, TRANSPARENT);
		HFONT oldFont;
		oldFont = (HFONT)SelectObject(hdc, mainFont);
		LPCTSTR mes = L"̹ ̴\r\n׷ (*.jpg, *.png) 巡Ͽ Ͽ ߰Ͻʽÿ.";
		DrawText(hdc, mes, -1, &crt, DT_WORDBREAK);
		SelectObject(hdc, oldFont);
		return;
	}

	DrawImageCenter(hdc, nowImage, crt.right, crt.bottom, false, win_backBrush);

	// ϸ 
	if (displayFileName) {
		SetTextColor(hdc, RGB(255, 255, 0));
		SetBkMode(hdc, TRANSPARENT);
		SetTextAlign(hdc, TA_CENTER | TA_BASELINE);
		HFONT oldFont;
		oldFont = (HFONT)SelectObject(hdc, mainFont);
		TCHAR *p = _tcsrchr(arImage[nowIdx]->Path, '\\');
		p++;
		TextOut2(hdc, crt.right / 2, crt.bottom - 2, p);
		SelectObject(hdc, oldFont);
	}
}

LRESULT CImageSlide::OnLButtonDown(WPARAM wParam, LPARAM lParam)
{
	//   Ѵ.
	if (nowIdx == -1) return 0;

	//   ¿ ̹    ̹ ȣ  ˷ ش.
	if (multiViewer == false && pLastViewer != NULL) {
		SendMessage(pLastViewer->win_hWnd, WM_USER + 1, nowIdx, NULL);
	} else {
		CImageViewer* pImgViewer;
		pImgViewer = new CImageViewer();
		pImgViewer->nowIdx = nowIdx;
		pImgViewer->Create(0, this);
		pLastViewer = pImgViewer;
	}

	return 0;
}

// ̹   todo - ⺻     Ŀ õõ  
// ŸƲ ϰ β  θ   巡ؼ ũ . ٴ 巡ؼ ̵
// 콺  ö󰡸 ϸ ݱ, ִȭ ư  . Ǵ   β ؼ ׻ ǥõ 
// Ȯ, , д, ȸ, ݻ,    . ̴  PgUp, PgDn ׺̼ ̵
void CImageViewer::Create(int parentType, CDget *parent)
{
	// ŸԿ  θ ĳ д.  ̴   迩 C ŸϷ  Ѵ.
	// CWindow    pParent ٷ  ȴ. 
	pParent = parent;
	this->parentType = parentType;
	switch (parentType) {
	case 0:
		pSlide = (CImageSlide* )pParent;
		break;
	case 1:
		pOneImage = (COneImage*)pParent;
		break;
	}

	CreateWindow(TEXT("CWindow"), L"̹ ", WS_POPUPWINDOW | WS_THICKFRAME | WS_CAPTION,
		0, 0, 0, 0,
		NULL, (HMENU)NULL, g_hInst, this);

	//   ġ о´. ϴ 븻 ǥ ʱ ǥ ´.
	prevWndPlace.length = sizeof(WINDOWPLACEMENT);
	prevWndPlace.flags = 0;
	prevWndPlace.rcNormalPosition.left = setting.get(pParent->dget_id, L"left", 10);
	prevWndPlace.rcNormalPosition.top = setting.get(pParent->dget_id, L"top", 10);
	prevWndPlace.rcNormalPosition.right = setting.get(pParent->dget_id, L"right", 650);
	prevWndPlace.rcNormalPosition.bottom = setting.get(pParent->dget_id, L"bottom", 490);
	prevWndPlace.showCmd = setting.get(pParent->dget_id, L"showCmd", SW_SHOWNORMAL);
	SetWindowPlacement(win_hWnd, &prevWndPlace);

	// ü ȭ ȯѴ. 
	fullScreen = setting.get(pParent->dget_id, L"fullScreen", false);
	if (fullScreen) {
		prevWndPlace.length = sizeof(WINDOWPLACEMENT);
		GetWindowPlacement(win_hWnd, &prevWndPlace);
		makeFullScreen(win_hWnd);
	}
}

LRESULT CImageViewer::OnLButtonDblClk(WPARAM wParam, LPARAM lParam)
{
	// ϴ Ŭ ִȭѴ.  ٸ  ü .
	toggleFullScreen();
	return 0;
}

LRESULT CImageViewer::OnUser1(WPARAM wParam, LPARAM lParam)
{
	// wParam   ̹ ǥѴ.
	if (nowImage != NULL) {
		delete nowImage;
	}
	nowIdx = (int)wParam;
	nowImage = Image::FromFile(pSlide->arImage[nowIdx]->Path);
	SetWindowText(win_hWnd, pSlide->arImage[nowIdx]->Path);
	InvalidateRect(win_hWnd, NULL, TRUE);
	return 0;
}

LRESULT CImageViewer::OnCreate(WPARAM wParam, LPARAM lParam)
{
	// ̴ idx ְ, OneImage θ  ش.
	LPCTSTR Path;
	if (parentType == 0) {
		Path = pSlide->arImage[nowIdx]->Path;
	} else {
		Path = imagePath;
	}
	nowImage = Image::FromFile(Path);
	FixImageOrientation(nowImage);
	SetWindowText(win_hWnd, Path);
	return 0;
}

LRESULT CImageViewer::OnDestroy(WPARAM wParam, LPARAM lParam)
{
	if (nowImage != NULL) {
		delete nowImage;
	}

	//   ġ Ѵ. , ü ȭ ̸ ü ȭ  븻 ǥ Ѵ.
	if (fullScreen == false) {
		prevWndPlace.length = sizeof(WINDOWPLACEMENT);
		GetWindowPlacement(win_hWnd, &prevWndPlace);
	}

	setting.set(pParent->dget_id, L"left", (int)prevWndPlace.rcNormalPosition.left);
	setting.set(pParent->dget_id, L"top", (int)prevWndPlace.rcNormalPosition.top);
	setting.set(pParent->dget_id, L"right", (int)prevWndPlace.rcNormalPosition.right);
	setting.set(pParent->dget_id, L"bottom", (int)prevWndPlace.rcNormalPosition.bottom);
	setting.set(pParent->dget_id, L"showCmd", (int)prevWndPlace.showCmd);
	setting.set(pParent->dget_id, L"fullScreen", (int)fullScreen);

	// θ𿡰 ڽ  ˸. ׷ Ŭ ο    ִ. 
	SendMessage(pParent->win_hWnd, WM_USER + 1, 0, 0);

	// ڱ ڽ Ѵ. üʿ ȴ. -> ̷   NCDESTROY ó  ٿ. -> θ     ϴ. 
	// delete this;
	return 0;
}

LRESULT CImageViewer::OnPaint(WPARAM wParam, LPARAM lParam)
{
	HDC hdc;
	PAINTSTRUCT ps;
	hdc = BeginPaint(win_hWnd, &ps);
	RECT crt;
	GetClientRect(win_hWnd, &crt);

	// θ  귯 
	DrawImageCenter(hdc, nowImage, crt.right, crt.bottom, true, pParent->win_backBrush);

	EndPaint(win_hWnd, &ps);
	return 0;
}

LRESULT CImageViewer::OnSize(WPARAM wParam, LPARAM lParam)
{
	InvalidateRect(win_hWnd, NULL, TRUE);
	return 0;
}

LRESULT CImageViewer::OnKeyDown(WPARAM wParam, LPARAM lParam)
{
	if (wParam == VK_ESCAPE) {
		DestroyWindow(win_hWnd);
	}
	if (wParam == VK_RETURN) {
		toggleFullScreen();
	}

	return 0;
}

void CImageViewer::toggleFullScreen()
{
	fullScreen = !fullScreen;
	if (fullScreen) {
		// ü ȭ ȯϱ  븻 ǥ ̸  д.
		prevWndPlace.length = sizeof(WINDOWPLACEMENT);
		GetWindowPlacement(win_hWnd, &prevWndPlace);
		makeFullScreen(win_hWnd);
	} else {
		SetWindowLongPtr(win_hWnd, GWL_STYLE, WS_POPUPWINDOW | WS_CAPTION | WS_THICKFRAME | WS_VISIBLE);
		SetWindowPos(win_hWnd, HWND_NOTOPMOST, 0, 0, 0, 0,
			SWP_NOMOVE | SWP_NOSIZE | SWP_FRAMECHANGED);
		// 븻 ǥ ٽ Ѵ. 
		prevWndPlace.length = sizeof(WINDOWPLACEMENT);
		SetWindowPlacement(win_hWnd, &prevWndPlace);
	}
}

//   todo
// Ʈ ˾ -   ,  , ̵. ̵ 巡 &   
//  ܿ ,   Ű ϴ  ۼϰ  ó
LRESULT CMusicPlayer::OnMessage(UINT iMessage, WPARAM wParam, LPARAM lParam) {
	switch (iMessage)
	{
	case MM_MCINOTIFY:
		switch (wParam) {
		case MCI_NOTIFY_ABORTED:
			// MCI_STOP  ABORTED   ⼭ ġ ݴ´. 
			mciSendCommand(LOWORD(lParam), MCI_CLOSE, 0, (DWORD)NULL);
			dev_id = 0;
			break;
		case MCI_NOTIFY_SUCCESSFUL:
			// Ѱ  Ϸ. ̶ ̹ STOP ̴. ġ     . 
			mciSendCommand(LOWORD(lParam), MCI_CLOSE, 0, (DWORD)NULL);
			dev_id = 0;

			//  ׷   ̵  Ѵ.
			if (randomPlay) {
				playIdx = SelectRandomPlay();
			} else {
				moveNext(playIdx, arMusic[playGroup].num);
			}
			groupIdx[playGroup] = playIdx;
			//  ׷ ̴ ̸ Ʈ ڽ Ŀ Ű ش.
			if (GetActiveGroup() == playGroup) {
				SendMessage(hList, LB_SETCURSEL, playIdx, 0);
			}
			DoPlayCurrent(true);
			break;
		}
		return 0;
	case WM_HSCROLL:
		if (lParam == (LPARAM)hProg) {
			if (dev_id != 0) {
				//  ߰ α׷ ġ ٽ Ѵ. 
				mciSendCommand(dev_id, MCI_STOP, 0, (DWORD)NULL);
				SetTimer(win_hWnd, MPTM_MOVEPOS, 100, NULL);
			}
		}
		return 0;
	case WM_HOTKEY:
		switch (wParam) {
		case 0:
			PostMessage(win_hWnd, WM_COMMAND, MAKEWPARAM(MP_PLAY, 0), 0);
			break;
		}
		return 0;
	}

	return CWindow::OnMessage(iMessage, wParam, lParam);
}


LRESULT CMusicPlayer::OnCreate(WPARAM wParam, LPARAM lParam)
{
	// ý   귯  ->  ϳ ũ , ư    ƴϾ . 
	// Ʈʿ       ۿ .  PNG  ϸ   
	//win_color = GetSysColor(COLOR_BTNFACE);
	//win_backBrush = CreateSolidBrush(win_color);

	hPlay = CreateWindow(L"GrpBtn", NULL, WS_CHILD | WS_VISIBLE, 2, 2, 24, 16, win_hWnd, (HMENU)MP_PLAY, g_hInst, NULL);
	SendMessage(hPlay, GBM_SETIMAGE, MAKEWPARAM(IDB_PLAYNORMAL, IDB_PLAYHOT), MAKEWPARAM(IDB_PLAYDOWN, IDB_PLAYNORMAL));
	hStop = CreateWindow(L"GrpBtn", NULL, WS_CHILD | WS_VISIBLE, 28, 2, 16, 16, win_hWnd, (HMENU)MP_STOP, g_hInst, NULL);
	SendMessage(hStop, GBM_SETIMAGE, MAKEWPARAM(IDB_STOPNORMAL, IDB_STOPHOT), MAKEWPARAM(IDB_STOPDOWN, IDB_STOPNORMAL));
	hPrev = CreateWindow(L"GrpBtn", NULL, WS_CHILD | WS_VISIBLE, 46, 2, 16, 16, win_hWnd, (HMENU)MP_PREV, g_hInst, NULL);
	SendMessage(hPrev, GBM_SETIMAGE, MAKEWPARAM(IDB_PREVNORMAL, IDB_PREVHOT), MAKEWPARAM(IDB_PREVDOWN, IDB_PREVNORMAL));
	hNext = CreateWindow(L"GrpBtn", NULL, WS_CHILD | WS_VISIBLE, 64, 2, 16, 16, win_hWnd, (HMENU)MP_NEXT, g_hInst, NULL);
	SendMessage(hNext, GBM_SETIMAGE, MAKEWPARAM(IDB_NEXTNORMAL, IDB_NEXTHOT), MAKEWPARAM(IDB_NEXTDOWN, IDB_NEXTNORMAL));
	hRandom = CreateWindow(L"GrpBtn", NULL, WS_CHILD | WS_VISIBLE | GBS_CHECK, 90, 2, 16, 16, win_hWnd, (HMENU)MP_RANDOM, g_hInst, NULL);
	SendMessage(hRandom, GBM_SETIMAGE, MAKEWPARAM(IDB_MPRANDOMOFF, IDB_MPRANDOMOFF), MAKEWPARAM(IDB_MPRANDOMON, IDB_MPRANDOMOFF));

	hProg = CreateWindow(L"GrpScrl", NULL, WS_CHILD | WS_VISIBLE | GSS_HORZ, 2, 20, 128, 14, win_hWnd, (HMENU)MP_PROG, g_hInst, NULL);
	SendMessage(hProg, GSM_SETBACKCOLOR, (WPARAM)RGB(240, 240, 240), 0);

	hGroup1 = CreateWindow(L"GrpBtn", NULL, WS_CHILD | WS_VISIBLE | GBS_CHECK, 2, 38, 16, 12, win_hWnd, (HMENU)MP_GROUP1, g_hInst, NULL);
	SendMessage(hGroup1, GBM_SETIMAGE, MAKEWPARAM(IDB_GROUP1UP, IDB_GROUP1UP), MAKEWPARAM(IDB_GROUP1DOWN, IDB_GROUP1DOWN));
	hGroup2 = CreateWindow(L"GrpBtn", NULL, WS_CHILD | WS_VISIBLE | GBS_CHECK, 18, 38, 16, 12, win_hWnd, (HMENU)MP_GROUP2, g_hInst, NULL);
	SendMessage(hGroup2, GBM_SETIMAGE, MAKEWPARAM(IDB_GROUP2UP, IDB_GROUP2UP), MAKEWPARAM(IDB_GROUP2DOWN, IDB_GROUP2DOWN));
	hGroup3 = CreateWindow(L"GrpBtn", NULL, WS_CHILD | WS_VISIBLE | GBS_CHECK, 34, 38, 16, 12, win_hWnd, (HMENU)MP_GROUP3, g_hInst, NULL);
	SendMessage(hGroup3, GBM_SETIMAGE, MAKEWPARAM(IDB_GROUP3UP, IDB_GROUP3UP), MAKEWPARAM(IDB_GROUP3DOWN, IDB_GROUP3DOWN));
	hGroup4 = CreateWindow(L"GrpBtn", NULL, WS_CHILD | WS_VISIBLE | GBS_CHECK, 50, 38, 16, 12, win_hWnd, (HMENU)MP_GROUP4, g_hInst, NULL);
	SendMessage(hGroup4, GBM_SETIMAGE, MAKEWPARAM(IDB_GROUP4UP, IDB_GROUP4UP), MAKEWPARAM(IDB_GROUP4DOWN, IDB_GROUP4DOWN));

	hAdd = CreateWindow(L"GrpBtn", NULL, WS_CHILD | WS_VISIBLE, 0, 0, 16, 16, win_hWnd, (HMENU)MP_ADD, g_hInst, NULL);
	SendMessage(hAdd, GBM_SETIMAGE, MAKEWPARAM(IDB_MPADDNORM, IDB_MPADDHOT), MAKEWPARAM(IDB_MPADDDOWN, IDB_MPADDNORM));
	hClear = CreateWindow(L"GrpBtn", NULL, WS_CHILD | WS_VISIBLE, 0, 0, 16, 16, win_hWnd, (HMENU)MP_CLEAR, g_hInst, NULL);
	SendMessage(hClear, GBM_SETIMAGE, MAKEWPARAM(IDB_MPCLEARNORM, IDB_MPCLEARHOT), MAKEWPARAM(IDB_MPCLEARDOWN, IDB_MPCLEARNORM));

	hList = CreateWindow(TEXT("listbox"), NULL, WS_CHILD | WS_VISIBLE | WS_BORDER |
		LBS_NOTIFY | WS_VSCROLL | LBS_NOINTEGRALHEIGHT, 2, 50, 120, 100, win_hWnd, (HMENU)MP_LIST, g_hInst, NULL);
	SendMessage(hList, WM_SETFONT, (WPARAM)mainFont, MAKELPARAM(FALSE, 0));

	//     ҷ ´.    . 
	// Ǵ  ÷ ΰ ÿ ϰ ϴ    
	LoadMusicList();

	//   ׷ Ͽ Ѵ. Ʈ ù ׷
	playGroup = setting.get(dget_id, L"playGroup", 0);
	playIdx = setting.get(dget_id, L"playIdx", -1);

	//  ׷  ð Ѵ.   쵵 ־ Ʈ  ̴. 
	TCHAR key[32];
	for (int group = 0; group < 4; group++) {
		wsprintf(key, L"groupIdx%d", group);
		groupIdx[group] = setting.get(dget_id, key, -1);
	}
	//  ׷   Ѵ. 3  5   ص ٽ ϸ 3 Ѵ.
	groupIdx[playGroup] = playIdx;

	//    
	randomPlay = setting.get(dget_id, L"randomPlay", 0);
	if (randomPlay) {
		SendMessage(hRandom, GBM_SETSTATE, GB_DOWN, 0);
	}

	//  ׷ ϰ  ä ִ´. 
	ChangeActiveGroup(playGroup, true);
	FillListBox(playGroup);

	DragAcceptFiles(win_hWnd, TRUE);
	dev_id = 0;

	// α׷ ſ Ÿ̸. ֱ Ѵ. 
	SetTimer(win_hWnd, MPTM_PROG, 200, NULL);

	// PauseŰ  Ű Ѵ. ٸ α׷ ̹    ִ. 
	if (RegisterHotKey(win_hWnd, 0, 0, VK_PAUSE) == FALSE) {
		// Ҹ   ˸    Ѵ. 
		#ifndef _DEBUG
		MessageBeep(0);
		#endif
	}

	// ӽ  θ ̸  д. 
	// todo :    ƴ ޸   ϴ    
	GetModuleFileName(NULL, stripPath, MAX_PATH);
	TCHAR* bs = _tcsrchr(stripPath, '\\');
	*(bs + 1) = 0;
	lstrcat(stripPath, L"SoEnty-temp.mp3");

	return 0;
}

LRESULT CMusicPlayer::OnDestroy(WPARAM wParam, LPARAM lParam)
{
	//  ׷ Ѵ. 
	setting.set(dget_id, L"playGroup", playGroup);
	setting.set(dget_id, L"playIdx", playIdx);
	setting.set(dget_id, L"randomPlay", randomPlay);

	TCHAR key[32];
	//  ׷  idx Ѵ.
	for (int group = 0; group < 4; group++) {
		wsprintf(key, L"groupIdx%d", group);
		setting.set(dget_id, key, groupIdx[group]);
		// ׷    ۸ . 
		for (int i = 0; i < (int)arMusic[group].num; i++) {
			delete arMusic[group][i];
		}
	}

	KillTimer(win_hWnd, MPTM_PROG);
	UnregisterHotKey(win_hWnd, 0);
	return 0;
}

LRESULT CMusicPlayer::OnSize(WPARAM wParam, LPARAM lParam)
{
	CWindow::OnSize(wParam, lParam);

	// ó ô ũⰡ 0ε ̶ ġ . 
	//  ׷ ũ   Ͻ 0 Ǿ  4 پ  . ũ ٿ پ ũ ϴ  ʿ
	int width = LOWORD(lParam);
	if (width == 0) return 0;

	MoveWindow(hProg, 2, 20, width - 4, 14, TRUE);
	MoveWindow(hList, 2, 50, width - 4, HIWORD(lParam) - 48, TRUE);
	MoveWindow(hAdd, width - 36, 34, 16, 16, TRUE);
	MoveWindow(hClear, width - 18, 34, 16, 16, TRUE);

	return 0;
}

LRESULT CMusicPlayer::OnTimer(WPARAM wParam, LPARAM lParam)
{
	switch (wParam) {
	// α׷ .   ֱ 
	case MPTM_PROG:
		if (dev_id != 0) {
			SendMessage(hProg, GSM_SETPOS, GetPosition(), 0);
		}
		break;
	//  Ŭ     
	case MPTM_PLAYACTIVE:
		KillTimer(win_hWnd, MPTM_PLAYACTIVE);
		PlayActiveCurrent();
		break;
	//   ̵
	case MPTM_PLAYNEXT:
		KillTimer(win_hWnd, MPTM_PLAYNEXT);
		DoPlayCurrent(true);
		break;
	//   ̵
	case MPTM_PLAYPREV:
		KillTimer(win_hWnd, MPTM_PLAYPREV);
		DoPlayCurrent(false);
		break;
	//  ġ ̵.  ũ   ġ  
	case MPTM_MOVEPOS:
		KillTimer(win_hWnd, MPTM_MOVEPOS);
		DoPlay(arMusic[playGroup][groupIdx[playGroup]]->Path, SendMessage(hProg, GSM_GETPOS, 0, 0));
		break;
	}
	return 0;
}

//  ٸ ɼ . 
LRESULT CMusicPlayer::OnContextMenu(WPARAM wParam, LPARAM lParam)
{
	return 0;
}

LRESULT CMusicPlayer::OnDropFiles(WPARAM wParam, LPARAM lParam)
{
	TCHAR Path[MAX_PATH];
	int Count, n, addCount = 0;

	Count = DragQueryFile((HDROP)wParam, 0xffffffff, NULL, 0);
	for (n = 0; n < Count; n++) {
		DragQueryFile((HDROP)wParam, n, Path, MAX_PATH);
		AddFile(Path);
	}

	//  Ͽ  巡 ù ° ׸  .  ׸  ¸  ƾ Ѵ. 
	if (groupIdx[GetActiveGroup()] == -1) {
		groupIdx[GetActiveGroup()] = 0;
		SendMessage(hList, LB_SETCURSEL, 0, 0);
	}

	// Ͽ ȭ   Ѵ. 
	SaveMusicList();
	return 0;
}

LRESULT CMusicPlayer::OnCommand(WPARAM wParam, LPARAM lParam)
{
	int group;
	int list_idx;

	switch (LOWORD(wParam)) {
	case MP_PLAY:
		if (dev_id != 0) {
			//  ִ ̸  ¿  Ͻ Ǵ 簳Ѵ.
			switch (GetStatus()) {
			case MCI_MODE_PLAY:
				mciSendCommand(dev_id, MCI_PAUSE, 0, (DWORD)NULL);
				break;
			case MCI_MODE_PAUSE:
				mciSendCommand(dev_id, MCI_RESUME, 0, (DWORD)NULL);
				break;
			}
		} else {
			//    Ƽ ׷   Ѵ.
			// ڰ   Ͽ   ̴. 
			PlayActiveCurrent();
		}
		break;
	case MP_STOP:
		if (dev_id != 0) {
			mciSendCommand(dev_id, MCI_STOP, 0, (DWORD)NULL);
			SendMessage(hProg, GSM_SETPOS, 0, 0);
		}
		break;
	case MP_NEXT:
		//  ƴϸ Ƽ ׷  ̵ϰ Ʈ ڽ ǥ
		if (dev_id == 0) {
			group = GetActiveGroup();
			if (groupIdx[group] != -1) {
				moveNext(groupIdx[group], arMusic[group].num);
				SendMessage(hList, LB_SETCURSEL, groupIdx[group], 0);
			}
		} else {
			if (randomPlay) {
				playIdx = SelectRandomPlay();
			} else {
				//  ׷  ̵. 
				moveNext(playIdx, arMusic[playGroup].num);
			}
			// ׷  ϴ Ѵ. 
			groupIdx[playGroup] = playIdx;
			//  ׷ ̴ ̸ Ʈ ڽ ǥ. ٸ    
			if (GetActiveGroup() == playGroup) {
				SendMessage(hList, LB_SETCURSEL, playIdx, 0);
			}

			//  ϰ  ׷  
			mciSendCommand(dev_id, MCI_STOP, MCI_WAIT, (DWORD)NULL);
			SetTimer(win_hWnd, MPTM_PLAYNEXT, 100, NULL);
		}
		break;
	case MP_PREV:
		if (dev_id == 0) {
			group = GetActiveGroup();
			if (groupIdx[group] != -1) {
				movePrev(groupIdx[group], arMusic[group].num);
				SendMessage(hList, LB_SETCURSEL, groupIdx[group], 0);
			}
		} else {
			if (randomPlay) {
				playIdx = SelectRandomPlay();
			} else {
				movePrev(playIdx, arMusic[playGroup].num);
			}
			groupIdx[playGroup] = playIdx;
			if (GetActiveGroup() == playGroup) {
				SendMessage(hList, LB_SETCURSEL, playIdx, 0);
			}

			mciSendCommand(dev_id, MCI_STOP, MCI_WAIT, (DWORD)NULL);
			SetTimer(win_hWnd, MPTM_PLAYPREV, 100, NULL);
		}
		break;
	case MP_LIST:
		switch (HIWORD(wParam)) {
		case LBN_DBLCLK:
			// Ŭ  . ̸   
			if (dev_id != 0) {
				mciSendCommand(dev_id, MCI_STOP, MCI_WAIT, (DWORD)NULL);
				SetTimer(win_hWnd, MPTM_PLAYACTIVE, 100, NULL);
			} else {
				PlayActiveCurrent();
			}
			break;
		case LBN_SELCHANGE:
			//   Ƽ ׷   Ѵ.
			list_idx = SendMessage(hList, LB_GETCURSEL, 0, 0);
			groupIdx[GetActiveGroup()] = list_idx;
			break;
		}
		break;
	case MP_ADD:
		OPENFILENAME OFN;
		TCHAR* files;
		TCHAR* p;
		TCHAR dir[MAX_PATH];
		TCHAR file[MAX_PATH];
		TCHAR path[MAX_PATH];
		files = (TCHAR *)calloc(32000, sizeof(TCHAR));
		memset(&OFN, 0, sizeof(OPENFILENAME));
		OFN.lStructSize = sizeof(OPENFILENAME);
		OFN.hwndOwner = win_hWnd;
		OFN.lpstrFilter = TEXT(" (mp3, wav)\0*.mp3;*.wav\0");
		OFN.lpstrFile = files;
		OFN.nMaxFile = 320000;
		OFN.Flags = OFN_EXPLORER | OFN_ALLOWMULTISELECT;
		//    Ѳ ߰. 뷫   Ѳ ߰ ϴ. 
		if (GetOpenFileName(&OFN) != 0) {
			p = files;
			lstrcpy(dir, p);
			if (*(p + lstrlen(dir) + 1) == 0) {
				AddFile(dir);
			} else {
				lstrcpy(file, dir);
				for (;;) {
					p = p + lstrlen(file) + 1;
					if (*p == 0)
						break;
					lstrcpy(file, p);
					lstrcpy(path, dir);
					lstrcat(path, L"\\");
					lstrcat(path, file);
					AddFile(path);
				}
			}
		} else {
			if (CommDlgExtendedError() == FNERR_BUFFERTOOSMALL) {
				MessageBox(win_hWnd, TEXT("Ѳ ʹ   ߽ϴ."), TEXT(""), MB_OK);
			}
		}
		SaveMusicList();
		break;
	case MP_CLEAR:
		//  ̸ ϴ Ѵ. 
		if (dev_id != 0) {
			mciSendCommand(dev_id, MCI_STOP, 0, (DWORD)NULL);
			SendMessage(hProg, GSM_SETPOS, 0, 0);
		}

		// Ʈ ڽ 
		SendMessage(hList, LB_RESETCONTENT, 0, 0);

		// ׷  . 
		group = GetActiveGroup();
		for (int i = 0; i < (int)arMusic[group].num; i++) {
			delete arMusic[group][i];
		}
		arMusic[group].Clear();
		groupIdx[group] = -1;

		SaveMusicList();
		break;
	case MP_GROUP1:
	case MP_GROUP2:
	case MP_GROUP3:
	case MP_GROUP4:
		ChangeActiveGroup(LOWORD(wParam) - MP_GROUP1);
		break;
	case MP_RANDOM:
		randomPlay = (SendMessage(hRandom, GBM_GETSTATE, 0, 0) == GB_DOWN);
		break;
	}
	return 0;
}

//  ׷ Ŀ   Ѵ.
// Play ư , Ŭ,  Ŭ 
void CMusicPlayer::PlayActiveCurrent()
{
	playGroup = GetActiveGroup();
	playIdx = groupIdx[playGroup];
	//  ׷    .  Ѵ.
	if (playIdx == -1) return;
	// ׷   ̻ ȣ ȿϴ.  ׷   ϸ playIdx ȿ ġ Ų. 
	//   ׷ playGroup  playIdx  ϰ ־   ó ʿϴ. 
	if (playIdx >= (int)arMusic[playGroup].num) return;

	DoPlayCurrent(true);
}

// playGroup playIdx ϸ ȣ     ξ Ѵ. 
// н  Ǵ   ã´. MCI ѰӸ ƴ϶ ߸     ־  ʿϴ.
// ׻  ¿  ޼带 ȣؾ ϸ dev_id ׻ 0̴. 
bool CMusicPlayer::DoPlayCurrent(bool bNext)
{
	int oldIdx = playIdx;

	//  ġ     ̵
	while (DoPlay(arMusic[playGroup][playIdx]->Path) == false) {
		if (bNext) {
			moveNext(playIdx, arMusic[playGroup].num);
		} else {
			movePrev(playIdx, arMusic[playGroup].num);
		}

		//  ׷ ̸ Ʈ ڽ  ġ Ѵ.
		if (playGroup == GetActiveGroup()) {
			SendMessage(hList, LB_SETCURSEL, playIdx, 0);
		}
		// ѹ  ó     ̸     Ѵ. 
		if (playIdx == oldIdx) return false;

		// ణ .
		MessageBeep(0);
		Sleep(300);
	}

	return true;
}

//   Ѵ. fromPos ־  ġ Ѵ.
bool CMusicPlayer::DoPlay(LPCTSTR musicPath, int fromPos /*= 0*/)
{
	DWORD Result;
	MCI_OPEN_PARMS openParam;
	MCI_PLAY_PARMS playParam;
	TCHAR sError[256];

	// ID3 ±׸  ȯ  ϰ ׷   Ѵ. 
	TCHAR tPath[MAX_PATH];
	if (StripID3Tag(musicPath)) {
		lstrcpy(tPath, stripPath);
	} else {
		lstrcpy(tPath, musicPath);
	}

	//    ̸ ġ   Ѵ. 
	// ġ Openϰ ID ߱޹޴´.
	openParam.lpstrDeviceType = L"mpegvideo";
	openParam.lpstrElementName = tPath;
	Result = mciSendCommand(0, MCI_OPEN, MCI_OPEN_TYPE | MCI_OPEN_ELEMENT, (DWORD)(LPVOID)&openParam);
	if (Result) {
		// MCI 277  - ID3 ± Ǵ Ÿ  ߻ . ID3 ±  ذ ٸ     ִ. 
		mciGetErrorString(Result, sError, 256);

		//  ݰ и Ѵ. 
		mciSendCommand(dev_id, MCI_CLOSE, 0, (DWORD)NULL);
		return false;
	}
	dev_id = openParam.wDeviceID;

	//  Ѵ. fromPos  ó Ѵ.    .
	playParam.dwCallback = (DWORD)win_hWnd;
	DWORD dwFlag = MCI_NOTIFY;
	if (fromPos != 0) {
		playParam.dwFrom = fromPos;
		dwFlag = dwFlag | MCI_FROM;
	}
	Result = mciSendCommand(dev_id, MCI_PLAY, dwFlag, (DWORD)(LPVOID)&playParam);

	//  ؼ Ʈٷ  Ѵ. ʴ̸ 32Ʈ  ؾ Ѵ.
	SendMessage(hProg, GSM_SETRANGE, 0, GetLength());

	return true;
}

//  ¸ Ѵ. dev_id  ִ ¿ Ѵ.
DWORD CMusicPlayer::GetStatus()
{
	MCI_STATUS_PARMS statusParam;
	DWORD Result;
	TCHAR sError[256];

	statusParam.dwItem = MCI_STATUS_MODE;
	Result = mciSendCommand(dev_id, MCI_STATUS, MCI_STATUS_ITEM, (DWORD)(LPVOID)&statusParam);
	if (Result) {
		mciGetErrorString(Result, sError, 256);
	}

	return statusParam.dwReturn;
}

//  ̸ Ѵ.
DWORD CMusicPlayer::GetLength()
{
	MCI_STATUS_PARMS statusParam;
	DWORD Result;
	TCHAR sError[256];

	statusParam.dwItem = MCI_STATUS_LENGTH;
	Result = mciSendCommand(dev_id, MCI_STATUS, MCI_STATUS_ITEM, (DWORD)(LPVOID)&statusParam);
	if (Result) {
		mciGetErrorString(Result, sError, 256);
	}

	return statusParam.dwReturn;
}

//   ġ Ѵ.
DWORD CMusicPlayer::GetPosition()
{
	MCI_STATUS_PARMS statusParam;
	DWORD Result;
	TCHAR sError[256];

	statusParam.dwItem = MCI_STATUS_POSITION;
	Result = mciSendCommand(dev_id, MCI_STATUS, MCI_STATUS_ITEM, (DWORD)(LPVOID)&statusParam);
	if (Result) {
		mciGetErrorString(Result, sError, 256);
	}

	return statusParam.dwReturn;
}

//  ǥ ׷쿡  ߰Ѵ.
bool CMusicPlayer::AddFile(LPCTSTR Path)
{
	TCHAR ext[MAX_PATH];

	// Ȯڸ ҹڷ ٲ  Ѵ.
	lstrcpy(ext, PathFindExtension(Path));
	_tcslwr(ext);
	if (lstrcmp(ext, L".mp3") == 0 || lstrcmp(ext, L".wav") == 0) {
		arMusic[GetActiveGroup()].Append(new sImagePath(Path));
		// δ  ϸ ؼ ǥ
		SendMessage(hList, LB_ADDSTRING, 0, (LPARAM)PathFindFileName(Path));
		return true;
	}

	return false;
}

void CMusicPlayer::LoadMusicList()
{
	TCHAR* buf;
	TCHAR* p, * pEnd;
	TCHAR oneFile[MAX_PATH];
	TCHAR key[32];

	int bufSize = MAX_PATH * 1000 * sizeof(TCHAR);
	buf = (TCHAR*)malloc(bufSize);
	for (int group = 0; group < 4; group++) {
		wsprintf(key, L"MusicList%d", group);
		setting.get(dget_id, key, L"", buf, bufSize);
		arMusic[group].Clear();
		for (p = buf; *p != 0;) {
			pEnd = _tcsstr(p, L"");
			memset(oneFile, 0, sizeof(oneFile));
			_tcsncpy(oneFile, p, pEnd - p);
			arMusic[group].Append(new sImagePath(oneFile));
			p = pEnd + 1;
		}
	}
	free(buf);
}

void CMusicPlayer::SaveMusicList()
{
	TCHAR key[32];
	TCHAR* buf;
	int num;

	// 4 ׷   Ѵ.
	for (int group = 0; group < 4; group++) {
		num = arMusic[group].num;
		if (num == 0) {
			//  ϳ   ڿ з̶ Ҵؼ ؾ Ѵ.
			buf = (TCHAR*)calloc(128, sizeof(TCHAR));
		} else {
			buf = (TCHAR*)calloc(MAX_PATH * num, sizeof(TCHAR));
			for (int i = 0; i < (int)arMusic[group].num; i++) {
				lstrcat(buf, arMusic[group][i]->Path);
				lstrcat(buf, L"");
			}
		}
		wsprintf(key, L"MusicList%d", group);
		setting.set(dget_id, key, buf);
		free(buf);
	}
}

// ׷ Ѵ. 
void CMusicPlayer::ChangeActiveGroup(int group, bool init/* = false*/)
{
	ChangeState(hGroup1, GB_DOWN);
	ChangeState(hGroup2, GB_DOWN);
	ChangeState(hGroup3, GB_DOWN);
	ChangeState(hGroup4, GB_DOWN);

	switch (group) {
	case 0:
		ChangeState(hGroup1, GB_NORMAL);
		break;
	case 1:
		ChangeState(hGroup2, GB_NORMAL);
		break;
	case 2:
		ChangeState(hGroup3, GB_NORMAL);
		break;
	case 3:
		ChangeState(hGroup4, GB_NORMAL);
		break;
	}

	//  ǥ ׷    ش. 
	FillListBox(group);
}

// ׷ ȣ Ѵ.
int CMusicPlayer::GetActiveGroup()
{
	if (SendMessage(hGroup1, GBM_GETSTATE, 0, 0) == GB_NORMAL) return 0;
	if (SendMessage(hGroup2, GBM_GETSTATE, 0, 0) == GB_NORMAL) return 1;
	if (SendMessage(hGroup3, GBM_GETSTATE, 0, 0) == GB_NORMAL) return 2;
	if (SendMessage(hGroup4, GBM_GETSTATE, 0, 0) == GB_NORMAL) return 3;

	return -1;
}

// ׷   ä  ð  ش. 
void CMusicPlayer::FillListBox(int group)
{
	SendMessage(hList, LB_RESETCONTENT, 0, 0);
	for (int i = 0; i < (int)arMusic[group].num; i++) {
		SendMessage(hList, LB_ADDSTRING, 0, (LPARAM)PathFindFileName(arMusic[group][i]->Path));
	}

	SendMessage(hList, LB_SETCURSEL, groupIdx[group], 0);
}

// playGroup ϰ ϳ  ش. 
// todo : ü ׷쿡    ִ. UI ׷찣  ɼ  , ,  ׷찣 ̵ϵ ϸ  ϴ. 
int CMusicPlayer::SelectRandomPlay()
{
	// ϳۿ   0̴.
	if (arMusic[playGroup].num == 1) return 0;

	int idx;
	do {
		idx = random(arMusic[playGroup].num);
	} while (playIdx == idx);

	return idx;
}

bool CMusicPlayer::StripID3Tag(LPCTSTR path)
{
	HANDLE hFile;
	DWORD dwRead, dwWritten;
	DWORD size;
	void* buf = NULL;

	//    ۷ о δ. 
	//   ٸ  ״ е ȯ · Ѵ. 
	hFile = CreateFile(path, GENERIC_READ, 0, NULL,
		OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if (hFile == INVALID_HANDLE_VALUE) {
		return false;
	}
	size = GetFileSize(hFile, NULL);
	buf = malloc(size);
	ReadFile(hFile, buf, size, &dwRead, NULL);
	CloseHandle(hFile);

	int offset = 0;
	char* p = (char*)buf;

	// ID3 ϸ ±װ ִ ̴. ±׸    ͸ ӽ  . 
	if (p[0] == 'I' && p[1] == 'D' && p[2] == '3') {
		// ± ̴ 6~9Ʈ ֵ synchsafe  Ǿ ִ.
		// ù Ʈ  0̸  7Ʈ ϴ Ʋ̴. 
		offset = int(p[6] * pow(2, 21) + p[7] * pow(2, 14) + p[8] * pow(2, 7) + p[9]);
		// ± ̿  ̴ Ƿ   10ŭ ؾ  ִ ġ ȴ.
		offset += 10;

		//   ġ ӽ  Ѵ. MCI ޸𸮻    ʾ ݵ  ؾ Ѵ.
		//  Ϸ ϵ α׷    ݵ  Ѵ. 
		hFile = CreateFile(stripPath, GENERIC_WRITE, 0, NULL,
			CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL | FILE_ATTRIBUTE_HIDDEN, NULL);
		WriteFile(hFile, p + offset, size - offset, &dwWritten, NULL);
		CloseHandle(hFile);
	}
	free(buf);

	// ȯ θ Ѵ. 
	if (offset == 0) {
		return false;
	} else {
		return true;
	}
}

// ޸  todo
//  Ʈ GDI   lib ũ. ִ ؽƮ 
// Ŀ   ޺ ڽ ۼ.
// ˾     ̵  

COLORREF arMemoBack[] = { 
	GetColorFromName(L"LemonChiffon"),
	GetColorFromName(L"GreenYellow"),
	GetColorFromName(L"DeepSkyBlue"),
	GetColorFromName(L"Plum"),
	GetColorFromName(L"LightPink"),
	GetColorFromName(L"Snow"),
	};
COLORREF arMemoFore[] = {
	GetColorFromName(L"Black"),
	GetColorFromName(L"Red"),
	GetColorFromName(L"Blue"),
	GetColorFromName(L"Magenta"),
	GetColorFromName(L"Maroon"),
	GetColorFromName(L"Indigo"),
};

LRESULT CMemo::OnCreate(WPARAM wParam, LPARAM lParam)
{
	hCombo = CreateWindow(TEXT("combobox"), NULL, WS_CHILD | WS_VISIBLE |
		CBS_DROPDOWNLIST, 2, 2, 100, 200, win_hWnd, (HMENU)MEMO_COMBO, g_hInst, NULL);
	hAdd = CreateWindow(TEXT("button"), TEXT("+"), WS_CHILD | WS_VISIBLE |
		BS_PUSHBUTTON, 20, 20, 100, 25, win_hWnd, (HMENU)MEMO_ADD, g_hInst, NULL);
	hDelete = CreateWindow(TEXT("button"), TEXT("-"), WS_CHILD | WS_VISIBLE |
		BS_PUSHBUTTON, 20, 50, 100, 25, win_hWnd, (HMENU)MEMO_DELETE, g_hInst, NULL);
	hView = CreateWindow(TEXT("button"), TEXT(""), WS_CHILD | WS_VISIBLE |
		BS_PUSHBUTTON, 20, 20, 100, 25, win_hWnd, (HMENU)MEMO_VIEW, g_hInst, NULL);
	hEdit = CreateWindow(TEXT("edit"), NULL, WS_CHILD | WS_VISIBLE | WS_BORDER | WS_VSCROLL |
		ES_AUTOHSCROLL | ES_MULTILINE, 10, 10, 200, 25, win_hWnd, (HMENU)MEMO_EDIT, g_hInst, NULL);
	SendMessage(hCombo, WM_SETFONT, (WPARAM)mainFont, MAKELPARAM(FALSE, 0));
	SendMessage(hEdit, WM_SETFONT, (WPARAM)mainFont, MAKELPARAM(FALSE, 0));

	//       ʱȭ
	nowIdx = -1;

	// ޸  о´. 
	LoadMemoList();

	// ޺ ڽ ޸  ä ְ  ׸  ش. 
	for (int i = 0; i < arMemo.num; i++) {
		SendMessage(hCombo, CB_ADDSTRING, 0, (LPARAM)arMemo[i]->title);
	}

	if (nowIdx == -1) {
		SetWindowText(hEdit, L"޸ ϳ ϴ.\r\n+ ư  ޸ ߰Ͻʽÿ.");
		EnableWindow(hEdit, FALSE);
	} else {
		SendMessage(hCombo, CB_SETCURSEL, nowIdx, 0);
		SetWindowText(hEdit, arMemo[nowIdx]->content);
	}

	return 0;
}

LRESULT CMemo::OnDestroy(WPARAM wParam, LPARAM lParam)
{
	SaveMemo(nowIdx);
	if (isModi) {
		SaveMemoList();
	}
	return 0;
}

LRESULT CMemo::OnSize(WPARAM wParam, LPARAM lParam)
{
	CWindow::OnSize(wParam, lParam);

	int w = LOWORD(lParam);
	int h = HIWORD(lParam);

	MoveWindow(hCombo, 2, 2, w - 70, 200, TRUE);
	MoveWindow(hAdd, w - 66, 5, 20, 20, TRUE);
	MoveWindow(hDelete, w - 44, 5, 20, 20, TRUE);
	MoveWindow(hView, w - 22, 5, 20, 20, TRUE);
	MoveWindow(hEdit, 2, 28, w - 4, h - 30, TRUE);

	return 0;
}

LRESULT CMemo::OnCommand(WPARAM wParam, LPARAM lParam)
{
	sMemo* pMemo;
	TCHAR name[64];
	bool find;
	int idx;
	TCHAR mes[128];

	switch(LOWORD(wParam)) {
	case MEMO_ADD:
		SaveMemo(nowIdx);

		//  ޸ ȣ ã´. 
		for (int i = 1;; i++) {
			wsprintf(name, L" ޸%d", i);
			find = false;
			for (int m = 0; m < arMemo.num; m++) {
				if (lstrcmp(arMemo[m]->title, name) == 0) {
					find = true;
					break;
				}
			}
			if (find == false) break;
		}

		//  0   ʱȭѴ.  ׷   ϰ ȴ. 
		pMemo = (sMemo*)calloc(sizeof(sMemo), 1);
		lstrcpy(pMemo->title, name);
		//     ش. 
		pMemo->x = 10;
		pMemo->y = 10;
		pMemo->w = 400;
		pMemo->h = 500;
		lstrcpy(pMemo->fontFace, L" ");
		pMemo->fontSize = 16;
		pMemo->isText = true;
		pMemo->foreColor = RGB(0, 0, 0);
		pMemo->backColor = arMemoBack[arMemo.num % Count(arMemoBack)];
		pMemo->wordWrap = false;
		pMemo->content = (TCHAR*)calloc(1, sizeof(TCHAR));
		pMemo->content_len = 1;
		pMemo->isModi = false;
		pMemo->pViewer = NULL;

		arMemo.Append(pMemo);
		nowIdx = SendMessage(hCombo, CB_ADDSTRING, 0, (LPARAM)pMemo->title);
		SendMessage(hCombo, CB_SETCURSEL, nowIdx, 0);

		SetWindowText(hEdit, L"");
		EnableWindow(hEdit, TRUE);
		MySetImeMode(hEdit, TRUE);
		SetFocus(hEdit);

		isModi = true;
		break;
	case MEMO_DELETE:
		idx = SendMessage(hCombo, CB_GETCURSEL, 0, 0);
		if (idx != -1) {
			GetWindowText(hCombo, name, 64);
			wsprintf(mes, L"%s ޸ մϴ.", name);
			if (MessageBox(win_hWnd, mes, L"", MB_YESNO) == IDYES) {

				//    ݴ´. , ̶ θ  ü  ϸ  θ𿡰  û  ʿ䰡 .
				// ı ϸ  WM_USER+1 ̴µ OnUser1 ó  arMemo[idx] Ǿ  ٿȴ. 
				if (arMemo[idx]->pViewer != NULL) {
					arMemo[idx]->pViewer->destroyBySelf = false;
					DestroyWindow(arMemo[idx]->pViewer->win_hWnd);
					delete(arMemo[idx]->pViewer);
				}

				//  ϰ ޸ Ѵ.
				free(arMemo[idx]->content);
				arMemo.Delete(idx);

				// ޺ .  ׸̾ ׸ ̵
				SendMessage(hCombo, CB_DELETESTRING, idx, 0);
				if (nowIdx == SendMessage(hCombo, CB_GETCOUNT, 0, 0)) {
					nowIdx--;
				}
				//  ġ ޸ о
				if (nowIdx == -1) {
					SetWindowText(hEdit, L"޸ ϳ ϴ.\r\n+ ư  ޸ ߰Ͻʽÿ.");
					EnableWindow(hEdit, FALSE);
				} else {
					SendMessage(hCombo, CB_SETCURSEL, nowIdx, 0);
					pMemo = arMemo[nowIdx];
					SetWindowText(hEdit, pMemo->content);
				}

			}
		}
		break;
	case MEMO_VIEW:
		if (nowIdx != -1) {
			// ϴ ϴź ϰ
			SaveMemo(nowIdx);
			//    Ŀ ְ ƴϸ Ѵ.
			if (arMemo[nowIdx]->pViewer != NULL) {
				SetFocus(arMemo[nowIdx]->pViewer->win_hWnd);
				arMemo[nowIdx]->pViewer->RefreshMemo();
			} else {
				arMemo[nowIdx]->pViewer = new CMemoViewer();
				arMemo[nowIdx]->pViewer->Create(this, nowIdx);
			}
		}
		break;
	case MEMO_COMBO:
		switch (HIWORD(wParam)) {
		case CBN_SELCHANGE:
			SaveMemo(nowIdx);

			//  ޸  о´. 
			nowIdx = SendMessage(hCombo, CB_GETCURSEL, 0, 0);
			pMemo = arMemo[nowIdx];
			SetWindowText(hEdit, pMemo->content);

			break;
		}
		break;
	case MEMO_EDIT:
		switch (HIWORD(wParam)) {
		case EN_CHANGE:
			if (nowIdx != -1) {
				// ޸ ü Ͽ ȭ   д. 
				arMemo[nowIdx]->isModi = true;
				isModi = true;
			}
			break;
		}
		break;
	}
	return 0;
}

//     ޽ δ. wParam ޸ idx Ѵ.
LRESULT CMemo::OnUser1(WPARAM wParam, LPARAM lParam)
{
	delete(arMemo[wParam]->pViewer);
	arMemo[wParam]->pViewer = NULL;
	return 0;
}

void CMemo::SaveMemo(int idx)
{
	sMemo* pMemo;

	//  ޸  ¿ ׳ Ѵ. 
	if (idx == -1) return;

	//  ޸ Ǿ ̿ ߾ ޸ Ҵϰ Ѵ. 
	pMemo = arMemo[idx];
	if (pMemo->isModi == true) {
		SaveMemo(pMemo, hEdit);
		pMemo->isModi = false;
		isModi = true;
	}
}

// ޸  hEdit  Ѵ. hEdit    ְ ޸   ִ. 
void CMemo::SaveMemo(sMemo* pMemo, HWND hEdit)
{
	//  Ṯںиŭ ҴѴ.
	int newlen = GetWindowTextLength(hEdit) + 1;
	if (pMemo->content_len < newlen) {
		pMemo->content = (TCHAR*)realloc(pMemo->content, newlen * sizeof(TCHAR));
		pMemo->content_len = newlen;
	}
	GetWindowText(hEdit, pMemo->content, pMemo->content_len);
}

void CMemo::SaveMemoList()
{
	TCHAR Path[MAX_PATH];
	HANDLE hFile;
	DWORD dwWritten;

	GetMemoFilePath(Path);
	hFile = CreateFile(Path, GENERIC_WRITE, 0, NULL,
		CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);

	// ĺ 
	LPCTSTR magic = L"SoEntyMemo";
	WriteFile(hFile, magic, lstrlen(magic) * sizeof(TCHAR), &dwWritten, NULL);
	//  
	int Ver = 100;
	WriteFile(hFile, &Ver, sizeof(Ver), &dwWritten, NULL);
	//   ޸ ȣ 
	WriteFile(hFile, &nowIdx, sizeof(nowIdx), &dwWritten, NULL);
	int num = arMemo.num;
	WriteFile(hFile, &num, sizeof(num), &dwWritten, NULL);

	// ȸϸ ޸ 
	for (int i = 0; i < arMemo.num; i++) {
		// ޸  .
		WriteFile(hFile, arMemo[i], sizeof(sMemo), &dwWritten, NULL);
		// ޸  .   ڵ  . 
		WriteFile(hFile, arMemo[i]->content, arMemo[i]->content_len * sizeof(TCHAR), &dwWritten, NULL);
	}

	CloseHandle(hFile);
}

void CMemo::LoadMemoList()
{
	TCHAR Path[MAX_PATH];
	HANDLE hFile;
	DWORD dwRead;

	GetMemoFilePath(Path);
	hFile = CreateFile(Path, GENERIC_READ, 0, NULL,
		OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	//      ׳ Ѵ. 
	if (hFile == INVALID_HANDLE_VALUE) {
		return;
	}
	LPCTSTR magic = L"SoEntyMemo";
	TCHAR buf[100] = { 0, };
	ReadFile(hFile, &buf, lstrlen(magic) * sizeof(TCHAR), &dwRead, NULL);
	if (lstrcmp(buf, magic) != 0) {
		return;
	}

	//  Ȯ
	int ver;
	ReadFile(hFile, &ver, sizeof(int), &dwRead, NULL);
	if (ver != 100) {
		return;
	}

	ReadFile(hFile, &nowIdx, sizeof(nowIdx), &dwRead, NULL);
	int num;
	ReadFile(hFile, &num, sizeof(num), &dwRead, NULL);

	for (int i = 0; i < num; i++) {
		sMemo *pMemo;
		pMemo = (sMemo*)malloc(sizeof(sMemo));
		ReadFile(hFile, pMemo, sizeof(sMemo), &dwRead, NULL);
		pMemo->content = (TCHAR *)calloc(pMemo->content_len, sizeof(TCHAR));
		ReadFile(hFile, pMemo->content, pMemo->content_len * sizeof(TCHAR), &dwRead, NULL);
		arMemo.Append(pMemo);
	}

	CloseHandle(hFile);
}

//    ϸ.memo  θ Ѵ. 
void CMemo::GetMemoFilePath(TCHAR* Path)
{
	GetModuleFileName(NULL, Path, MAX_PATH);
	TCHAR *p = _tcsrchr(Path, '.');
	*(p + 1) = 0;

	if (lstrcmp(dget_id, L"Memo_1") == 0) {
		lstrcat(Path, L"Memo");
	} else {
		lstrcat(Path, dget_id);
	}
}

void CMemoViewer::Create(CMemo* pMemoWidget, int idx)
{
	this->pMemoWidget = pMemoWidget;
	this->nowIdx = idx;
	this->pMemo = pMemoWidget->arMemo[idx];

	//   ġ 츦 Ѵ. 
	CreateWindow(TEXT("CWindow"), pMemo->title, WS_POPUPWINDOW | WS_THICKFRAME | WS_VISIBLE,
		pMemo->x, pMemo->y, pMemo->w, pMemo->h,
		NULL, (HMENU)NULL, g_hInst, this);

	MoveWindow(win_hWnd, pMemo->x, pMemo->y, pMemo->w, pMemo->h, FALSE);
}

LRESULT CMemoViewer::OnMessage(UINT iMessage, WPARAM wParam, LPARAM lParam)
{
	POINT pt;

	switch (iMessage)
	{
	case WM_NCHITTEST:
		int nHit;
		nHit = (int)DefWindowProc(win_hWnd, WM_NCHITTEST, wParam, lParam);
		pt.x = (int)(short)LOWORD(lParam);
		pt.y = (int)(short)HIWORD(lParam);
		ScreenToClient(win_hWnd, &pt);

		if (nHit == HTCLIENT) {
			if (pt.y < capThick) {
				return HTCAPTION;
			}
		}

		return nHit;
	case WM_SETFOCUS:
		RefreshMemo();
		SetFocus(hEdit);
		return 0;
	case WM_CTLCOLOREDIT:
		if ((HWND)lParam == hEdit) {
			SetTextColor((HDC)wParam, pMemo->foreColor);
			SetBkColor((HDC)wParam, pMemo->backColor);
			return (LRESULT)backBrush;
		}
		break;
	}

	return CWindow::OnMessage(iMessage, wParam, lParam);
}

LRESULT CMemoViewer::OnCreate(WPARAM wParam, LPARAM lParam)
{
	hClose = CreateWindow(TEXT("GrpBtn"), NULL, WS_CHILD | WS_VISIBLE | GBS_PUSH,
		0, 0, 16, 16, win_hWnd, (HMENU)MV_CLOSE, g_hInst, NULL);
	SendMessage(hClose, GBM_SETIMAGE, MAKEWPARAM(IDB_CLOSE_NORMAL, IDB_CLOSE_HOT),MAKEWPARAM(IDB_CLOSE_DOWN, IDB_CLOSE_NORMAL));
	hAttr = CreateWindow(TEXT("GrpBtn"), NULL, WS_CHILD | WS_VISIBLE | GBS_PUSH,
		0, 0, 16, 16, win_hWnd, (HMENU)MV_ATTR, g_hInst, NULL);
	SendMessage(hAttr, GBM_SETIMAGE, MAKEWPARAM(IDB_PROPNORM, IDB_PROPHOT), MAKEWPARAM(IDB_PROPDOWN, IDB_PROPNORM));
	hEdit = CreateWindow(TEXT("edit"), NULL, WS_CHILD | WS_VISIBLE | WS_VSCROLL | ES_MULTILINE |
		ES_AUTOHSCROLL, 0, 0, 200, 25, win_hWnd, (HMENU)MV_EDIT, g_hInst, NULL);

	fontEdit = CreateFont(pMemo->fontSize, 0, 0, 0, 0, 0, 0, 0, HANGUL_CHARSET, 3, 2, 1,
		VARIABLE_PITCH | FF_MODERN, pMemo->fontFace);
	SendMessage(hEdit, WM_SETFONT, (WPARAM)fontEdit, MAKELPARAM(FALSE, 0));
	backBrush = CreateSolidBrush(pMemo->backColor);

	SetWindowText(hEdit, pMemo->content);
	SetFocus(hEdit);
	isModi = false;

	return 0;
}

LRESULT CMemoViewer::OnDestroy(WPARAM wParam, LPARAM lParam)
{
	//   ġ Ѵ.
	RECT wrt;
	GetWindowRect(win_hWnd, &wrt);
	pMemo->x = wrt.left;
	pMemo->y = wrt.top;
	pMemo->w = (wrt.right - wrt.left);
	pMemo->h = (wrt.bottom - wrt.top);

	DeleteObject(fontEdit);
	DeleteObject(backBrush);
	// θ𿡰 Ḧ ˷  ü 쵵 Ѵ. ı  ޽  óؾ ϱ  Send ƴϰ Post. 
	// , ڽ    θ𿡰 ı ûϰ θ  ı  ׷ ʿ . 
	if (destroyBySelf) {
		PostMessage(pMemoWidget->win_hWnd, WM_USER + 1, nowIdx, 0);
	}
	return 0;
}

void CMemoViewer::OnDraw(HDC hdc, RECT crt)
{
	// ĸ   ä
	HBRUSH brush = CreateSolidBrush(pMemo->backColor);
	FillRect(hdc, 0, 0, crt.right, capThick, brush);
	DeleteObject(brush);

	// Ʒʿ ȸ ϳ ߴ´.   Ѱ ̴. 
	HPEN pen, oldPen;
	pen = CreatePen(PS_SOLID, 1, RGB(128, 128, 128));
	oldPen = (HPEN)SelectObject(hdc, pen);
	MoveToEx(hdc, 5, capThick - 1, NULL); LineTo(hdc, crt.right - 5, capThick - 1);
	DeleteObject(SelectObject(hdc, oldPen));

	SetBkMode(hdc, TRANSPARENT);
	HFONT oldFont = (HFONT)SelectObject(hdc, mainFont);
	TextOutVCenter(hdc, 4, capThick / 2, pMemo->title);
	SelectObject(hdc, oldFont);

}

void CMemoViewer::SendMemoToWidget()
{
	// Ǿ ޸ Ѵ. 
	if (isModi) {
		pMemoWidget->SaveMemo(pMemo, hEdit);
		//  ϰ ִ ޸ ǥϰ  Ʈ  Ѵ. 
		if (pMemoWidget->nowIdx == nowIdx) {
			SetWindowText(pMemoWidget->hEdit, pMemo->content);
		}
		isModi = false;
	}
}

LRESULT CMemoViewer::OnSize(WPARAM wParam, LPARAM lParam)
{
	CWindow::OnSize(wParam, lParam);

	int w = LOWORD(lParam);
	int h = HIWORD(lParam);

	MoveWindow(hClose, w - 20, 4, 16, 16, TRUE);
	MoveWindow(hAttr, w - 40, 4, 16, 16, TRUE);
	MoveWindow(hEdit, 0, capThick, w, h-capThick, TRUE);

	return 0;
}

INT_PTR CALLBACK MemoDlgProc(HWND hDlg, UINT iMessage, WPARAM wParam, LPARAM lParam)
{
	static CMemoViewer* pViewer;
	static CMemo::sMemo* pMemo;
	LPMEASUREITEMSTRUCT lpmis;
	LPDRAWITEMSTRUCT lpdis;
	HBRUSH bkBrush, Brush, OldBrush;
	COLORREF* arColor;
	int idx;

	switch (iMessage) {
	case WM_INITDIALOG:
		pViewer = (CMemoViewer*)lParam;
		pMemo = pViewer->pMemo;

		if (pMemo->isText) {
			CheckRadioButton(hDlg, IDC_RAFORMAT1, IDC_RAFORMAT2, IDC_RAFORMAT1);
		} else {
			CheckRadioButton(hDlg, IDC_RAFORMAT1, IDC_RAFORMAT2, IDC_RAFORMAT2);
		}

		SetDlgItemText(hDlg, IDC_EDTITLE, pMemo->title);

		SendDlgItemMessage(hDlg, IDC_LIFONT, LB_ADDSTRING, 0, (LPARAM)L"");
		SendDlgItemMessage(hDlg, IDC_LIFONT, LB_ADDSTRING, 0, (LPARAM)L"");
		SendDlgItemMessage(hDlg, IDC_LIFONT, LB_ADDSTRING, 0, (LPARAM)L"ü");
		SendDlgItemMessage(hDlg, IDC_LIFONT, LB_ADDSTRING, 0, (LPARAM)L" ");

		if (lstrcmp(pMemo->fontFace, L"") == 0) SendDlgItemMessage(hDlg, IDC_LIFONT, LB_SETCURSEL, 0, 0);
		if (lstrcmp(pMemo->fontFace, L"") == 0) SendDlgItemMessage(hDlg, IDC_LIFONT, LB_SETCURSEL, 1, 0);
		if (lstrcmp(pMemo->fontFace, L"ü") == 0) SendDlgItemMessage(hDlg, IDC_LIFONT, LB_SETCURSEL, 2, 0);
		if (lstrcmp(pMemo->fontFace, L" ") == 0) SendDlgItemMessage(hDlg, IDC_LIFONT, LB_SETCURSEL, 3, 0);

		SendDlgItemMessage(hDlg, IDC_SPINFONTSIZE, UDM_SETRANGE, 0, MAKELPARAM(64, 8));
		SetDlgItemInt(hDlg, IDC_EDFONTSIZE, pMemo->fontSize, FALSE);

		// ŭ ޺ ڽ ä   Ѵ. ǥ  ̸ 0 Ѵ.
		idx = 0;
		for (int i = 0; i < Count(arMemoBack); i++) {
			SendDlgItemMessage(hDlg, IDC_CBBACK, CB_ADDSTRING, 0, 0);
			if (pMemo->backColor == arMemoBack[i]) idx = i;
		}
		SendDlgItemMessage(hDlg, IDC_CBBACK, CB_SETCURSEL, idx, 0);

		idx = 0;
		for (int i = 0; i < Count(arMemoFore); i++) {
			SendDlgItemMessage(hDlg, IDC_CBFORE, CB_ADDSTRING, 0, 0);
			if (pMemo->foreColor == arMemoFore[i]) idx = i;
		}
		SendDlgItemMessage(hDlg, IDC_CBFORE, CB_SETCURSEL, idx, 0);

		return TRUE;
	case WM_MEASUREITEM:
		lpmis = (LPMEASUREITEMSTRUCT)lParam;
		lpmis->itemHeight = 18;
		return TRUE;
	case WM_DRAWITEM:
		if (wParam == IDC_CBFORE) {
			arColor = arMemoFore;
		} else if (wParam == IDC_CBBACK) {
			arColor = arMemoBack;
		}
		lpdis = (LPDRAWITEMSTRUCT)lParam;

		//   ׸
		if (lpdis->itemState & ODS_SELECTED) {
			bkBrush = CreateSolidBrush(RGB(0, 0, 255));
		} else {
			bkBrush = CreateSolidBrush(RGB(255, 255, 255));
		}
		FillRect(lpdis->hDC, &lpdis->rcItem, bkBrush);
		DeleteObject(bkBrush);

		//  ׸
		Brush = CreateSolidBrush(arColor[lpdis->itemID]);
		OldBrush = (HBRUSH)SelectObject(lpdis->hDC, Brush);
		Rectangle(lpdis->hDC, lpdis->rcItem.left + 2, lpdis->rcItem.top + 1,
			lpdis->rcItem.right - 2, lpdis->rcItem.bottom - 1);
		SelectObject(lpdis->hDC, OldBrush);
		DeleteObject(Brush);
		return TRUE;
		break;
	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDOK:
			GetDlgItemText(hDlg, IDC_EDTITLE, pMemo->title, Count(pMemo->title));

			idx = SendDlgItemMessage(hDlg, IDC_LIFONT, LB_GETCURSEL, 0, 0);
			if (idx == 0) lstrcpy(pMemo->fontFace, L"");
			if (idx == 1) lstrcpy(pMemo->fontFace, L"");
			if (idx == 2) lstrcpy(pMemo->fontFace, L"ü");
			if (idx == 3) lstrcpy(pMemo->fontFace, L" ");

			pMemo->fontSize = GetDlgItemInt(hDlg, IDC_EDFONTSIZE, NULL, FALSE);
			pMemo->isModi = true;
			EndDialog(hDlg, IDOK);
			return TRUE;
		case IDCANCEL:
			EndDialog(hDlg, IDCANCEL);
			return TRUE;
		case IDC_CBFORE:
		case IDC_CBBACK:
			switch (HIWORD(wParam)) {
			case CBN_SELCHANGE:
				idx = SendDlgItemMessage(hDlg, LOWORD(wParam), CB_GETCURSEL, 0, 0);
				if (LOWORD(wParam) == IDC_CBFORE) {
					pMemo->foreColor = arMemoFore[idx];
				} else {
					pMemo->backColor = arMemoBack[idx];
				}
				break;
			}
			return TRUE;
		}
		break;
	}
	return FALSE;
}

LRESULT CMemoViewer::OnCommand(WPARAM wParam, LPARAM lParam)
{
	switch (LOWORD(wParam)) {
	case MV_CLOSE:
		DestroyWindow(win_hWnd);
		break;
	case MV_ATTR:
		if (DialogBoxParam(g_hInst, MAKEINTRESOURCE(IDD_MEMO), win_hWnd, MemoDlgProc, (LPARAM)this) == IDOK) {
			DeleteObject(fontEdit);
			fontEdit = CreateFont(pMemo->fontSize, 0, 0, 0, 0, 0, 0, 0, HANGUL_CHARSET, 3, 2, 1,
				VARIABLE_PITCH | FF_MODERN, pMemo->fontFace);
			SendMessage(hEdit, WM_SETFONT, (WPARAM)fontEdit, MAKELPARAM(FALSE, 0));
			DeleteObject(backBrush);
			backBrush = CreateSolidBrush(pMemo->backColor);

			//  ٲ   ޺ ڿ ٲٰ  ŸƲ ٵ ٲ۴. 
			TCHAR tTitle[64];
			SendMessage(pMemoWidget->hCombo, CB_GETLBTEXT, nowIdx, (LPARAM)tTitle);
			if (lstrcmp(pMemo->title, tTitle) != 0) {
				// ޺ ׸ ڿ  ٲٴ    .      
				//     ã  
				int oldIdx = SendMessage(pMemoWidget->hCombo, CB_GETCURSEL, 0, 0);
				SendMessage(pMemoWidget->hCombo, CB_DELETESTRING, nowIdx, 0);
				SendMessage(pMemoWidget->hCombo, CB_INSERTSTRING, nowIdx, (LPARAM)pMemo->title);
				SendMessage(pMemoWidget->hCombo, CB_SETCURSEL, oldIdx, 0);
				//  ŸƲ ٵ ٽ ׸. 
				InvalidateRect(win_hWnd, NULL, TRUE);
			}
		}
		break;
	case MV_EDIT:
		switch (HIWORD(wParam)) {
		case EN_CHANGE:
			isModi = true;
			break;
		// Ŀ    Ѵ.   ڵ ȴ. 
		case EN_KILLFOCUS:
			SendMemoToWidget();
			return 0;
		}
		break;
	}

	return 0;
}

void CMemoViewer::RefreshMemo()
{
	SetWindowText(hEdit, pMemo->content);
}


