//  Ŭ. ٸ    .
class CWidget : public CDget
{
public:
	CWidget(LPCTSTR name, LPCTSTR id) :CDget(name, id) { ; }
};

class CClock : public CWidget
{
public:
	int faceType;
	bool hour24;
	bool outSec;
	bool digit2;
	int month, day;
	TCHAR yoil[16];
	int hour, min, sec;
	CClock(LPCTSTR name, LPCTSTR id) : CWidget(name, id) { ; }

	// ª ޽ ζ óѴ.
	LRESULT OnCreate(WPARAM wParam, LPARAM lParam) {
		//  о´.  ü ʱȭ Ŀ о ϹǷ ڿ   . 
		LoadSetting();

		SetTimer(win_hWnd, 1, 1000, NULL);
		SendMessage(win_hWnd, WM_TIMER, 1, NULL);
		return 0;
	}

	LRESULT OnDestroy(WPARAM wParam, LPARAM lParam) {
		KillTimer(win_hWnd, 1);
		return 0;
	}

	//  ޼ ܺ Լ Ѵ. OnDraw  Լ ϸ ܺο Ѵ. 
	void LoadSetting();
	void SaveSetting();
	LRESULT OnTimer(WPARAM wParam, LPARAM lParam);
	LRESULT OnContextMenu(WPARAM wParam, LPARAM lParam);
	void OnDraw(HDC hdc, RECT crt);
};

class CCpuUsage : public CWidget
{
public:
	static const int USAGE_NUM = 60;
	int arUsage[USAGE_NUM];
	PDH_HQUERY cpuQuery;
	PDH_HCOUNTER cpuTotal;
	int timerInterval;
	bool varYAxis;
	bool viewThread;

	CCpuUsage(LPCTSTR name, LPCTSTR id) : CWidget(name, id) { ; }

	LRESULT OnCreate(WPARAM wParam, LPARAM lParam) {
		timerInterval = 5;
		varYAxis = true;
		viewThread = false;
		SetTimer(win_hWnd, 1, timerInterval * 1000, NULL);
		PdhOpenQuery(NULL, NULL, &cpuQuery);
		PdhAddCounter(cpuQuery, TEXT("\\Processor(_Total)\\% Processor Time"), NULL, &cpuTotal);
		PdhCollectQueryData(cpuQuery);

		memset(arUsage, 0, sizeof(arUsage));
		return 0;
	}

	LRESULT OnDestroy(WPARAM wParam, LPARAM lParam) {
		KillTimer(win_hWnd, 1);
		return 0;
	}

	LRESULT OnTimer(WPARAM wParam, LPARAM lParam);
	LRESULT OnContextMenu(WPARAM wParam, LPARAM lParam);
	void OnDraw(HDC hdc, RECT crt);
};

class CMemUsage : public CWidget
{
public:
	int timerInterval;
	MEMORYSTATUSEX mem;

	CMemUsage(LPCTSTR name, LPCTSTR id) : CWidget(name, id) { ; }

	LRESULT OnCreate(WPARAM wParam, LPARAM lParam) {
		timerInterval = 10;
		SetTimer(win_hWnd, 1, timerInterval * 1000, NULL);
		SendMessage(win_hWnd, WM_TIMER, 1, 0);
		return 0;
	}

	LRESULT OnDestroy(WPARAM wParam, LPARAM lParam) {
		KillTimer(win_hWnd, 1);
		return 0;
	}

	LRESULT OnTimer(WPARAM wParam, LPARAM lParam);
	void OnDraw(HDC hdc, RECT crt);
};

class CDiskUsage : public CWidget
{
public:
	struct DiskInfo
	{
		TCHAR drive;
		ULARGE_INTEGER Avail, Total, Free;
	};

	int timerInterval;
	DiskInfo arDisk[26];
	bool includeRemovable;
	bool includeNetwork;
	bool relativeChart;

	CDiskUsage(LPCTSTR name, LPCTSTR id) : CWidget(name, id) { ; }

	LRESULT OnCreate(WPARAM wParam, LPARAM lParam) {
		timerInterval = 60;
		includeRemovable = true;
		includeNetwork = false;
		relativeChart = true;
		SetTimer(win_hWnd, 1, timerInterval * 1000, NULL);
		SendMessage(win_hWnd, WM_TIMER, 1, 0);
		return 0;
	}

	LRESULT OnDestroy(WPARAM wParam, LPARAM lParam) {
		KillTimer(win_hWnd, 1);
		return 0;
	}

	LRESULT OnTimer(WPARAM wParam, LPARAM lParam);
	LRESULT OnContextMenu(WPARAM wParam, LPARAM lParam);
	void OnDraw(HDC hdc, RECT crt);
};

class CBattery : public CWidget
{
public:
	HWND hStMem;
	SYSTEM_POWER_STATUS sps;

	CBattery(LPCTSTR name, LPCTSTR id) : CWidget(name, id) { ; }

	LRESULT OnCreate(WPARAM wParam, LPARAM lParam) {
		SetTimer(win_hWnd, 1, 10000, NULL);
		SendMessage(win_hWnd, WM_TIMER, 1, 0);
		return 0;
	}

	LRESULT OnDestroy(WPARAM wParam, LPARAM lParam) {
		KillTimer(win_hWnd, 1);
		return 0;
	}

	LRESULT OnTimer(WPARAM wParam, LPARAM lParam);
	void OnDraw(HDC hdc, RECT crt);
};

class CCalc : public CWidget
{
public:
	HWND hCbExp;
	HWND hEdit;
	HWND hBtnCopy;
	double calcResult;
	TCHAR sResult[128];
	bool autoCopy;
	CCalc(LPCTSTR name, LPCTSTR id) : CWidget(name, id) {
		calcResult = 0;
		lstrcpy(sResult, L"=0");
		autoCopy = false;
	}

	LRESULT OnCreate(WPARAM wParam, LPARAM lParam);
	LRESULT OnSize(WPARAM wParam, LPARAM lParam);
	LRESULT OnCommand(WPARAM wParam, LPARAM lParam);
	void OnDraw(HDC hdc, RECT crt);
	LRESULT OnContextMenu(WPARAM wParam, LPARAM lParam);
	LRESULT OnUser1(WPARAM wParam, LPARAM lParam);
	LRESULT OnUser2(WPARAM wParam, LPARAM lParam);

	void CopyResult();
};

class CRadix : public CWidget
{
public:
	HWND hEdit2;
	HWND hEdit10;
	HWND hEdit16;
	bool editByCode;
	CRadix(LPCTSTR name, LPCTSTR id) : CWidget(name, id) { 
		editByCode = false;
	}

	LRESULT OnCreate(WPARAM wParam, LPARAM lParam);
	LRESULT OnSize(WPARAM wParam, LPARAM lParam);
	LRESULT OnCommand(WPARAM wParam, LPARAM lParam);
	void OnDraw(HDC hdc, RECT crt);
};

class CImageViewer;
class CImageSlide : public CWidget
{
public:
	int timerInterval;
	int nowIdx;
	Image *nowImage;
	TDArray<sImagePath*> arImage;
	bool randomSlide;				//  
	bool displayFileName;			// ϸ ǥ
	bool multiViewer;				// Ŭ    ϳ 
	CImageViewer* pLastViewer;

	CImageSlide(LPCTSTR name, LPCTSTR id) : CWidget(name, id) { 
		pLastViewer = NULL;
		nowImage = NULL;
	}

	LRESULT OnCreate(WPARAM wParam, LPARAM lParam);
	LRESULT OnDestroy(WPARAM wParam, LPARAM lParam);
	void LoadSetting();
	void SaveSetting();
	void LoadImageList();
	void SaveImageList();
	LRESULT OnTimer(WPARAM wParam, LPARAM lParam);
	LRESULT OnContextMenu(WPARAM wParam, LPARAM lParam);
	void OnDraw(HDC hdc, RECT crt);
	LRESULT OnLButtonDown(WPARAM wParam, LPARAM lParam);
	LRESULT OnUser1(WPARAM wParam, LPARAM lParam);
	LRESULT OnDropFiles(WPARAM wParam, LPARAM lParam);
};

class COneImage;
class CImageViewer : public CWindow
{
public:
	int parentType;			//  θ. 0 = ̴, 1 = oneImage
	CDget* pParent;		// θ ü. Ʒ  ̸ ĳ д.
	CImageSlide* pSlide;
	COneImage* pOneImage;
	int nowIdx;						// ̴  ε
	TCHAR imagePath[MAX_PATH];		// OneImage ̹ 
	Image* nowImage;				// Ÿӿ ϴ ̹ ü
	bool fullScreen;
	WINDOWPLACEMENT prevWndPlace;

	CImageViewer() : CWindow() { ; }

	void Create(int parentType, CDget* parent);
	LRESULT OnCreate(WPARAM wParam, LPARAM lParam);
	LRESULT OnDestroy(WPARAM wParam, LPARAM lParam);
	LRESULT OnPaint(WPARAM wParam, LPARAM lParam);
	LRESULT OnSize(WPARAM wParam, LPARAM lParam);
	LRESULT OnKeyDown(WPARAM wParam, LPARAM lParam);
	LRESULT OnLButtonDblClk(WPARAM wParam, LPARAM lParam);
	LRESULT OnUser1(WPARAM wParam, LPARAM lParam);

	void toggleFullScreen();
};

class CMusicPlayer : public CWidget
{
public:
	HWND hPlay, hStop, hPrev, hNext;
	HWND hProg, hList;
	HWND hGroup1, hGroup2, hGroup3, hGroup4;
	HWND hAdd, hClear, hRandom;
	enum { MP_PLAY, MP_STOP, MP_PREV, MP_NEXT, MP_PROG, 
		MP_LIST, MP_GROUP1, MP_GROUP2, MP_GROUP3, MP_GROUP4,
		MP_ADD, MP_CLEAR, MP_RANDOM
	};
	// Ÿ̸ . 1   1ȸ
	enum {
		MPTM_PROG = 1,			// α׷ ſ
		MPTM_PLAYACTIVE,		//  Ŀ   
		MPTM_PLAYNEXT,			//  ׷  
		MPTM_PLAYPREV,			//  ׷  
		MPTM_MOVEPOS,			//   ġ ̵
	};

	TDArray<sImagePath*> arMusic[4];		//  
	int playGroup;				//   ׷
	int playIdx;				//   playGroup 
	int groupIdx[4];			//  ׷ 
	bool randomPlay;			//  
	UINT dev_id;				// MCI ġ. 0̸  ƴ
	TCHAR stripPath[MAX_PATH];	// ID3 ±׸  ӽ  

	CMusicPlayer(LPCTSTR name, LPCTSTR id) : CWidget(name, id) { ; }

	LRESULT OnMessage(UINT iMessage, WPARAM wParam, LPARAM lParam);
	LRESULT OnCreate(WPARAM wParam, LPARAM lParam);
	LRESULT OnDestroy(WPARAM wParam, LPARAM lParam);
	LRESULT OnSize(WPARAM wParam, LPARAM lParam);
	LRESULT OnTimer(WPARAM wParam, LPARAM lParam);
	LRESULT OnContextMenu(WPARAM wParam, LPARAM lParam);
	LRESULT OnDropFiles(WPARAM wParam, LPARAM lParam);
	LRESULT OnCommand(WPARAM wParam, LPARAM lParam);

	void PlayActiveCurrent();
	bool DoPlayCurrent(bool bNext);
	bool DoPlay(LPCTSTR musicPath, int fromPos = 0);
	DWORD GetStatus();
	DWORD GetPosition();
	DWORD GetLength();
	bool AddFile(LPCTSTR Path);
	void LoadMusicList();
	void SaveMusicList();
	void FillListBox(int group);
	void ChangeActiveGroup(int group, bool init = false);
	int GetActiveGroup();
	int SelectRandomPlay();
	bool StripID3Tag(LPCTSTR path);
};

class CMemoViewer;
class CMemo : public CWidget
{
public:
	HWND hCombo, hAdd, hDelete, hView, hEdit;
	enum {
		MEMO_COMBO, MEMO_ADD, MEMO_DELETE, MEMO_VIEW, MEMO_EDIT
	};

	struct sMemo {
		TCHAR title[64];				// 
		int x, y, w, h;					//  ġ, ũ
		COLORREF foreColor, backColor;	// , 
		bool isText;					// ؽƮ Ǵ Ĺ
		TCHAR fontFace[32];				// Ʈ.
		int fontSize;					// Ʈ ũ
		bool wordWrap;					// ڵ  
		TCHAR* content;					// 
		int content_len;				//  
		bool isModi;					//  
		CMemoViewer* pViewer;			//  ü.    NULL
	};

	TDArray<sMemo *> arMemo;	
	int nowIdx;
	bool isModi;				// ޸ ϳ ٲ ִ 

	CMemo(LPCTSTR name, LPCTSTR id) : CWidget(name, id) { ; }

	LRESULT OnCreate(WPARAM wParam, LPARAM lParam);
	LRESULT OnDestroy(WPARAM wParam, LPARAM lParam);
	LRESULT OnSize(WPARAM wParam, LPARAM lParam);
	LRESULT OnCommand(WPARAM wParam, LPARAM lParam);
	LRESULT OnUser1(WPARAM wParam, LPARAM lParam);

	void SaveMemo(int idx);
	void SaveMemo(sMemo* pMemo, HWND hEdit);
	void SaveMemoList();
	void LoadMemoList();
	void GetMemoFilePath(TCHAR* Path);
};

class CMemoViewer : public CWindow
{
public:
	CMemo* pMemoWidget;
	int nowIdx;
	CMemo::sMemo* pMemo;
	bool isModi;
	HWND hClose, hAttr, hEdit;
	enum { MV_CLOSE, MV_ATTR, MV_EDIT };
	HFONT fontEdit;
	HBRUSH backBrush;
	bool destroyBySelf;

	CMemoViewer() : CWindow() {
		destroyBySelf = true;
	}

	void Create(CMemo* pMemoWidget, int idx);
	LRESULT OnMessage(UINT iMessage, WPARAM wParam, LPARAM lParam);
	LRESULT OnCreate(WPARAM wParam, LPARAM lParam);
	LRESULT OnDestroy(WPARAM wParam, LPARAM lParam);
	LRESULT OnSize(WPARAM wParam, LPARAM lParam);
	void OnDraw(HDC hdc, RECT crt);
	LRESULT OnCommand(WPARAM wParam, LPARAM lParam);

	void SendMemoToWidget();
	void RefreshMemo();
};

