#include "pch.h"

CRegisterHelper::CRegisterHelper()
{
	WNDCLASS WndClass;

	WndClass.cbClsExtra = 0;
	WndClass.cbWndExtra = 0;
	// ۸ ⺻ Ǿ  귯ô .
	WndClass.hbrBackground = NULL;
	WndClass.hCursor = LoadCursor(NULL, IDC_ARROW);
	WndClass.hIcon = LoadIcon(NULL, IDI_APPLICATION);
	WndClass.hInstance = GetModuleHandle(NULL);
	//  ν  Ŭ Ǿ ִ. 
	WndClass.lpfnWndProc = (WNDPROC)CWindow::CWindowProc;
	WndClass.lpszClassName = L"CWindow";
	WndClass.lpszMenuName = NULL;
	// Ŭ ⺻ Ѵ.
	WndClass.style = CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS;
	RegisterClass(&WndClass);

	nReg = 0;
	arSize = 100;
	arObj = (_arObj*)malloc(arSize * sizeof(_arObj));
	memset(arObj, 0, arSize * sizeof(_arObj));
}

CRegisterHelper::~CRegisterHelper()
{
	free(arObj);
	arObj = NULL;
}

CWindow* CRegisterHelper::FindObject(HWND hWnd)
{
	int i;

	for (i = 0; i < nReg; i++) {
		if (arObj[i].hWnd == hWnd)
			return arObj[i].pObj;
	}
	return NULL;
}

void CRegisterHelper::AddObject(HWND hWnd, CWindow* pObj)
{
	int i;

	if (nReg == arSize - 1) {
		arSize++;
		arObj = (_arObj*)realloc(arObj, arSize * sizeof(_arObj));
		arObj[arSize - 1].hWnd = NULL;
		arObj[arSize - 1].pObj = NULL;
	}

	for (i = 0;; i++) {
		if (arObj[i].hWnd == NULL)
			break;
	}
	arObj[i].hWnd = hWnd;
	arObj[i].pObj = pObj;
	pObj->win_hWnd = hWnd;
	nReg++;
}

void CRegisterHelper::RemoveObject(HWND hWnd)
{
	int i, j;

	// ü Ž 츦 ı ƾ Ѵ. ü ı   츦  ıؾ Ѵ. 
	// ӹ  ıڴ   ʾ ı WM_DESTROY ó OnMessage Ȯϰ ã Ѵ. 
	// ̿   ̷п ؼ  1.2  21-1-  Ѵ.
	// if (IsWindow(hWnd)) { DestroyWindow(hWnd); }

	for (i = 0; i < nReg; i++) {
		if (arObj[i].hWnd == hWnd)
			break;
	}
	for (j = i + 1; j < arSize; j++) {
		arObj[j - 1].hWnd = arObj[j].hWnd;
		arObj[j - 1].pObj = arObj[j].pObj;
	}
	nReg--;
}

//   ü
CRegisterHelper _RegisterHelper;

// ⺻ ޽ ó ָ ϵ ޽ ڵ鷯 ޴´.   ޽ ϵ尡  óؾ Ѵ.
LRESULT CWindow::OnMessage(UINT iMessage, WPARAM wParam, LPARAM lParam) {
	switch (iMessage)
	{
	case WM_CREATE:
		return OnCreate(wParam, lParam);
	case WM_DESTROY:
		return OnDestroy(wParam, lParam);
	case WM_SIZE:
		return OnSize(wParam, lParam);
	case WM_PAINT:
		return OnPaint(wParam, lParam);
	case WM_TIMER:
		return OnTimer(wParam, lParam);
	case WM_COMMAND:
		return OnCommand(wParam, lParam);
	case WM_CONTEXTMENU:
		return OnContextMenu(wParam, lParam);
	case WM_KEYDOWN:
		return OnKeyDown(wParam, lParam);
	case WM_LBUTTONDOWN:
		return OnLButtonDown(wParam, lParam);
	case WM_MOUSEMOVE:
		return OnMouseMove(wParam, lParam);
	case WM_LBUTTONUP:
		return OnLButtonUp(wParam, lParam);
	case WM_LBUTTONDBLCLK:
		return OnLButtonDblClk(wParam, lParam);
	case WM_MOUSEWHEEL:
		return OnMouseWheel(wParam, lParam);
	case WM_USER + 1:
		return OnUser1(wParam, lParam);
	case WM_USER + 2:
		return OnUser2(wParam, lParam);
	case WM_DROPFILES:
		return OnDropFiles(wParam, lParam);
	}
	return(DefWindowProc(win_hWnd, iMessage, wParam, lParam));
}

LRESULT CWindow::OnPaint(WPARAM wParam, LPARAM lParam)
{
	HDC hdc;
	PAINTSTRUCT ps;
	HDC hMemDC;
	HBITMAP oldBit;

	RECT crt;
	GetClientRect(win_hWnd, &crt);
	hdc = BeginPaint(win_hWnd, &ps);
	if (win_dblBuffer == NULL) {
		win_dblBuffer = CreateCompatibleBitmap(hdc, crt.right, crt.bottom);
	}
	hMemDC = CreateCompatibleDC(hdc);
	oldBit = (HBITMAP)SelectObject(hMemDC, win_dblBuffer);
	FillRect(hMemDC, &crt, win_backBrush);

	// ϵ忡 ޸ DC Ͽ Ѵ. 
	OnDraw(hMemDC, crt);

	SelectObject(hMemDC, oldBit);
	DeleteDC(hMemDC);
	DrawBitmap(hdc, 0, 0, win_dblBuffer);
	EndPaint(win_hWnd, &ps);
	return 0;
}

// ũⰡ ٲ ۸ Ʈ  .
// Ļ Ŭ WM_SIZE ޾  CWindow::OnSize  ȣؾ Ѵ.
LRESULT CWindow::OnSize(WPARAM wParam, LPARAM lParam)
{
	if (win_dblBuffer != NULL) {
		DeleteObject(win_dblBuffer);
		win_dblBuffer = NULL;
	}
	return 0;
}

//   ޽ ν  Լ ϳ ̴. CWindow  Լ Խ״. 
LRESULT CALLBACK CWindow::CWindowProc(HWND hWnd, UINT iMessage, WPARAM wParam, LPARAM lParam)
{
	CWindow* pWin;

	pWin = _RegisterHelper.FindObject(hWnd);
	if (pWin == NULL) {
		// WS_THICKFRAME Ÿ      ̶ lParam MINMAXINFO ü ã  . 
		if (iMessage == WM_GETMINMAXINFO) {
			return DefWindowProc(hWnd, iMessage, wParam, lParam);
		}
		pWin = (CWindow*)((LPCREATESTRUCT)lParam)->lpCreateParams;
		_RegisterHelper.AddObject(hWnd, pWin);
	}

	return pWin->OnMessage(iMessage, wParam, lParam);
}

